Subject: Re: Distinguished names and X509v3 extension OIDs (fwd)
From: Eric Young <[email-masked]>
To: Warwick Ford <[email-masked]>
Cc: "David P. Kemp" <[email-masked]>, [email-masked], [email-masked], [email-masked]
Date: Tue, 1 Apr 1997 12:35:11 +1000 (EST)

On Mon, 31 Mar 1997, Warwick Ford wrote:
> The level of indirection gained through the OCTET STRING overcomes this
> problem.  Intermediate systems are not permitted to change the encoding of
> an extension at the inner level, since it is mandated to always be DER.
> And changing the encoding of the octet string itself is not a problem as
> you can always regenerate the DER encoding of an OCTET STRING.

I would definitly agree that the abstraction supplied by the OCTET STRING
is required.  In much the same way a BIT-STRING is used to contain the
'blob' that is a public key, the OCTET STRING holds those objects that
the particular software does not understand.
The X509v3 extensions even go so far as to let you know if it matters that
you can not decode the OCTET-STRING (manditory flag).

eric

Date: Mon, 31 Mar 1997 16:50:51 -0800
To: [email-masked] (David P. Kemp), [email-masked], [email-masked]
From: Warwick Ford <[email-masked]>
Subject: Re: Distinguished names and X509v3 extension OIDs (fwd)
Cc: [email-masked]

We certainly looked first at the more obvious options such as ANY DEFINED
BY and EXTERNAL but were forced to reject them.  I think what you are
saying you would prefer is essentially the ANY DEFINED BY option, i.e., (in
shorthand) SEQUENCE { oid, boolean, ANY DEFINED BY oid }.  (Actually this
would be done using table notation, but most readers probably are more
familiar with ANY DEFINED BY.)

>From recollection, the problem with the ANY DEFINED BY approach is as
follows.  Recall that a certificate is not necessarily transmitted
everywhere encoded in DER.  Some certificate-carrying protocols use
BER-encoding.  This is why a cert using system may need to regenerate the
DER encoding of the cert when verifying the signature.  Recall also that
intermediate systems through which a cert traverses may decode and recode
certs differently (e.g., if BER is in use, a system may re-encode a cert
with a different BER encoding than that in which it was received).  In the
case of an extension, such a change of encoding might occur in any system
that recognizes the extension OID and the corresponding ASN.1 type for the
extension value.

Now, when it comes to validating a cert, note that certs that contain
unrecognized extensions may still be perfectly valid and usable (provided
every unrecognized extension is flagged noncritical).  But, if it is
possible for the bit-representation of an unrecognized extension to have
changed in transit, how can the cert-using system generate the required
canonical encoding to verify the cert's signature?

The level of indirection gained through the OCTET STRING overcomes this
problem.  Intermediate systems are not permitted to change the encoding of
an extension at the inner level, since it is mandated to always be DER.
And changing the encoding of the octet string itself is not a problem as
you can always regenerate the DER encoding of an OCTET STRING.

Hope this helps,
Warwick (Ford)

At 09:53 AM 3/31/97 -0500, David P. Kemp wrote:
>The fact that extensions are octet strings is not SSLeay's fault. It
>was, IMHO, a faulty decision by the designers of X.509 v3.  It's
>probably too late to correct this decision now - lots of people
>have already written code to handle v3 certs with octet string extensions.
>But it would have been smarter for the extension contents to be the
>DER data directly, not an octet string containing DER data.  (Octet
>string would be a legitimate content type for some extensions, such
>as keys, hash values, or opaque non-ASN.1 objects such as Microsoft
>Word documents :-).
>
>John Larmouth (http://www.salford.ac.uk/iti/books/osi/chap8.html)
>has this to say about the "OCTETSTRING hole":
>
>  "... the application designer specifies a field as an ASN.1 octet
>  string for the purposes of defining his/her own abstract syntax,
>  then proceeds to populate the field with the encoding of an ASN.1
>  type ...  Use of this mechanism cannot be prevented by the Presentation
>  Layer or by ASN.1 (although text in the 1992 DIS deprecates this use of
>  OCTETSTRING), but clearly does not fit in any way with the spirit
>  of the presentation layer.   ...  The reader is ... asked to
>  avoid introducing such holes in any designs he/she becomes responsible
>  for!"
>
>
>X.509 designers, is there any chance of fixing the certificateExtension
>definition in the 1997 spec?

---------------------------------------------------------------------
Warwick Ford, VeriSign, Inc., One Alewife Center, Cambridge, MA 02140
   [email-masked]; Tel: (617)492 2816 x225; Fax: (617)661 0716
---------------------------------------------------------------------

Date: Mon, 31 Mar 1997 10:22:53 -0500
From: "Lusk, Steve" <[email-masked]>
Subject: RE: OIDs
To: "[email-masked]'" <[email-masked]>
Cc: "[email-masked]'" <[email-masked]>

I believe this question is appropriate for SSL talk. Flame me if it's
not. ;-)
I also cc:'ed the ietf group because I thought people would be
interested. 

With the newly defined X.509 extensions, I was wondering which products
(and in which releases) the following extensions would be supported for
SSL.

When I say supported, I don't mean they won't crash when they encounter
them, rather the product will use the information in the extension to do
some further processing, e.g., if the mime type indicates a CA cert,
does the Basic Constraints extension have to be set to CA? And which
Basic Constraints extension will it look for?

>#define ID_CE_1 "{ 2 5 29 1 }" /* authorityKeyIdentifier     */
>#define ID_CE_2 "{ 2 5 29 2 }" /* keyAttributes              */
>#define ID_CE_3 "{ 2 5 29 3 }" /* certificatePolicies        */
>#define ID_CE_4 "{ 2 5 29 4 }" /* keyUsageRestriction        */
>#define ID_CE_5 "{ 2 5 29 5 }" /* policyMapping              */
>#define ID_CE_6  "{ 2 5 29 6 }" /* subtreesConstraint        */
>#define ID_CE_7 "{ 2 5 29 7 }" /* subjectAltName             */
>#define ID_CE_8 "{ 2 5 29 8 }" /* issuerAltName              */
>#define ID_CE_9 "{ 2 5 29 9 }" /* subjectDirectoryAttributes */
>#define ID_CE_10 "{ 2 5 29 10 }" /* basicConstraints  x.509  */
>#define ID_CE_11 "{ 2 5 29 11 }" /* nameConstraints          */
>#define ID_CE_12 "{ 2 5 29 12 }" /* policyConstraints        */
>#define ID_CE_13 "{ 2 5 29 13 }" /* basicConstraints  9.55   */
>
>/* The following are the latest X.509 extensions */
>#define ID_CE_14  "{ 2 5 29 14 }" /* subjectKeyIdentifier     */
>#define ID_CE_15  "{ 2 5 29 15 }" /* keyUsage                 */
>#define ID_CE_16  "{ 2 5 29 16 }" /* privateKeyUsagePeriod    */
>#define ID_CE_17  "{ 2 5 29 17 }" /* subjectAltName           */
>#define ID_CE_18  "{ 2 5 29 18 }" /* issuerAltName            */
>#define ID_CE_19  "{ 2 5 29 19 }" /* basicConstraints         */
>#define ID_CE_20  "{ 2 5 29 20 }" /* cRLNumber    	      */
>#define ID_CE_21  "{ 2 5 29 21 }" /* cRLReason		      */
>#define ID_CE_31  "{ 2 5 29 31 }" /* cRLDistPoints            */
>#define ID_CE_32  "{ 2 5 29 32 }" /* certificatePolicies      */
>#define ID_CE_35  "{ 2 5 29 35 }" /* authorityKeyIdentifier   */
>
>
>Also, how widely accepted are the Netscape extensions. I know of at least one
>product that does not support them.
>
>#define ID_NET_1 "{ 2 16 840 1 113730 1 1 }" /* NetscapeCertType */
>#define ID_NET_2 "{ 2 16 840 1 113730 1 2 }" /* NetscapeBaseUrl */
>#define ID_NET_3 "{ 2 16 840 1 113730 1 3 }" /* NetscapeRevocationUrl */
>#define ID_NET_4 "{ 2 16 840 1 113730 1 4 }" /* NetscapeCaRevocationUrl */
>#define ID_NET_7 "{ 2 16 840 1 113730 1 7 }" /* NetscapeCertRenewalUrl */
>#define ID_NET_8 "{ 2 16 840 1 113730 1 8 }" /* NetscapeCaPolicyUrl */
>#define ID_NET_12 "{ 2 16 840 1 113730 1 12 }" /* NetscapeSSLServerName */
>#define ID_NET_13 "{ 2 16 840 1 113730 1 13 }" /* NetscapeComment */
>

Date: Mon, 31 Mar 1997 09:53:31 -0500
From: [email-masked] (David P. Kemp)
To: [email-masked], [email-masked]
Subject: Re: Distinguished names and X509v3 extension OIDs (fwd)
Cc: [email-masked]

PKIX and X.509 folks,

  The following thread originated on the ssl-users list, but I believe
the issues of DN design and certificate extension format are appropriate
for this audience.

> From [email-masked] Fri Mar 28 12:52:19 1997
> 
> >So, it is perfectly legal to have serialNumber in the DN? (You use the
> >word "should" not "would" in the above sentence :-) I would be
> >quite happy with
> >
> >/C=SI/O=Razvojni center IRC d.o.o./OU=Sistem/CN=Warwick Heath/SN=1234567890123
> >
> >if it does not violate anything. Is it the case that every OID starting with
> >2.5.4.* can go into a DN? For example I would not mind having street 
> >address/phone number etc etc in my certs. Any problems with this (assuming
> >the appropriate objects are added to ssleay)? I ask because the certs
> >that I see always have the basic minimum of info in them - yet a certificate is
> >most useful when it contains contact information for a person (for example). 
> >
> >(To my mind a DN is used to traverse the DIT, however a lot of OIDs 
> >under 2.5.4.* seem to describe attributes of a leaf of the DIT, rather then 
> >be part of the DIT. Is it really the case that all AVAs in the subject's 
> >DN are used in traversing the DIT?)

(Nit: a DN is a sequence of AT&Vs, not a sequence of AVAs.)

> >As far as I see, using SN would only require minor changes to ssleay.
> >This would be great.

International Standards, being designed by committees, usually take
great pains to be so general that very little violates them :-).

Hoyt has posted drafts of the 1997 versions of the X.500 series at
ftp.bull.com.  I haven't had time to look at them yet, but the comment
in the AttributeTypeAndValue definition in the 1993 version of X.501
Annex B implies that the definition of SupportedAttributes does not
exist in X.5xx, and will be profiled by and for specific communities
(banking/finance, Internet/IETF, etc).

I read that to mean that in the absense of a specific profile, *any*
attribute (not just any under 2.5.4) is a legal component of a DN
according to X.501.

That said, it is good practice for a certificate to contain the
absolute minimum of information required to accomplish it's purpose,
which is to provide a secure binding between a public key and an
entity.  If your definition of an "entity" does not include a street
address as a fundamental, essential element of it's identity, then
the street address should not be included in the DN in a certificate,
or for that matter, in an extension.

The street address is a changeable attribute that belongs in the
directory, not in a certificate.  But the SerialNumber in your example
is not just some useful information about an entity, it is an essential
component of an identity (it distinguishes between two different
physical people that may happen to have the same Common Name).  So it
belongs in the DN.

> >One person mailed to me the location of a copy of X500v3 online. 
> >Another emailed the location of a database of lots of OIDs.

Could you forward me, or better, post the location of the OID database?

> > So after
> >looking at X509, x520 and the database I now have an idea of the 
> >v3 extensions available. The problem is, is that ssleay's support 
> >for v3 extensions is minimal, any extension is treated simply as 
> >an octet string. Adding support for subjectAltName would take me
> >some time, especially as it's not a simple ASN.1 type. I would
> >like to avoid this route.

The fact that extensions are octet strings is not SSLeay's fault. It
was, IMHO, a faulty decision by the designers of X.509 v3.  It's
probably too late to correct this decision now - lots of people
have already written code to handle v3 certs with octet string extensions.
But it would have been smarter for the extension contents to be the
DER data directly, not an octet string containing DER data.  (Octet
string would be a legitimate content type for some extensions, such
as keys, hash values, or opaque non-ASN.1 objects such as Microsoft
Word documents :-).

John Larmouth (http://www.salford.ac.uk/iti/books/osi/chap8.html)
has this to say about the "OCTETSTRING hole":

  "... the application designer specifies a field as an ASN.1 octet
  string for the purposes of defining his/her own abstract syntax,
  then proceeds to populate the field with the encoding of an ASN.1
  type ...  Use of this mechanism cannot be prevented by the Presentation
  Layer or by ASN.1 (although text in the 1992 DIS deprecates this use of
  OCTETSTRING), but clearly does not fit in any way with the spirit
  of the presentation layer.   ...  The reader is ... asked to
  avoid introducing such holes in any designs he/she becomes responsible
  for!"

X.509 designers, is there any chance of fixing the certificateExtension
definition in the 1997 spec?

     Dave Kemp
     speaking as an individual

Date: Fri, 28 Mar 1997 16:00:37 -0800
To: [email-masked]
From: Warwick Ford <[email-masked]>
Subject: PKIX Part 4 I-D

We have issued a revised version of the Certificate Policy/Practices
Framework that was previously distributed and discussed at the San Jose
meeting.  This new revision has attempted to take into account feedback
from the San Jose meeting and from several individuals.

The main changes are:

- Reduce the volume of material in a major way.  This has largely involved
removing redundant material, and organizing the document better.
- Improve the explanatory material and definitions.
- Some technical changes in the light of feedback from an effort by the
Canadian Govt. to use the framework in writing real certificate policies.
- Align the material better with the ABA's work.

We have titled this document as a draft of PKIX Part 4, and suggested that
the final disposition of this work be an Informational RFC.  Such matters
are, of course, fully open for debate by the PKIX group.  We can discuss at
the Memphis meeting.

Warwick

> A New Internet-Draft is available from the on-line Internet-Drafts 
> directories. This draft is a work item of the Public-Key Infrastructure 
> (X.509) Working Group of the IETF.                                        
>
>       Title     : Internet Public Key Infrastructure  Part IV: Certificate
>                   Policy and Certification Practices Framework            
>       Author(s) : S. Chokhani, W. Ford
>       Filename  : draft-ietf-pkix-ipki-part4-00.txt
>       Pages     : 42
>       Date      : 03/26/1997
>
>This document presents a framework to assist the writers of certificate 
>policies or certification practice statements for certification authorities
>and public key infrastructures.   In particular, the framework provides a 
>comprehensive list of topics that potentially (at the writer's discretion) 
>need to be covered in a certificate policy definition or a certification 
>practice statement. It is intended that this document, when fully 
>developed, be published as an Informational RFC.                           
>
>Internet-Drafts are available by anonymous FTP.  Login with the username
>"anonymous" and a password of your e-mail address.  After logging in,
>type "cd internet-drafts" and then
>     "get draft-ietf-pkix-ipki-part4-00.txt".
>A URL for the Internet-Draft is:
>ftp://ds.internic.net/internet-drafts/draft-ietf-pkix-ipki-part4-00.txt
> 
>Internet-Drafts directories are located at:	
>	                                                
>     o  Africa:  ftp.is.co.za                    
>	                                                
>     o  Europe:  ftp.nordu.net            	
>                 ftp.nis.garr.it                 
>	                                                
>     o  Pacific Rim: munnari.oz.au               
>	                                                
>     o  US East Coast: ds.internic.net           
>	                                                
>     o  US West Coast: ftp.isi.edu               
>	                                                
>Internet-Drafts are also available by mail.	
>	                                                
>Send a message to:  [email-masked]. In the body type: 
>     "FILE /internet-drafts/draft-ietf-pkix-ipki-part4-00.txt".
>							
>NOTE: The mail server at ds.internic.net can return the document in
>      MIME-encoded form by using the "mpack" utility.  To use this
>      feature, insert the command "ENCODING mime" before the "FILE"
>      command.  To decode the response(s), you will need "munpack" or
>      a MIME-compliant mail reader.  Different MIME-compliant mail readers
>      exhibit different behavior, especially when dealing with
>      "multipart" MIME messages (i.e., documents which have been split
>      up into multiple messages), so check your local documentation on
>      how to manipulate these messages.
>							
>							
>
>Below is the data which will enable a MIME compliant mail reader 
>implementation to automatically retrieve the ASCII version
>of the Internet-Draft.
>
><ftp://ds.internic.net/internet-drafts/draft-ietf-pkix-ipki-part4-00.txt>
>
---------------------------------------------------------------------
Warwick Ford, VeriSign, Inc., One Alewife Center, Cambridge, MA 02140
   [email-masked]; Tel: (617)492 2816 x225; Fax: (617)661 0716
---------------------------------------------------------------------

To: IETF-Announce:;@tandem.com
cc: [email-masked]
From: [email-masked]
Reply-to: [email-masked]
Subject: I-D ACTION:draft-ietf-pkix-ipki-part1-04.txt
Date: Fri, 28 Mar 1997 09:58:04 -0500
Sender: [email-masked]

--NextPart

 A Revised Internet-Draft is available from the on-line Internet-Drafts 
 directories. This draft is a work item of the Public-Key Infrastructure 
 (X.509) Working Group of the IETF.                                        

       Title     : Internet Public Key Infrastructure   Part I:  X.509 
                   Certificate and CRL Profile                             
       Author(s) : R. Housley, W. Ford, T. Polk, D. Solo
       Filename  : draft-ietf-pkix-ipki-part1-04.txt
       Pages     : 75
       Date      : 03/26/1997

This is the fourth draft of the Internet Public Key Infrastructure X.509 
Certificate and CRL Profile.  This draft is a complete specification; text 
is provided for all previously open sections.  Modifications and 
enhancements which appear in this draft include a reduced set of private 
extensions, conformance requirements for CAs and clients, and examples of a
certificate and a CRL. This draft also features specific semantics for 
alternative name extensions and clarifies the syntax of date fields.  
Please send comments on this document to the [email-masked] 
mail list.                                                                      

Internet-Drafts are available by anonymous FTP.  Login with the username
"anonymous" and a password of your e-mail address.  After logging in,
type "cd internet-drafts" and then
     "get draft-ietf-pkix-ipki-part1-04.txt".
A URL for the Internet-Draft is:
ftp://ds.internic.net/internet-drafts/draft-ietf-pkix-ipki-part1-04.txt
 
Internet-Drafts directories are located at:	
	                                                
     o  Africa:  ftp.is.co.za                    
	                                                
     o  Europe:  ftp.nordu.net            	
                 ftp.nis.garr.it                 
	                                                
     o  Pacific Rim: munnari.oz.au               
	                                                
     o  US East Coast: ds.internic.net           
	                                                
     o  US West Coast: ftp.isi.edu               
	                                                
Internet-Drafts are also available by mail.	
	                                                
Send a message to:  [email-masked]. In the body type: 
     "FILE /internet-drafts/draft-ietf-pkix-ipki-part1-04.txt".
							
NOTE: The mail server at ds.internic.net can return the document in
      MIME-encoded form by using the "mpack" utility.  To use this
      feature, insert the command "ENCODING mime" before the "FILE"
      command.  To decode the response(s), you will need "munpack" or
      a MIME-compliant mail reader.  Different MIME-compliant mail readers
      exhibit different behavior, especially when dealing with
      "multipart" MIME messages (i.e., documents which have been split
      up into multiple messages), so check your local documentation on
      how to manipulate these messages.

Below is the data which will enable a MIME compliant mail reader 
implementation to automatically retrieve the ASCII version
of the Internet-Draft.

--NextPart
Content-Type: Multipart/Alternative; Boundary="OtherAccess"

--OtherAccess
Content-Type:  Message/External-body;
        access-type="mail-server";
        server="[email-masked]"

Content-Type: text/plain
Content-ID: <[email-masked]>

ENCODING mime
FILE /internet-drafts/draft-ietf-pkix-ipki-part1-04.txt

--OtherAccess
Content-Type:   Message/External-body;
        name="draft-ietf-pkix-ipki-part1-04.txt";
        site="ds.internic.net";
        access-type="anon-ftp";
        directory="internet-drafts"

Content-Type: text/plain
Content-ID: <[email-masked]>

--OtherAccess--

--NextPart--

Date: Thu, 27 Mar 1997 13:39:48 -0800
To: [email-masked]
From: Peter Williams <[email-masked]>
Subject: PKIX 4 - ID

Speaking as a mailing list independent, individual reviewer, the
way I have done for the last 5 years, and not having seen the
material before publication, I comment to the authors,
and (mainly) to the list members:

Its highly useful, when seeking to understand the notions,
relations and repercussions of PKIX IV ID on the Internet, to
compare and contrasts this version with the  previous version
of the material from the authors and their sponsors.

Between the document versions there is significant semantic & procedural
shift which can, subjectively, give one understanding of the motivations
for the shifts. I suggest to other reviewers, that its useful to compare
some of the design with sources of material addressing those same basic
ideas which may have been taken up from those other forums. I 
can supply pointers, privately.

It does requires a very sophisticated reader, however,
to understand this material per se, and forsee its likely impacts,
and grasp the type of accreditation dominated world its adoption
would enable over the Internet; a return to pre-1770s US culture, in
some senses!

It disturbs me, as an thoughtful Internet individual (Ive
never not known the Internet, or knowingly used a closed data
network) that the mind set seems to expect trusted software
implementation to be effectively present in the Internet, at
all layers.

Looking at the history of software and network capability
adoption in corporations, general purpose business is 
more likely to adopt the "general-purpose" assurance regime, for 
the majority of its commercial functions, providing
it can control the financial risks though mainly
administrative  of contractual procedures, and that the auditable
integrity-enabling technology is dirt-cheap and effective 99.8%
of the time. This in complete contrast to military deployment
philosophies who tend to rely on technical countermeasures
to a far greater degree, for confidentiality or
hierarchical command-and-control purposes, and have
only the same operational quality rate, in any case.

Tight, controlled, business functions which does require
"commercial-grade" solutions will have to decide which
is more cost effective to their limited purposes as
characterized by high-end security objectives, requiring
high grade controls: a one-off proprietary solution between
the few peers, or else tailored specialization of a type-I
like PKI management culture, and PKI system component.

Type I like business needs are often characterized
by highly static distribution and interworking networks. 
How does one commercially compete with
a savvy buyer simply going and buying 100 Racal
Datacryptors, or Motorola NES Lans, for a world-wide
interchange/trading network? Its cheap, its effective, and solves
the problem with little hassle in comparison
with an alternative, far more poorly understood and
hardly massively deployed PKI management techniques. See
what SWIFT did, in this regard, and at what
cost and relative assurance. At the medium end, PPTP
and RC4 encryption comes free with NT4 to make
static VPNs galore.

For the general-purpose internet, including
business/civil functions conducted with the general
public, I really struggle to buy into
the technology deployment assumptions which
seem to underpin the policy (vs CPS) enforcement framework, based
on known cost and difficulty, the availability
of alternatives, and a rather limited market
willing to pay for it all.

Don't get me wrong, I work for a PKI management service
company as interested in high end customers, as low! One just
has to realise HERE its the *Internet* infrastructure culture and
businesses willing to use open networks instead of fax channel
that we are dealing with here, on the whole, not a high-end
tailored network environment.

In traditional Peter style, I could bitch about the documents
technical internal coherency in relation to the portions related
to enforcement design, but its probably not particularly worthwhile 
to the IETF process given the material is intended to be
Informational RFC.

I would be interested in the authors' statement on the degree
to which the framework is, or is intended to be harmonised with
the a big-picture view characterised by the APKI I-D. Its also
useful for reviewers to compare the PKIX 4 ID with
that document to gain perspective and understanding
of the content.

Its certainly well worth reading, and understanding,
to gain a glimpse of one view of the big picture.

Peter.

From: [email-masked] (Peter Gutmann)
To: [email-masked], [email-masked]
Subject: Re: sample code - parsing X.509 certificate with LDAP routines
Sender: [email-masked]
Reply-To: [email-masked]
Date: Fri, 28 Mar 1997 06:01:40 (NZST)

Jochen Keutel <[email-masked]> wrote:
 
>I got a lot of answers - a lot of people seem to be interested in my sample
>code. So I'll attach it here. I'll put it online later.
>
>The sample code "print_certificates.c" opens a file containing a X.509
>certificate and prints it's content to stdout. It's really a sample program
 
In case anyone's interested, I've also got a program which does this (it's 
actually a general-purpose ASN.1 dump program, but it knows about most of the 
OIDs you'll find in a cert and in related objects).  Since it's just a 
debugging tool I threw together, it's not terribly intelligent about 
indefinite-length (BER rather than DER) objects, but should do a fairly good 
job of picking apart ASN.1 things and catching some types of format errors (eg 
fields with the wrong length).  You can get it as
http://www.cs.auckland.ac.nz/~pgut001/dumpasn1.c.
 
Peter.

Date: Thu, 27 Mar 1997 10:43:07 -0500
From: Tim Polk <[email-masked]>
To: [email-masked]
Subject: pkix part 1, draft 4
Content-Length: 171714

Hello all,

I have enclosed a new draft of Part 1.  I believe I submitted it on time,
so it should be an official draft for the Memphis meeting. (That hasn't
been confirmed as of 9AM this morning.) Here is a summary of changes
incorporated:

  #1 The document now specifies that dates before 2050 are represented in
  UTCTime and 2050 or later are represented in GeneralizedTime.  The only
  exception is privateKeyUsagePeriod and invalidityDate, which always use
  GeneralizedTime.  Changes are confined to Sections 4.1.2.5 "Validity" (which
  is referenced in 5.1.2.4 "This Update", and 5.1.2.5 "Next Update".)

  The rationale is that a given date should be encoded in exactly one
  way for each field.  The sliding window was a bad idea.  (It was my idea,
  so I can say that!)
  
  #2 The document uses URIs in the subjectAltName (4.2.1.7) and issuerAltName
  (4.2.1.8) to specify the location of certificates, the distributionPointName
  (4.2.1.13) to specify the location of CRLs, and cPSPointer (4.2.1.5) to
  specify the location of policies.
  
  #3 Two private extensions are defined instead of three. They use URIs to
  specify the location of information (as above). The subjectInfoAccess
  extension (4.2.2.1) specifies the location of additional info about the
  subject. The authorityInfoAcess extension (4.2.2.2) can specify the
  location of on-line validation services and additonal information about
  the issuer.
 
  Neither private extension is critical.

  The authorityInfoAcess extension (4.2.2.2) was critical in the last draft,
  to address the situation where a CA does not publish CRLs. This is not
  necessary. If a system attempts to validate a path, does not process the
  extension, and the CA doesn't publish CRLs, it will fail regardless of
  criticality.

  #4 We obtained a patent statement from Cylink for Hellman-Merkle and
  Diffie-Hellman.

  #5 We added a lot of information to the ASN.1 module in section 9.

  The certificate and CRL were defined in X.509 using EXPLICIT tagging
  and the extensions were defined using IMPLICIT tagging.  Putting
  them into a single module caused a few problems... I fixed them by
  marking the module IMPLICIT and specifying EXPLICIT tags in the
  certificate and CRL structures.

  X.400 addressing structures have been added, including a long list of
  constants for maximum sizes.  (Thanks to Bengt Ackzell for the ASN.1;
  I would never have made the submission deadline if I was typing that
  in!)

  The previous version used an "ANY" kludge for BMPString and UniversalString.
  It turns out that most '88 ASN.1 compilers will handle the construct

	UniversalString ::= [UNIVERSAL 28] IMPLICIT OCTET STRING
  
  which is much more correct.  (Thanks to Brian Korver!)

  The userNotice for policy qualifiers was changed from IA5String to
  VisibleString to coordinate with SET.  VisibleString is the visible
  character subset of IA5String plus space.

  #6 We inserted text describing the KEA key encoding.

  #7 I hacked together an example certificate and an example CRL. No
  guarantees on correctness!  I pulled examples from the certificate
  viewer package, but the examples were flawed. I attempted to fix them,
  but I'm not a good substitute for an ASN.1 compiler.

  #8 We fixed several obsolete or empty references.

  #9 We fixed the author's addresses by adding countries. 
               
Open issues:
  
  #1 We need a Patent Statement for RSA from RSADSI.  I am trying to
  get one, but if anyone knows the right contact please send me mail!
  
  #2 Better examples with a more useful format are required.

  I have obtained some nice software that will allow me to generate
  certificates and CRLs with any values and extensions, so I will
  get to this ASAP.
  
  #3 Some ASN.1 issues may remain. Specifically, the conversion of
  TYPE-IDENTIFIER constructs to the '88 ASN.1 requires review.

  #4 Peter Williams provided detailed comments on the introductory
  material.  Some of his suggestions have been implemented; I intend
  to do a few more, but they didn't make it into this draft.  Peter's
  comments were posted to this list; I will post my response to the
  list as well.  I just haven't had time to write it up yet.

I've attached an ASCII table summarizing the pointers to external information
in the PKIX certificate for this draft. The table does not appear in the
draft. It is intended to assist you as you review draft 4.  I think we
can provide all the information needed to validate a path through the
certificate - can you think of anything I've missed?

Finally, I have appended the March 26 draft.  Please review with an eye
towards the changes. I believe this document is nearly stable; does
anyone see open issues beyond the three I mentioned?

Thanks,

Tim Polk

-------------------attached table--------------------

Summary of "pointers to external information" in Part 1 certificate.
               
|----------------------------------------------------------------------------|
| subjectAltName	|  other certificates with the same subject,         |
|			|  a.k.a key management certificates. URI            |
|			|  specifies scheme and object (object implied       |
|			|  for mailto)                                       |
|----------------------------------------------------------------------------|
| issuerAltName		|  certificates whose subject is the issuer of       |
|			|  this certificate; used to build paths. URI        |
|			|  specifies scheme and object (object implied       |
|			|  for mailto)                                       |
|----------------------------------------------------------------------------|
| distributionPoint	|  current CRL issued by the issuer that would       |
|			|  include this certificate if it is revoked or      |
|			|  on hold. URI specifies scheme and object          |
|			|  (object implied for mailto)                       |
|----------------------------------------------------------------------------|
| cPSPointer		|  pointer to object containing text of              |
|			|  Certificate Practice Statement corresponding      |
|			|  to a policy OID. URI specifies scheme and object  |
|			|  (object implied for mailto)                       |
|----------------------------------------------------------------------------|
| CertStatus		|  pointer to on-line validation service.            |
|			|  Specifies transport protocol and object (object   |
|			|  implied with smtp scheme.) Marked critical if no  |
|			|  CRLs are issued.                                  |
|----------------------------------------------------------------------------|
| SubjectInfoAccess	|  points to additional information about the        |
|			|  subject. The CA does not vouch for the integrity  |
|			|  of this information unless it has signed the      |
|			|  object. It is analagous to the information        |
|			|  returned by "finger subject".                     |
|----------------------------------------------------------------------------|
| AuthorityInfoAccess   |  points to additional information about the issuer.|
|	|---------------|----------------------------------------------------|
|	| authorityInfo |  points to general information about the issuer.   |
|	|               |  URI specifies scheme and object (object implied   |
|	|		|  for mailto)                                       |
|	|---------------|----------------------------------------------------|
|	| certStatus    |  points to an on-line validation service for this  |
|	|               |  issuer. URI specifies scheme and object (object   |
|	|		|  implied for mailto).                              |
|----------------------------------------------------------------------------|
]

-------------------------March 26 PKIX Part 1 draft-------------------------

PKIX Working Group                                   R. Housley (SPYRUS)
Internet Draft                                        W. Ford (Verisign)
                                                          W. Polk (NIST)
                                                           D. Solo (BBN)
expires in six months                                      March 26 1996

                   Internet Public Key Infrastructure

               Part I:  X.509 Certificate and CRL Profile

                  <draft-ietf-pkix-ipki-part1-04.txt>

Status of this Memo

   This document is an Internet-Draft.  Internet-Drafts are working
   documents of the Internet Engineering Task Force (IETF), its areas,
   and its working groups.  Note that other groups may also distribute
   working documents as Internet-Drafts.

   Internet-Drafts are draft documents valid for a maximum of six months
   and may be updated, replaced, or obsoleted by other documents at any
   time.  It is inappropriate to use Internet- Drafts as reference
   material or to cite them other than as "work in progress."

   To learn the current status of any Internet-Draft, please check the
   "1id-abstracts.txt" listing contained in the Internet- Drafts Shadow
   Directories on ftp.is.co.za (Africa), nic.nordu.net (Europe),
   munnari.oz.au Pacific Rim), ds.internic.net (US East Coast), or
   ftp.isi.edu (US West Coast).

Abstract

   This is the fourth draft of the Internet Public Key Infrastructure
   X.509 Certificate and CRL Profile.  This draft is a complete
   specification; text is provided for all previously open sections.
   Modifications and enhancements which appear in this draft include a
   reduced set of private extensions, conformance requirements for CAs
   and clients, and examples of a certificate and a CRL. This draft also
   features specific semantics for alternative name extensions and
   clarifies the syntax of date fields.  Please send comments on this
   document to the [email-masked] mail list.

Housley, Ford, Polk, & Solo                                     [Page 1]

INTERNET DRAFT                                             March 26 1996

1  Executive Summary

   This specification is Part 1 of a four part standard for development
   of a Public Key Infrastructure for the Internet.  This specification
   is a standalone document; implementations of this standard may
   proceed before completion of parts two through four.

   This specification profiles the format and semantics of certificates
   and certificate revocation lists for the Internet PKI.  Procedures
   are described for processing of certification paths in the Internet
   environment.  Encoding rules are provided for popular cryptographic
   algorithms.  Finally, a comprehensive ASN.1 module is provided in the
   appendices for all data structure defined or referenced.

   The specification presents profiles of the X.509 version 3
   certificate and version 2 certificate revocation lists. The profiles
   include the identification of ISO and ANSI extensions which may be
   useful in the Internet PKI and definition of new extensions to meet
   the Internet's requirements. The profiles are presented in the 1988
   Abstract Syntax Notation One (ASN.1) rather than the 1993 syntax used
   in the ISO standards.

   This specification also includes path validation procedures.  These
   procedures are based upon the ISO definition, but incorporate the
   Internet defined extensions.  Implementations are required to derive
   the same results but are not required to use the specified
   procedures.

   Finally, the specification describes procedures for identification
   and encoding of public key materials and digital signatures.
   Implementations are not required to use any particular cryptographic
   algorithms.  However, conforming implementations which use the
   identified algorithms are required to identify and encode the public
   key materials and digital signatures as described.

   An Appendix is provided containing all ASN.1 structures defined or
   referenced within this specification.  As above, the material is
   presented in the 1988 Abstract Syntax Notation One (ASN.1) rather
   than the 1993 syntax.

2  Requirements and Assumptions

   Goal is to develop a profile and associated management structure to
   facilitate the adoption/use of X.509 certificates within Internet
   applications for those communities wishing to make use of X.509
   technology. Such applications may include WWW, electronic mail, user
   authentication, and IPSEC, as well as others.  In order to relieve
   some of the obstacles to using X.509 certificates, this document

Housley, Ford, Polk, & Solo                                     [Page 2]

INTERNET DRAFT                                             March 26 1996

   defines a profile to promote the development of certificate
   management systems; development of application tools; and
   interoperability determined by policy, as opposed to syntax.

   Some communities will need to supplement, or possibly replace, this
   profile in order to meet the requirements of specialized application
   domains or environments with additional authorization, assurance, or
   operational requirements.  However, for basic applications, common
   representations of frequently used attributes are defined so that
   application developers can obtain necessary information without
   regard to the issuer of a particular certificate or certificate
   revocation list (CRL).

   As supplemental authorization and attribute management tools emerge,
   such as attribute certificates, it may be appropriate to limit the
   authenticated attributes that are included in a certificate.  These
   other management tools may be more appropriate method of conveying
   many authenticated attributes.

2.1  Communication and Topology

   The users of certificates will operate in a wide range of
   environments with respect to their communication topology, especially
   users of secure electronic mail.  This profile supports users without
   high bandwidth, real-time IP connectivity, or high connection
   availablity.  In addition, the profile allows for the presence of
   firewall or other filtered communication.

   This profile does not assume the deployment of an X.500 Directory
   system.  The profile does not prohibit the use of an X.500 Directory,
   but other means of distributing certificates and certificate
   revocation lists (CRLs) are supported.

2.2  Acceptability Criteria

   The goal of the Internet Public Key Infrastructure (PKI) is to meet
   the needs of deterministic, automated identification, authentication,
   access control, and authorization functions. Support for these
   services determines the attributes contained in the certificate as
   well as the ancillary control information in the certificate such as
   policy data and certification path constraints.

2.3  User Expectations

   Users of the Internet PKI are people and processes who use client
   software and are the subjects named in certificates.  These uses
   include readers and writers of electronic mail, the clients for WWW
   browsers, WWW servers, and the key manager for IPSEC within a router.

Housley, Ford, Polk, & Solo                                     [Page 3]

INTERNET DRAFT                                             March 26 1996

   This profile recognizes the limitations of the platforms these users
   employ and the sophistication/attentiveness of the users themselves.
   This manifests itself in minimal user configuration responsibility
   (e.g., root keys, rules), explicit platform usage constraints within
   the certificate, certification path constraints which shield the user
   from many malicious actions, and applications which sensibly automate
   validation functions.

2.4  Administrator Expectations

   As with users, the Internet PKI profile is structured to support the
   individuals who generally operate Certification Authorities (CAs).
   Providing administrators with unbounded choices increases the chances
   that a subtle CA administrator mistake will result in broad
   compromise.  Also, unbounded choices greatly complicates the software
   that must process and validate the  certificates created by the CA.

3  Overview of Approach

   Following is a simplified view of the architectural model assumed by
   the PKIX specifications.

Housley, Ford, Polk, & Solo                                     [Page 4]

INTERNET DRAFT                                             March 26 1996

      +---+
      | C |                       +------------+
      | e | <-------------------->| End entity |
      | r |       Operational     +------------+
      | t |       transactions         ^
      |   |      and management        |  Management
      | / |       transactions         |  transactions
      |   |                            |
      | C |    PKI users               v
      | R |             -------+-------+--------+------
      | L |   PKI management   ^                ^
      |   |      entities      |                |
      |   |                    v                |
      | R |                 +------+            |
      | e | <-------------- | RA   | <-----+    |
      | p |   certificate   |      |       |    |
      | o |       publish   +------+       |    |
      | s |                                |    |
      | I |                                v    v
      | t |                            +------------+
      | o | <--------------------------|     CA     |
      | r |   certificate publish      +------------+
      | y |           CRL publish             ^
      |   |                                   |
      +---+                                   |    Management
                                              |    transactions
                                              v
                                          +------+
                                          |  CA  |
                                          +------+

                          Figure 1 - PKI Entities

   The components in this model are:

   end entity:  user of PKI certificates and/or end user system that
                is the subject of a certificate;
   CA:          certification authority;
   RA:          registration authority, i.e., an optional system to
                which a CA delegates certain management functions;
   repository:  a system or collection of distributed systems that
                store certificates and CRLs and serves as a means of
                distributing these certificates and CRLs to end
                entities.

Housley, Ford, Polk, & Solo                                     [Page 5]

INTERNET DRAFT                                             March 26 1996

3.1  X.509 Version 3 Certificate

   Application of public key technology requires the user of a public
   key to be confident that the public key belongs to the correct remote
   subject (person or system) with which an encryption or digital
   signature mechanism will be used.  This confidence is obtained
   through the use of public key certificates, which are data structures
   that bind public key values to subjects.  The binding is achieved by
   having a trusted certification authority (CA) digitally sign each
   certificate.  A certificate has a limited valid lifetime which is
   indicated in its signed contents.  Because a certificate's signature
   and timeliness can be independently checked by a certificate-using
   client, certificates can be distributed via untrusted communications
   and server systems, and can be cached in unsecured storage in
   certificate-using systems.

   The standard known as ITU-T X.509 (formerly CCITT X.509) or ISO/IEC
   9594-8, which was first published in 1988 as part of the X.500
   Directory recommendations, defines a standard certificate format. The
   certificate format in the 1988 standard is called the version 1 (v1)
   format.  When X.500 was revised in 1993, two more fields were added,
   resulting in the version 2 (v2) format. These two fields are used to
   support directory access control.

   The Internet Privacy Enhanced Mail (PEM) proposals, published in
   1993, include specifications for a public key infrastructure based on
   X.509 v1 certificates [RFC 1422].  The experience gained in attempts
   to deploy RFC 1422 made it clear that the v1 and v2 certificate
   formats are deficient in several respects.  Most importantly, more
   fields were needed to carry information which PEM design and
   implementation experience has proven necessary.  In response to these
   new requirements, ISO/IEC and ANSI X9 developed the X.509 version 3
   (v3) certificate format.  The v3 format extends the v2 format by
   adding provision for additional extension fields.  Particular
   extension field types may be specified in standards or may be defined
   and registered by any organization or community. In June 1996,
   standardization of the basic v3 format was completed [X.509-AM].

   ISO/IEC and ANSI X9 have also developed standard extensions for use
   in the v3 extensions field [X.509-AM][X9.55].  These extensions can
   convey such data as additional subject identification information,
   key attribute information, policy information, and certification path
   constraints.

   However, the ISO/IEC and ANSI standard extensions are very broad in
   their applicability.  In order to develop interoperable
   implementations of X.509 v3 systems for Internet use, it is necessary
   to specify a profile for use of the X.509 v3 extensions tailored for

Housley, Ford, Polk, & Solo                                     [Page 6]

INTERNET DRAFT                                             March 26 1996

   the Internet.  It is one goal of this document to specify a profile
   for Internet WWW, electronic mail, and IPSEC applications.
   Environments with additional requirements may build on this profile
   or may replace it.

3.2  Certification Paths and Trust

   A user of a security service requiring knowledge of a public key
   generally needs to obtain and validate a certificate containing the
   required public key.  If the public-key user does not already hold an
   assured copy of the public key of the CA that signed the certificate,
   then it might need an additional certificate to obtain that public
   key.  In general, a chain of multiple certificates may be needed,
   comprising a certificate of the public key owner (the end entity)
   signed by one CA, and zero or more additional certificates of CAs
   signed by other CAs.  Such chains, called certification paths, are
   required because a public key user is only initialized with a limited
   number of assured CA public keys.

   There are different ways in which CAs might be configured in order
   for public key users to be able to find certification paths.  For
   PEM, RFC 1422 defined a rigid hierarchical structure of CAs.  There
   are three types of PEM certification authority:

   (a)  Internet Policy Registration Authority (IPRA):  This authority,
   operated under the auspices of the Internet Society, acts as the root
   of the PEM certification hierarchy at level 1.  It issues
   certificates only for the next level of authorities, PCAs.  All
   certification paths start with the IPRA.

   (b)  Policy Certification Authorities (PCAs):  PCAs are at level 2 of
   the hierarchy, each PCA being certified by the IPRA.  A PCA must
   establish and publish a statement of its policy with respect to
   certifying users or subordinate certification authorities.  Distinct
   PCAs aim to satisfy different user needs. For example, one PCA (an
   organizational PCA) might support the general electronic mail needs
   of commercial organizations, and another PCA (a high-assurance PCA)
   might have a more stringent policy designed for satisfying legally
   binding signature requirements.

   (c)  Certification Authorities (CAs):  CAs are at level 3 of the
   hierarchy and can also be at lower levels. Those at level 3 are
   certified by PCAs.  CAs represent, for example, particular
   organizations, particular organizational units (e.g., departments,
   groups, sections), or particular geographical areas.

   RFC 1422 furthermore has a name subordination rule which requires
   that a CA can only issue certificates for entities whose names are

Housley, Ford, Polk, & Solo                                     [Page 7]

INTERNET DRAFT                                             March 26 1996

   subordinate (in the X.500 naming tree) to the name of the CA itself.
   The trust associated with a PEM certification  path is implied by the
   PCA name. The name subordination rule ensures that CAs below the PCA
   are sensibly constrained as to the set of subordinate entities they
   can certify (e.g., a CA for an organization can only certify entities
   in that organization's name tree). Certificate user systems are able
   to mechanically check that the name subordination rule has been
   followed.

   The RFC 1422 CA hierarchical model has been found to have several
   deficiencies, including:

   (a)  The pure top-down hierarchy, with all certification paths
   starting from the root, is too restrictive for many purposes.  For
   some applications, verification of certification paths should start
   with a public key of a CA in a user's own domain, rather than
   mandating that verification commence at the top of a hierarchy. In
   many environments, the local domain is often the most trusted.  Also,
   initialization and key-pair-update operations can be more effectively
   conducted between an end entity and a local management system.

   (b)  The name subordination rule introduces undesirable constraints
   upon the X.500 naming system an organization may use.

   (c)  Use of the PCA concept requires knowledge of individual PCAs to
   be built into certificate chain verification logic.  In the
   particular case of Internet mail, this is not a major problem -- the
   PCA name can always be displayed to the human user who can make a
   decision as to what trust to imply from a particular chain.  However,
   in many commercial applications, such as electronic commerce or EDI,
   operator intervention to make policy decisions is impractical.  The
   process needs to be automated to a much higher degree.  In fact, the
   full process of certificate chain processing needs to be
   implementable in trusted software.

   Because of the above shortcomings, it is proposed that more flexible
   CA structures than the RFC 1422 hierarchy be supported by the PKIX
   specifications.  In fact, the main reason for the structural
   restrictions imposed by RFC 1422 was the restricted certificate
   format provided with X.509 v1.  With X.509 v3, most of the
   requirements addressed by RFC 1422 can be addressed using certificate
   extensions, without a need to restrict the CA structures used.  In
   particular, the certificate extensions relating to certificate
   policies obviate the need for PCAs and the constraint extensions
   obviate the need for the name subordination rule.

Housley, Ford, Polk, & Solo                                     [Page 8]

INTERNET DRAFT                                             March 26 1996

3.3  Revocation

   When a certificate is issued, it is expected to be in use for its
   entire validity period.  However, various circumstances may cause a
   certificate to become invalid prior to the expiration of the validity
   period. Such circumstances might include change of name, change of
   association between subject and CA (e.g., an employee terminates
   employment with an organization), and compromise or suspected
   compromise of the corresponding private key.  Under such
   circumstances, the CA needs to revoke the certificate.

   X.509 defines one method of certificate revocation.  This method
   involves each CA periodically issuing a signed data structure called
   a certificate revocation list (CRL).  A CRL is a time stamped list
   identifying revoked certificates which is signed by a CA and made
   freely available in a public repository.  Each revoked certificate is
   identified in a CRL by its certificate serial number. When a
   certificate-using system uses a certificate (e.g., for verifying a
   remote user's digital signature), that system not only checks the
   certificate signature and validity but also acquires a suitably-
   recent CRL and checks that the certificate serial number is not on
   that CRL.  The meaning of "suitably-recent" may vary with local
   policy, but it usually means the most recently-issued CRL.  A CA
   issues a new CRL on a regular periodic basis (e.g., hourly, daily, or
   weekly).  Entries are added to CRLs as revocations occur, and an
   entry may be removed when the certificate expiration date is reached.

   An advantage of this revocation method is that CRLs may be
   distributed by exactly the same means as certificates themselves,
   namely, via untrusted communications and server systems.

   One limitation of the CRL revocation method, using untrusted
   communications and servers, is that the time granularity of
   revocation is limited to the CRL issue period.  For example, if a
   revocation is reported now, that revocation will not be reliably
   notified to certificate-using systems until the next periodic CRL is
   issued -- this may be up to one hour, one day, or one week depending
   on the frequency that the CA issues CRLs.

   Another potential problem with CRLs is the risk of a CRL growing to
   an entirely unacceptable size.  In the 1988 and 1993 versions of
   X.509, the CRL for the end-user certificates needed to cover the
   entire population of end-users for one CA.  It is desirable to allow
   such populations to be in the range of thousands, tens of thousands,
   or possibly even hundreds of thousands of users. The end-user CRL is
   therefore at risk of growing to such sizes, which present major
   communication and storage overhead problems.  With the version 2 CRL
   format, introduced along with the v3 certificate format, it becomes

Housley, Ford, Polk, & Solo                                     [Page 9]

INTERNET DRAFT                                             March 26 1996

   possible to arbitrarily divide the population of certificates for one
   CA into a number of partitions, each partition being associated with
   one CRL distribution point (e.g., directory entry or URL) from which
   CRLs are distributed.  Therefore, the maximum CRL size can be
   controlled by a CA.  Separate CRL distribution points can also exist
   for different revocation reasons.  For example, routine revocations
   (e.g., name change) may be placed on a different CRL to revocations
   resulting from suspected key compromises, and policy may specify that
   the latter CRL be updated and issued more frequently than the former.

   As with the X.509 v3 certificate format, in order to facilitate
   interoperable implementations from multiple vendors, the X.509 v2 CRL
   format needs to be profiled for Internet use.  It is one goal of this
   document to specify that profile.

   Furthermore, it is recognized that on-line methods of revocation
   notification may be applicable in some environments as an alternative
   to the X.509 CRL.  On-line revocation checking eliminates the latency
   between a revocation report and CRL the next issue.  Once the
   revocation is reported, any query to the on-line service will
   correctly reflect the certificate validation impacts of the
   revocation.  However, these methods impose new security requirements;
   the certificate validator must trust the on-line validation service
   while the repository did not need to be trusted.

   Therefore, this profile also considers standard approaches to on-line
   revocation notification.  Part 2 of the PKIX series of specifications
   defines a set of standard message formats supporting these functions.
   The protocols for conveying these messages in different environments
   are also specified.

3.4  Operational Protocols

   Operational protocols are required to deliver certificates and CRLs
   to certificate using client systems. Provision is needed for a
   variety of different means of certificate and CRL delivery, including
   request/delivery procedures based on E-mail, http, X.500, and
   WHOIS++.  These specifications include definitions of, and/or
   references to, message formats and procedures for supporting all of
   the above operational environments, including definitions of or
   references to appropriate MIME content types.

3.5  Management Protocols

   Management protocols are required to support on-line interactions
   between Public Key Infrastructure (PKI) components.  For example,
   management protocol might be used between a CA and a client system
   with which a key pair is associated, or between two CAs which cross-

Housley, Ford, Polk, & Solo                                    [Page 10]

INTERNET DRAFT                                             March 26 1996

   certify each other.  The set of functions which potentially need to
   be supported by management protocols include:

   (a)  registration:  This is the process whereby a user first makes
   itself known to a CA (directly, or through an LRA), prior to that CA
   issuing  a certificate or certificates for that user.

   (b)  initialization:  Before a client system can operate securely it
   is necessary to install in it necessary key materials which have the
   appropriate relationship with keys stored elsewhere in the
   infrastructure.  For example, the client needs to be securely
   initialized with the public key of a CA, to be used in validating
   certificate paths.  Furthermore, a client typically needs to be
   initialized with its own key pair(s).

   (c)  certification:  This  is the process in which a CA issues a
   certificate for a user's public key, and returns that certificate to
   the user's client system and/or posts that certificate in a
   repository.

   (d)  key pair recovery:  As an option, user client key materials
   (e.g., a user's private key used for encryption purposes) may be
   backed up by a CA or a key backup system.  If a user needs to recover
   these backed up key materials (e.g., as a result of a forgotten
   password or a lost key chain file), an on-line protocol exchange may
   be needed to support such recovery.

   (e)  key pair update:  All key pairs need to be updated regularly,
   i.e., replaced with a new key pair, and new certificates issued.

   (f)  revocation request:  An authorized person advises a CA of an
   abnormal situation requiring certificate revocation.

   (g)  cross-certification:  Two CAs exchange the information necessary
   to establish cross-certificates between those CAs.

   Note that on-line protocols are not the only way of implementing the
   above functions.  For all functions there are off-line methods of
   achieving the same result, and this specification does not mandate
   use of on- line protocols.  For example, when hardware tokens are
   used, many of the functions may be achieved through as part of the
   physical token delivery.  Furthermore, some of the above functions
   may be combined into one protocol exchange.  In particular, two or
   more of the registration, initialization, and certification functions
   can be combined into one protocol exchange.

   Part 3 of the PKIX series of specifications defines a set of standard
   message formats supporting the above functions.  The protocols for

Housley, Ford, Polk, & Solo                                    [Page 11]

INTERNET DRAFT                                             March 26 1996

   conveying these messages in different environments (on-line, e-mail,
   and WWW) are also specified in Part 3.

4  Certificate and Certificate Extensions Profile

   This section presents a profile for public key certificates that will
   foster interoperability and a reusable public key infrastructure.
   This section is based upon the X.509 V3 certificate format
   [COR95][X.509-AM] and the standard certificate extensions defined in
   the Amendment [X.509-AM].  The ISO documents use the 1993 version of
   ASN.1; while this document uses the 1988 ASN.1 syntax, the encoded
   certificate and standard extensions are equivalent.  This section
   also defines private extensions required to support a public key
   infrastructure for the Internet community.

   Certificates may be used in a wide range of applications and
   environments covering a broad spectrum of interoperability goals and
   a broader spectrum of operational and assurance requirements.  The
   goal of this document is to establish a common baseline for generic
   applications requiring broad interoperability and limited special
   purpose requirements.  In particular, the emphasis will be on
   supporting the use of X.509 v3 certificates for informal internet
   electronic mail, IPSEC, and WWW applications.  Other efforts are
   looking at certificate profiles for payment systems.

4.1  Basic Certificate Fields

   The X.509 v3 certificate basic syntax is as follows.  For signature
   calculation, the certificate is encoded using the ASN.1 distinguished
   encoding rules (DER) [X.208].  ASN.1 DER encoding is a tag, length,
   value encoding system for each element.

   Certificate  ::=  SEQUENCE  {
        tbsCertificate       TBSCertificate,
        signatureAlgorithm   AlgorithmIdentifier,
        signature            BIT STRING  }

   TBSCertificate  ::=  SEQUENCE  {
        version         [0]  EXPLICIT Version DEFAULT v1,
        serialNumber         CertificateSerialNumber,
        signature            AlgorithmIdentifier,
        issuer               Name,
        validity             Validity,
        subject              Name,
        subjectPublicKeyInfo SubjectPublicKeyInfo,
        issuerUniqueID  [1]  IMPLICIT UniqueIdentifier OPTIONAL,
                             -- If present, version must be v2 or v3
        subjectUniqueID [2]  IMPLICIT UniqueIdentifier OPTIONAL,

Housley, Ford, Polk, & Solo                                    [Page 12]

INTERNET DRAFT                                             March 26 1996

                             -- If present, version must be v2 or v3
        extensions      [3]  EXPLICIT Extensions OPTIONAL
                             -- If present, version must be v3
        }

   Version  ::=  INTEGER  {  v1(0), v2(1), v3(2)  }

   CertificateSerialNumber  ::=  INTEGER

   Validity ::= SEQUENCE {
        notBefore      CertificateValidityDate,
        notAfter       CertificateValidityDate }

   CertificateValidityDate ::= CHOICE {
        utcTime        UTCTime,
        generalTime    GeneralizedTime }

   UniqueIdentifier  ::=  BIT STRING

   SubjectPublicKeyInfo  ::=  SEQUENCE  {
        algorithm            AlgorithmIdentifier,
        subjectPublicKey     BIT STRING  }

   Extensions  ::=  SEQUENCE OF Extension

   Extension  ::=  SEQUENCE  {
        extnID      OBJECT IDENTIFIER,
        critical    BOOLEAN DEFAULT FALSE,
        extnValue   OCTET STRING  }

   The following items describe a proposed use of the X.509 v3
   certificate for the Internet.

4.1.1  Certificate Fields

   The Certificate is a SEQUENCE of three required fields. The fields
   are are described in detail in the following subsections

4.1.1.1  tbsCertificate

   The first field in the sequence is the tbsCertificate.  This is a
   itself a sequence, and contains the names of the subject and issuer,
   a public key associated with the subject an expiration date, and
   other associated information.  The fields of the basic tbsCertificate
   are described in detail in section 4.1.2; the tbscertificate may also
   include extensions which are described in section 4.2.

Housley, Ford, Polk, & Solo                                    [Page 13]

INTERNET DRAFT                                             March 26 1996

4.1.1.2  signatureAlgorithm

   The signatureAlgorithm field contains the algorithm identifier for
   the algorithm used by the CA to sign the certificate.  Section 7.2
   lists the supported signature algorithms.

   This field should contain the same algorithm identifier as the field
   signature in the sequence tbsCertificate (see section 4.1.2.3)

4.1.1.3  signature

   The signature field contains a digital signature computed upon the
   ASN.1 DER encoded TBSCertificate.  The ASN.1 DER encoded
   TBSCertificate is used as the input to a one-way hash function.  The
   one-way hash function output value is ASN.1 encoded as an OCTET
   STRING and the result is encrypted (e.g., using RSA Encryption) to
   form the signed quantity.  This signature value is then ASN.1 encoded
   as a BIT STRING and included in the Certificate's signature field.

   By generating this signature, a CA certifies the validity of the
   information in tbscertificate.  In particular, the CA certifies the
   binding between the public key material and the subject of the
   certificate.

4.1.2  TBSCertificate

   The sequence TBSCertificate is a sequence which contains information
   associated with the subject of the certificate and the CA who issued
   it.  Every TBSCertificate contains the names of the subject and
   issuer, a public key associated with the subject, an expiration date,
   a version number and a serial number; some will contain optional
   unique identifier fields.  The remainder of this section describes
   the syntax and semantics of these fields.  A TBSCertificate may also
   include extensions.  Extensions for the Internet PKI are described in
   Section 4.2.

4.1.2.1  Version

   This field describes the version of the encoded certificate.  When
   extensions are used, as expected in this profile, use X.509 version 3
   (value is 2).  If no extensions are present, but a UniqueIdentifier
   is present, use version 2 (value is 1).  If only basic fields are
   present, use version 1 (the value is omitted from the certificate as
   the default value).

   Implementations should be prepared to accept any version certificate.
   In particular, at a minimum, implementations must recognize version 3
   certificates; determine whether any critical extensions are present;

Housley, Ford, Polk, & Solo                                    [Page 14]

INTERNET DRAFT                                             March 26 1996

   and accept certificates without critical extensions even if they
   don't recognize any extensions.  A certificate with an unrecognized
   critical extension must always be rejected.

   Generation of version 2 certificates is not expected by
   implementations based on this profile.

4.1.2.2  Serial number

   The serial number is an integer assigned by the certification
   authority to each certificate.  It must be unique for each
   certificate issued by a given CA (i.e., the issuer name and serial
   number identify a unique certificate).

4.1.2.3  Signature

   This field contains the algorithm identifier for the algorithm used
   by the CA to sign the certificate.  Section 7.2 lists the supported
   signature algorithms.

4.1.2.4  Issuer Name

   The issuer name identifies the entity who has signed (and issued the
   certificate).  The issuer identity may be carried in the issuer name
   field and/or the issuerAltName extension.  If identity information is
   present only in the issuerAltName extension, then the issuer name may
   be an empty sequence and the issuerAltName extension must be
   critical.

4.1.2.5  Validity

   This field indicates the dates on which the certificate becomes valid
   (notBefore) and on which the certificate ceases to be valid
   (notAfter).  Both notBefore and notAfter may be encoded as UTCTime or
   GeneralizedTime.

   CAs conforming to this profile shall always encode validity dates
   through the year 2049 as UTCTime; validity dates in 2050 or later
   shall be encoded as GeneralizedTime.

4.1.2.5.1  UTCTime

   The universal time type, UTCTime, is a standard ASN.1 type intended
   for international applications where local time alone is not
   adequate. UTCTime specifies the year through the two low order digits
   and time is specified to the precision of one minute or one second.
   UTCTime includes either Z (for Zulu, or Greenwich Mean Time) or a
   time differential.

Housley, Ford, Polk, & Solo                                    [Page 15]

INTERNET DRAFT                                             March 26 1996

   For the purposes of this profile, UTCTime values shall be expressed
   Greenwich Mean Time (Zulu) and shall include< seconds (i.e., times
   are YYMMDDHHMMSSZ), even where the number of seconds is zero.
   Conforming systems shall interpret the year field (YY) as follows:

      Where YY is greater than 50, the year shall be interpreted as
      19YY; and

      Where YY is less than or equal to 50, the year shall be
      interpreted as 20YY.

4.1.2.5.2  GeneralizedTime

   The generalized time type, GeneralizedTime, is a standard ASN.1 type
   for variable precision representation of time.  Optionally, the
   GeneralizedTime field can include a representation of the time
   differential between local and Greenwich Mean Time.

   For the purposes of this profile, GeneralizedTime values shall be
   expressed Greenwich Mean Time (Zulu) and shall include seconds (i.e.,
   times are YYYYMMDDHHMMSSZ), even where the number of seconds is zero.
   GeneralizedTime values shall not include fractional seconds.

4.1.2.6  Subject Name

   The subject name identifies the entity associated with the public key
   stored in the subject public key field. The subject identity may be
   carried in the subject field and/or the subjectAltName extension.  If
   identity information is present only in the subjectAltName extension
   (e.g., a key bound only to an email address or URI), then the subject
   name may be an empty sequence and the subjectAltName extension must
   be critical.

4.1.2.7  Subject Public Key Info

   This field is used to carry the public key and identify the algorithm
   with which the key is used.

4.1.2.8  Unique Identifiers

   The subject and issuer unique identifier are present in the
   certificate to handle the possibility of reuse of subject and/or
   issuer names over time.  This profile recommends that names not be
   reused and that Internet certificates not make use of unique
   identifiers.  CAs conforming to this profile should not generate
   certificates with unique identifiers.  Applications conforming to
   this profile should be capable of parsing unique identifiers and
   making comparisons.

Housley, Ford, Polk, & Solo                                    [Page 16]

INTERNET DRAFT                                             March 26 1996

4.2  Certificate Extensions

   The extensions defined for X.509 v3 certificates provide methods for
   associating additional attributes with users or public keys, for
   managing the certification hierarchy, and for managing CRL
   distribution.  The X.509 v3 certificate format also allows
   communities to define private extensions to carry information unique
   to those communities.  Each extension in a certificate may be
   designated as critical or non-critical.  A certificate using system
   (an application validating a certificate) must reject the certificate
   if it encounters a critical extension it does not recognize.  A non-
   critical extension may be ignored if it is not recognized.  The
   following presents recommended extensions used within Internet
   certificates and standard locations for information.  Communities may
   elect to use additional extensions; however, caution should be
   exercised in adopting any critical extensions in certificates which
   might be used in a general context.

   Each extension includes an object identifier and an ASN.1 structure.
   When an extension appears in a certificate, the object identifier
   appears as the field extnID and the corresponding ASN.1 encoded
   structure is the value of the bit string extnValue.  Only one
   instance of a particular extension may appear in a particular
   certificate. For example, a certificate may contain only one
   authority key identifier extension (4.2.1.1).  An extension may also
   include the optional boolean critical; critical's default value is
   FALSE.  The text for each extension specifies the acceptable values
   for the critical field.

   Conforming CAs are required to support the Basic Constraints
   extension (Section 4.2.1.10), the keyUsage extension (4.2.1.3) and
   certificatePolicies extension (4.2.1.5). If the CA issues
   certificates with an empty sequence for the subject field, the CA
   must support the altSubjectName extension.  If the CA issues
   certificates with an empty sequence for the issuer field, the CA must
   support the altIssuerName extension.  Support for the remaining
   extensions is optional. Conforming CAs may support extensions that
   are not identified within this specification; certificate issuers are
   cautioned that marking such extensions as critical may inhibit
   interoperability.

   At a minimum, applications conforming to this profile shall recognize
   extensions which shall or may be critical. These extensions are:  key
   usage (4.2.1.3), certificate policies (4.2.1.5), the alternative
   subject name (4.2.1.7), issuer alternative name (4.2.1.8), basic
   constraints (4.2.1.10), name constraints (4.2.1.11), and policy
   constraints (4.2.1.12).

Housley, Ford, Polk, & Solo                                    [Page 17]

INTERNET DRAFT                                             March 26 1996

   In addition, this profile recommends support for key identifiers
   (4.2.1.1 and 4.2.1.2), CRL distribution points (4.2.1.13), and
   authority information access (4.2.2.2).

4.2.1  Standard Extensions

   This section identifies standard certificate extensions defined in
   [X.509-AM] for use in the Internet Public Key Infrastructure.  Each
   extension is associated with an object identifier defined in [X.509-
   AM].  These object identifiers are members of the
   certificateExtension arc, which is defined by the following:

   certificateExtension  OBJECT IDENTIFIER ::=  {joint-iso-ccitt(2) ds(5) 29}
   id-ce                 OBJECT IDENTIFIER ::=  certificateExtension

   4.2.1.1  Authority Key Identifier

   The authority key identifier extension provides a means of
   identifying the particular public key used to sign a certificate.
   This extension would be used where an issuer has multiple signing
   keys (either due to multiple concurrent key pairs or due to
   changeover).  In general, this extension should be included in
   certificates.

   The identification can be based on either the key identifier (the
   subject key identifier in the issuer's certificate) or on the issuer
   name and serial number.  The key identifier method is recommended in
   this profile. Conforming CAs that generate this extension shall
   include or omit both authorityCertIssuer and
   authorityCertSerialNumber. If authorityCertIssuer and
   authorityCertSerialNumber are omitted, the keyIdentifier field shall
   be present.

   This extension shall not be marked critical.

   id-ce-authorityKeyIdentifier OBJECT IDENTIFIER ::=  { id-ce 35 }

   AuthorityKeyIdentifier ::= SEQUENCE {
        keyIdentifier                   [0] KeyIdentifier               OPTIONAL,
        authorityCertIssuer             [1] GeneralNames                OPTIONAL,
        authorityCertSerialNumber       [2] CertificateSerialNumber     OPTIONAL
    }

   KeyIdentifier ::= OCTET STRING

Housley, Ford, Polk, & Solo                                    [Page 18]

INTERNET DRAFT                                             March 26 1996

4.2.1.2  Subject Key Identifier

   The subject key identifier extension provides a means of identifying
   the particular public key used in an application.  Where a reference
   to a public key identifier is needed (as with an Authority Key
   Identifier) and one is not included in the associated certificate, a
   SHA-1 hash of the subject public key shall be used.  The hash shall
   be calculated over the value (excluding tag and length) of the
   subject public key field in the certificate.  This extension should
   be marked non-critical.

   id-ce-subjectKeyIdentifier OBJECT IDENTIFIER ::=  { id-ce 14 }

   SubjectKeyIdentifier ::= KeyIdentifier

4.2.1.3  Key Usage

   The key usage extension defines the purpose (e.g., encipherment,
   signature, certificate signing) of the key contained in the
   certificate.  The usage restriction might be employed when a
   multipurpose key is to be restricted (e.g., when an RSA key should be
   used only for signing or only for key encipherment).  The profile
   recommends that when used, this be marked as a critical extension.

   id-ce-keyUsage OBJECT IDENTIFIER ::=  { id-ce 15 }

   KeyUsage ::= BIT STRING {
        digitalSignature        (0),
        nonRepudiation          (1),
        keyEncipherment         (2),
        dataEncipherment        (3),
        keyAgreement            (4),
        keyCertSign             (5),
        cRLSign                 (6) }

4.2.1.4  Private Key Usage Period

   The private key usage period extension allows the certificate issuer
   to specify a different validity period for the private key than the
   certificate. This extension is intended for use with digital
   signature keys.  This extension consists of two optional components
   notBefore and notAfter.  The private key associated with the
   certificate should not be used to sign objects before or after the
   times specified by the two components, respectively. CAs conforming
   to this profile shall not generate certificates with private key
   usage period extensions unless at least one of the two components is
   present.

Housley, Ford, Polk, & Solo                                    [Page 19]

INTERNET DRAFT                                             March 26 1996

   This profile recommends against the use of this extension.  CAs
   conforming to this profile shall not generate certificates with
   critical private key usage period extensions. Where used, notBefore
   and notAfter are represented as GeneralizedTime and shall be
   specified and interpreted as defined in Section 4.1.2.5.2.

   id-ce-privateKeyUsagePeriod OBJECT IDENTIFIER ::=  { id-ce 16 }

   PrivateKeyUsagePeriod ::= SEQUENCE {
        notBefore       [0]     GeneralizedTime OPTIONAL,
        notAfter        [1]     GeneralizedTime OPTIONAL }

4.2.1.5  Certificate Policies

   The certificate policies extension contains a sequence of policy
   information terms, each of which consists of an object identifier
   (OID) and optional qualifiers.  These policy information terms
   indicate the policy under which the certificate has been issued and
   the purposes for which the certificate may be used.  This profile
   strongly recommends that a simple OID be present in this field.
   Optional qualifiers which may be present are expected to provide
   information about obtaining CA rules, not change the definition of
   the policy.

   Applications with specific policy requirements are expected to have a
   list of those policies which they will accept and to compare the
   policy OIDs in the certificate to that list.  If this extension is
   critical, the path validation software must be able to interpret this
   extension, or must reject the certificate.  (Applications are free to
   ignore the policy field, even if the extension is marked critical.)

   This specification defines two policy qualifiers types for use by
   certificate policy writers and certificate issuers at their own
   discretion. The qualifier types are the CPS Pointer qualifier, and
   the User Notice qualifier.

   The CPS Pointer qualifier contains a pointer to a Certification
   Practice Statement (CPS) published by the CA.  The pointer is in the
   form of a URI.

   The User Notice qualifier contains a text string that is to be
   displayed to a certificate user (including subscribers and relying
   parties) prior to the use of the certificate.  The text string may be
   an VisibleString (visible characters from International Alphabet 5
   plus space) or a BMPString - a subset of the ISO 100646-1 multiple
   octet coded character set.  A CA may invoke a procedure that requires
   that the certficate user acknowledge that the applicable terms and
   conditions have been disclosed or accepted.

Housley, Ford, Polk, & Solo                                    [Page 20]

INTERNET DRAFT                                             March 26 1996

   id-ce-certificatePolicies OBJECT IDENTIFIER ::=  { id-ce 32 }

   certificatePolicies ::= SEQUENCE SIZE (1..MAX) OF PolicyInformation

   PolicyInformation ::= SEQUENCE {
        policyIdentifier   CertPolicyId,
        policyQualifiers   SEQUENCE SIZE (1..MAX) OF
                PolicyQualifierInfo OPTIONAL }

   CertPolicyId ::= OBJECT IDENTIFIER

   PolicyQualifierInfo ::= SEQUENCE {
        policyQualifierId   PolicyQualifierId,
        qualifier           ANY DEFINED BY policyQualifierId }

   -- policyQualifierIds for Internet policy qualifiers

   id-pkix-cps      OBJECT IDENTIFIER ::=  { pkix 4 }
   id-pkix-unotice  OBJECT IDENTIFIER ::=  { pkix 5 }

   PolicyQualifierId ::= ENUMERATED { id-pkix-cps, id-pkix-unotice }

   Qualifier ::= CHOICE {
        cPSuri    CPSuri,
        userNotice     UserNotice }

   CPSuri ::= IA5String

   UserNotice ::= CHOICE {
     visibleString     VisibleString,
     bmpString         BMPString }

4.2.1.6  Policy Mappings

   This extension is used in CA certificates.  It lists pairs of
   objectidentifiers; each pair includes an issuerDomainPolicy and a
   subjectDomainPolicy. The pairing indicates the issuing CA considers
   its issuerDomainPolicy equivalent to the subject CA's
   subjectDomainPolicy.

   The issuing CA's users may accept an issuerDomainPolicy for certain
   applications. The policy mapping tells the issuing CA's users which
   policies associated with the subject CA are comparable to the policy
   they accept.

   This extension may be supported by CAs and/or applications, and it is
   always non-critical.

Housley, Ford, Polk, & Solo                                    [Page 21]

INTERNET DRAFT                                             March 26 1996

   id-ce-policyMappings OBJECT IDENTIFIER ::=  { id-ce 33 }

   PolicyMappings ::= SEQUENCE SIZE (1..MAX) OF SEQUENCE {
        issuerDomainPolicy      CertPolicyId,
        subjectDomainPolicy     CertPolicyId }

4.2.1.7  Subject Alternative Name

   The subject alternative names extension allows additional identities
   to be bound to the subject of the certificate.  Defined options
   include an rfc822 name (electronic mail address), a DNS name, an IP
   address, and a URI.  Other options exist, including completely local
   definitions.  Multiple instances of a name and multiple name forms
   may be included.  Whenever such identities are to be bound into a
   certificate, the subject alternative name (or issuer alternative
   name) extension shall be used.  (Note: a form of such an identifier
   may also be present in the subject distinguished name; however, the
   alternative name extension is the preferred location for finding such
   information.)

   Further, if the only subject identity included in the certificate is
   an alternative name form (e.g., an electronic mail address), then the
   subject distinguished name shall be empty (an empty sequence), and
   the subjectAltName extension shall be present. If the subject field
   contains an empty sequence, the subjectAltName extension shall be
   marked critical.

   Where the subjectAltName extension contains a
   uniformResourceIdentifier, this name the following semantics shall be
   assumed: the URI is a pointer to a sequence of certificates issued by
   this CA (and optionally other CAs) to this subject.

   The URI must be an absolute, not relative, pathname and must specify
   the host.  This specification recognizes the following values for the
   URI scheme:  ftp, http, ldap, and mailto.  The mailto scheme
   indicates that mail sent to the specified address will generate an
   electronic mail response (to the sender) containing the subject's
   certificates.  No message is required.  If the URI scheme is ftp,
   then the information is available through anonymous ftp.  If the URI
   scheme is http or ldap, then the information may be retrieved using
   that protocol.

   (If the URI specifies any other scheme, contains a relative pathname,
   or omits the  host, the semantics are not defined by this
   specification.)

   Alternative names may be constrained in the same manner as subject
   distinguished names using the name constraints extension as described

Housley, Ford, Polk, & Solo                                    [Page 22]

INTERNET DRAFT                                             March 26 1996

   in section 4.2.1.11.

   id-ce-subjectAltName OBJECT IDENTIFIER ::=  { id-ce 17 }

   SubjectAltName ::= GeneralNames

   GeneralNames ::= SEQUENCE SIZE (1..MAX) OF GeneralName

   GeneralName ::= CHOICE {
        otherName                       [0]     anotherName,
        rfc822Name                      [1]     IA5String,
        dNSName                         [2]     IA5String,
        x400Address                     [3]     ORAddress,
        directoryName                   [4]     Name,
        ediPartyName                    [5]     EDIPartyName,
        uniformResourceIdentifier       [6]     IA5String,
        iPAddress                       [7]     OCTET STRING,
        registeredID                    [8]     OBJECT IDENTIFIER }

   anotherName  ::= SEQUENCE {
        type-id    OBJECT IDENTIFER,
        value      [0] EXPLICIT ANY DEFINED BY type-id
                 }

   EDIPartyName ::= SEQUENCE {
        nameAssigner            [0]     DirectoryString OPTIONAL,
        partyName               [1]     DirectoryString }

4.2.1.8  Issuer Alternative Name

   As with 4.2.1.7, this extension is used to associate Internet style
   identities with the certificate issuer.  If the only issuer identity
   included in the certificate is an alternative name form (e.g., an
   electronic mail address), then the issuer distinguished name shall be
   empty (an empty sequence), and the issuerAltName extension shall be
   present. If the subject field contains an empty sequence, the
   issuerAltName extension shall be marked critical.

   Where the issuerAltName extension contains a URI, the following
   semantics shall be assumed: the URI is a pointer to a sequence of
   certificates issued to this CA (and optionally other CAs).  The
   expected values for the URI are those defined in 4.2.1.7. Processing
   rules for other values are not defined by this specification.

   id-ce-issuerAltName OBJECT IDENTIFIER ::=  { id-ce 18 }

   IssuerAltName ::= GeneralNames

Housley, Ford, Polk, & Solo                                    [Page 23]

INTERNET DRAFT                                             March 26 1996

4.2.1.9  Subject Directory Attributes

   The subject directory attributes extension is not recommended as an
   essential part of this profile, but it may
   be used in local environments.  This extension is always non-critical.

   id-ce-subjectDirectoryAttributes OBJECT IDENTIFIER ::=  { id-ce 9 }

   SubjectDirectoryAttributes ::= SEQUENCE SIZE (1..MAX) OF Attribute

4.2.1.10  Basic Constraints

   The basic constraints extension identifies whether the subject of the
   certificate is a CA and how deep a certification path may exist
   through that CA.  This profile requires the use of this extension,
   and it shall be critical for all certificates issued to CAs.

   id-ce-basicConstraints OBJECT IDENTIFIER ::=  { id-ce 19 }

   BasicConstraints ::= SEQUENCE {
        cA                      BOOLEAN DEFAULT FALSE,
        pathLenConstraint       INTEGER (0..MAX) OPTIONAL }

4.2.1.11  Name Constraints

   The name constraints extension provides permitted and excluded
   subtrees that place restrictions on names that may be included within
   a certificate issued by a given CA.  Restrictions may apply to the
   subject distinguished name or subject alternative names.  Any name
   matching a restriction in the excluded subtrees field is invalid
   regardless of information appearing in the permitted subtrees. This
   extension may be critical or non-critical.

   Restrictions for the rfc822, dNSName, and uri name forms are all
   expressed in terms of strings with wild card matching.  An "*" is the
   wildcard character.  The minimum and maximum fields in general
   subtree are not used for these name forms.  For uris and rfc822
   names, the restriction applies to the host part of the name.
   Examples would be foo.bar.com; www*.bar.com; *.xyz.com.

   Restrictions of the form directoryName shall be applied to the
   subject field in the certificate and to the subjectAltName extensions
   of type directoryName.  Restrictions of the form x400Address shall be
   applied to subjectAltName extensions of type x400Address.

   The syntax and semantics for name constraints for otherName,
   ediPartyName, and registeredID are not defined by this specification.

Housley, Ford, Polk, & Solo                                    [Page 24]

INTERNET DRAFT                                             March 26 1996

   id-ce-nameConstraints OBJECT IDENTIFIER ::=  { id-ce 30 }

   NameConstraints ::= SEQUENCE {
        permittedSubtrees       [0]     GeneralSubtrees OPTIONAL,
        excludedSubtrees        [1]     GeneralSubtrees OPTIONAL }

   GeneralSubtrees ::= SEQUENCE SIZE (1..MAX) OF GeneralSubtree

   GeneralSubtree ::= SEQUENCE {
        base                    GeneralName,
        minimum         [0]     BaseDistance DEFAULT 0,
        maximum         [1]     BaseDistance OPTIONAL }

   BaseDistance ::= INTEGER (0..MAX)

4.2.1.12  Policy Constraints

   The policy constraints extension can be used in certificates issued
   to CAs.  The policy constraints extension constrains path validation
   in two ways. It can be used to prohibit policy mapping or limit the
   set of policies that can in subsequent certificates. This extension
   may be critical or non-critical.

   id-ce-policyConstraints OBJECT IDENTIFIER ::=  { id-ce 34 }

   PolicyConstraints ::= SEQUENCE SIZE (1..MAX) OF SEQUENCE {
        policySet                       [0] CertPolicySet OPTIONAL,
        requireExplicitPolicy           [1] SkipCerts OPTIONAL,
        inhibitPolicyMapping            [2] SkipCerts OPTIONAL }

   SkipCerts ::= INTEGER (0..MAX)

   CertPolicySet ::= SEQUENCE SIZE (1..MAX) OF CertPolicyId

4.2.1.13  CRL Distribution Points

   The CRL distribution points extension identifies how CRL information
   is obtained.  The extension shall be non-critical, but this profile
   recommends support for this extension by CAs and applications.
   Further discussion of CRL management is contained in section 5.

   If the cRLDistributionPoints extension contains a
   DistributionPointName of type URI, the following semantics shall be
   assumed: the URI is a pointer to the current CRL for the associated
   reasons and will be issued by the associated cRLIssuer.  The expected
   values for the URI are those defined in 4.2.1.7. Processing rules for
   other values are not defined by this specification.  If the
   distributionPoint omits reasons, the CRL shall include revocations

Housley, Ford, Polk, & Solo                                    [Page 25]

INTERNET DRAFT                                             March 26 1996

   for all reasons. If the distributionPoint omits cRLIssuer, the CRL
   shall be issued by the CA that issued the certificate.

   id-ce-cRLDistributionPoints OBJECT IDENTIFIER ::=  { id-ce 31 }

   cRLDistributionPoints ::= {
        CRLDistPointsSyntax }

   CRLDistPointsSyntax ::= SEQUENCE SIZE (1..MAX) OF DistributionPoint

   DistributionPoint ::= SEQUENCE {
        distributionPoint       [0]     DistributionPointName OPTIONAL,
        reasons                 [1]     ReasonFlags OPTIONAL,
        cRLIssuer               [2]     GeneralNames OPTIONAL }

   DistributionPointName ::= CHOICE {
        fullName                [0]     GeneralNames,
        nameRelativeToCRLIssuer [1]     RelativeDistinguishedName }

   ReasonFlags ::= BIT STRING {
        unused                  (0),
        keyCompromise           (1),
        cACompromise            (2),
        affiliationChanged      (3),
        superseded              (4),
        cessationOfOperation    (5),
        certificateHold         (6) }

4.2.2  Private Internet Extensions

   This section defines two new extensions for use in the Internet
   Public Key Infrastructure.  These extensions may be used to direct
   applications to additional information about the certificate's
   subject or identify an on-line validation service supporting the
   issuing CA.  As the information may be available in multiple forms,
   each extension is a sequence of IA5String values, each of which
   represents a URI.  The URI implicitly specifies the location and
   format of the information and the method for obtaining the
   information.

   Object identifiers are defined for each of the private extensions.
   The object identifiers associated with the private extensions are
   defined under the iso (1), org (3), dod (6), internet (1),
   security(5) or 1.3.6.1.5, branch of the name space.

   The following ASN.1 defines object identifiers which may be used by
   applications that implement the private extensions; additional access
   methods may be used, but the semantics are undefined by this

Housley, Ford, Polk, & Solo                                    [Page 26]

INTERNET DRAFT                                             March 26 1996

   document.

   pkix  OBJECT IDENTIFIER ::= { 1 3 6 1 5 5 7 }

4.2.2.1  Subject Information Access

   The name information in the certificate identifies the entity to
   which the public key is bound.  In some instances, it may also be
   necessary to know where to find additional information about the
   named entity.  In the case of X.500 names, this relationship is
   automatic.  The subject information access extension provides a means
   of identifying where and how to find information about the subject.
   The extension specifies a method of obtaining information and a
   general name form indicating where.  This extension shall always be
   non-critical.

   id-pkix-subjectInfoAccess OBJECT-IDENTIFIER ::= { pkix 1}

   -- subjectInfoAccess ::=  { SubjectInfoAccessSyntax }

   SubjectInfoAccessSyntax ::= SEQUENCE SIZE (1..MAX) OF AccessDescription

   AccessDescription  ::=  SEQUENCE  {
        subjectInfo        GeneralName  }

   The subjectInfo field(s) contains a URI that describes the location,
   basic format, and access scheme for the additional information on the
   subject.  The URI must contain an absolute pathname and the host.
   This specification recognizes the following values for the URI
   scheme:  ftp, http, ldap, and mailto.  The mailto scheme indicates
   that mail sent to the specified address will generate an electronic
   mail response (to the sender) containing the subject information.  No
   message is required.

   If the URI scheme is ftp, then the information is available through
   anonymous ftp.  If the URI scheme is http or ldap, then the
   information may be retrieved using that protocol.

4.2.2.2  Authority Information Access

   The authority information access extension indicates how to access CA
   information and services for the issuer of the certificate in which
   the extension appears.  Information and services include certificate
   status or on-line validation services, certificate retrieval, CA
   policy data, and CA certificates (certificates certifying the target
   CA to aid in certification path navigation).  This extension may be
   included in subject or CA certificates and is always non-critical.

Housley, Ford, Polk, & Solo                                    [Page 27]

INTERNET DRAFT                                             March 26 1996

   id-pkix-authorityInfoAccess OBJECT-IDENTIFIER ::= { pkix 2 }

   -- authorityInfoAccess ::=  { AuthorityInfoAccessSyntax  }

   AuthorityInfoAccessSyntax  ::=  SEQUENCE  {
        authorityInfo     [0] SEQUENCE OF GeneralName OPTIONAL,
        certStatus        [1] SEQUENCE OF GeneralName OPTIONAL }

   If certStatus is present, each entry in that sequence describes a
   mechanism and location for on-line verification of the status of this
   certificate.

   If authorityInfo is present, each entry in the sequence describes how
   to retrieve additional information about the CA who issued the
   certificate in which this extension appears.

   If the certStatus sequence has more than one value, conforming
   applications are not required to process all the values. Successful
   connection and querying of one on-line validation service shall be
   sufficient.  It is the responsibility of the certificate issuer to
   ensure all mechanisms provide the same information.

   The expected values for CertStatus and authorityInfo are those
   defined in 4.2.2.1 for subjectInfo field. Processing rules for other
   values for certStatus and authorityInfo are not defined.

5  CRL and CRL Extensions Profile

   As described above, one goal of this X.509 v2 CRL profile is to
   foster the creation of an interoperable and reusable Internet PKI.
   To achieve this goal, guidelines for the use of extensions are
   specified, and some assumptions are made about the nature of
   information included in the CRL.

   CRLs may be used in a wide range of applications and environments
   covering a broad spectrum of interoperability goals and an even
   broader spectrum of operational and assurance requirements.  This
   profile establishes a common baseline for generic applications
   requiring broad interoperability.  Emphasis is placed on support for
   X.509 v2 CRLs.  The profile defines a baseline set of information
   that can be expected in every CRL.  Also, the profile defines common
   locations within the CRL for frequently used attributes, and common
   representations for these attributes.

   This profile does not define any private Internet CRL extensions or
   CRL entry extensions.

   Environments with additional or special purpose requirements may

Housley, Ford, Polk, & Solo                                    [Page 28]

INTERNET DRAFT                                             March 26 1996

   build on this profile or may replace it.

   Conforming CAs are not required to issue CRLs if other revocation or
   status mechanisms are provided.  Conforming CAs that issue CRLs are
   required to issue version 2 CRLs.  Conforming applications are
   required to process version 1 and 2 certificates.

5.1  CRL Fields

   The X.509 v2 CRL syntax is as follows.  For signature calculation,
   the data that is to be signed is ASN.1 DER encoded.  ASN.1 DER
   encoding is a tag, length, value encoding system for each element.

   CertificateList  ::=  SEQUENCE  {
        tbsCertList          TBSCertList,
        signatureAlgorithm   AlgorithmIdentifier,
        signature            BIT STRING  }

   TBSCertList  ::=  SEQUENCE  {
        version                 Version OPTIONAL,
                                     -- if present, must be v2
        signature               AlgorithmIdentifier,
        issuer                  Name,
        thisUpdate              ChoiceOfTime,
        nextUpdate              ChoiceOfTime,
        revokedCertificates     SEQUENCE OF SEQUENCE  {
             userCertificate         CertificateSerialNumber,
             revocationDate          ChoiceOfTime,
             crlEntryExtensions      Extensions OPTIONAL
                                                 -- if present, must be v2
                                  }  OPTIONAL,
        crlExtensions           [0]  EXPLICIT Extensions OPTIONAL
                                                 -- if present, must be v2
                                  }

   ChoiceOfTime ::= CHOICE {
        utcTime        UTCTime,
        generalTime    GeneralizedTime }

   Version  ::= INTEGER  {  v1(0), v2(1), v3(2)  }

   AlgorithmIdentifier  ::=  SEQUENCE  {
        algorithm               OBJECT IDENTIFIER,
        parameters              ANY DEFINED BY algorithm OPTIONAL  }
                                     -- contains a value of the type
                                     -- registered for use with the
                                     -- algorithm object identifier value

Housley, Ford, Polk, & Solo                                    [Page 29]

INTERNET DRAFT                                             March 26 1996

   CertificateSerialNumber  ::=  INTEGER

   Extensions  ::=  SEQUENCE OF Extension

   Extension  ::=  SEQUENCE  {
        extnId                  OBJECT IDENTIFIER,
        critical                BOOLEAN DEFAULT FALSE,
        extnValue               OCTET STRING  }
                                     -- contains a DER encoding of a value
                                     -- of the type registered for use with
                                     -- the extnId object identifier value

   The following items describe the proposed use of the X.509 v2 CRL in
   the Internet PKI.

5.1.1  CertificateList Fields

   The CertificateList is a SEQUENCE of three required fields. The
   fields are are described in detail in the following subsections

5.1.1.1  tbsCertList

   The first field in the sequence is the tbsCertList.  This is a itself
   a sequence, and is generally thought of as the X.509 CRL. It contains
   the names of the subject and issuer, a public key associated with the
   subject an expiration date, and other associated information.  The
   fields of the basic tbsCertificate are described in detail in section
   4.1.2; the tbscertificate may also include extensions which are
   described in section 4.2.

5.1.1.2  signatureAlgorithm

   The signatureAlgorithm field contains the algorithm identifier for
   the algorithm used by the CA to sign the CertificateList.  Section
   7.2 lists the supported signature algorithms.

5.1.1.3  signature

   The signature field contains a digital signature computed upon the
   ASN.1 DER encoded TBSCertList.  The ASN.1 DER encoded  TBSCertificate
   is used as the input to a one-way hash function.  The one-way hash
   function output value is ASN.1 encoded as an OCTET STRING and the
   result is encrypted (e.g., using RSA Encryption) to form the signed
   quantity.  This signature value is then ASN.1 encoded as a BIT STRING
   and included in the Certificate's signature field.

Housley, Ford, Polk, & Solo                                    [Page 30]

INTERNET DRAFT                                             March 26 1996

5.1.2  Certificate List "To Be Signed"

   The certificate list to be signed, or tBSCertList, is a SEQUENCE of
   required and optional fields.  The required fields identify the CRL
   issuer, the algorithm used to sign the CRL, the date and time the CRL
   was issued, and the date and time by which the CA will issue the next
   CRL.

   Optional fields include lists of revoked certificates and CRL
   extensions.  The revoked certificate list is optional to support the
   special case where a CA has not revoked any unexpired certificates it
   has issued.  It is expected that nearly all CRLs issued in the
   Internet PKI will contain one or more lists of revoked certificates.
   Similarly, the profile requires conforming CAs to use of one CRL
   extension (CRL number) in all CRLs issued.

5.1.2.1  Version

   This field describes the version of the encoded CRL.  When extensions
   are used, as expected in this profile, use version 2 (the integer
   value is 1).  If neither CRL extensions nor CRL entry extensions are
   present, version 1 CRLs are recommended (e.g., the integer value
   should be omitted).

5.1.2.2  Signature

   This field contains the algorithm identifier for the algorithm used
   to sign the CRL.  Section 7.2 lists the signature algorithms used in
   the Internet PKI.

5.1.2.3  Issuer Name

   The issuer name identifies the entity who has signed (and issued the
   CRL).  The issuer identity may be carried in the issuer name field
   and/or the issuerAltName extension.  If identity information is
   present only in the issuerAltName extension, then the issuer name may
   be an empty sequence and the issuerAltName extension must be
   critical.

5.1.2.4  This Update

   This field indicates the issue date of this CRL. ThisUpdate may be
   encoded as UTCTime or GeneralizedTime.

   CAs conforming to this profile that issue CRLs shall encode
   thisUpdate as UTCTime for dates through the year 2049 as UTCTime. CAs
   conforming to this profile that issue CRLs shall encode thisUpdate as
   GeneralizedTime for dates in the year 2050 or later.

Housley, Ford, Polk, & Solo                                    [Page 31]

INTERNET DRAFT                                             March 26 1996

   Where encoded as UTCTime, thisUpdate shall be specified and
   interpreted as defined in Section 4.1.2.5.1.  Where encoded as
   GeneralizedTime, thisUpdate shall be specified and interpreted as
   defined in Section 4.1.2.5.2.

5.1.2.5  Next Update

   This field indicates the date by which the next CRL will be issued.
   The next CRL could be issued before the indicated date, but it will
   not be issued any later than the indicated date. nextUpdate may be
   encoded as UTCTime or GeneralizedTime.

   CAs conforming to this profile that issue CRLs shall encode
   nextUpdate as UTCTime for dates through the year 2049 as UTCTime. CAs
   conforming to this profile that issue CRLs shall encode nextUpdate as
   GeneralizedTime for dates in the year 2050 or later.

   Where encoded as UTCTime, nextUpdate shall be specified and
   interpreted as defined in Section 4.1.2.5.1.  Where encoded as
   GeneralizedTime, nextUpdate shall be specified and interpreted as
   defined in Section 4.1.2.5.2.

5.1.2.6  Revoked Certificates

   Revoked certificates are listed.  The revoked certificates are named
   by their serial numbers.  Certificates are uniquely identified by the
   combination of the issuer name or issuer alternative name along with
   the user certificate serial number.  The date on which the revocation
   occurred is specified.  The time for revocationDate shall be
   expressed as described in section 5.1.2.4. Additional information may
   be supplied in CRL entry extensions; CRL entry extensions are
   discussed in section 5.3.

5.2  CRL Extensions

   The extensions defined by ANSI X9 and ISO for X.509 v2 CRLs [X.509-
   AM] [X9.55] provide methods for associating additional attributes
   with CRLs.  The X.509 v2 CRL format also allows communities to define
   private extensions to carry information unique to those communities.
   Each extension in a CRL may be designated as critical or non-
   critical.  A CRL validation must fail if it encounters an critical
   extension which it does not know how to process.  However, an
   unrecognized non-critical extension may be ignored.  The following
   presents those extensions used within Internet CRLs.  Communities may
   elect to include extensions in CRLs which are not defined in this
   specification. However, caution should be exercised in adopting any
   critical extensions in CRLs which might be used in a general context.

Housley, Ford, Polk, & Solo                                    [Page 32]

INTERNET DRAFT                                             March 26 1996

   Conforming CAs that issue CRLs are required to support the CRL number
   extension (5.2.3), and include it in all CRLs issued. Conforming
   applications are required to support the critical and optionally
   critical CRL extensions issuer alternative name (5.2.2), issuing
   distribution point (5.2.4) and delta CRL indicator (5.2.5).

5.2.1  Authority Key Identifier

   The authority key identifier extension provides a means of
   identifying the particular public key used to sign a CRL.  The
   identification can be based on either the key identifier (the subject
   key identifier in the CRL signer's certificate) or on the issuer name
   and serial number.  The key identifier method is recommended in this
   profile.  This extension would be used where an issuer has multiple
   signing keys, either due to multiple concurrent key pairs or due to
   changeover.  In general, this non-critical extension should be
   included in certificates.

   The syntax for this CRL extension is defined in Section 4.2.1.1.

5.2.2  Issuer Alternative Name

   The issuer alternative names extension allows additional identities
   to be associated with the issuer of the CRL.  Defined options include
   an rfc822 name (electronic mail address), a DNS name, an IP address,
   and a URI.  Multiple instances of a name and multiple name forms may
   be included.  Whenever such identities are used, the issuer
   alternative name extension shall be used.

   Further, if the only issuer identity included in the CRL is an
   alternative name form (e.g., an electronic mail address), then the
   issuer distinguished name should be empty (an empty sequence), the
   issuerAltName extension should be used, and the issuerAltName
   extension must be marked critical. If more than one issuerAltName
   extension appears in the CRL and the issuer distinguished name is
   empty, exactly one issuerAltName extension must be marked critical.

   The object identifier and syntax for this CRL extension are defined
   in Section 4.2.1.8.

5.2.3  CRL Number

   The CRL number is a non-critical CRL extension which conveys a
   monotonically increasing sequence number for each CRL issued by a
   given CA through a specific CA X.500 Directory entry or CRL
   distribution point.  This extension allows users to easily determine
   when a particular CRL supercedes another CRL.  CAs conforming to this
   profile shall include this extension in all CRLs.

Housley, Ford, Polk, & Solo                                    [Page 33]

INTERNET DRAFT                                             March 26 1996

   id-ce-cRLNumber OBJECT IDENTIFIER ::= { id-ce 20 }

   cRLNumber ::= INTEGER (0..MAX)

5.2.4  Issuing Distribution Point

   The issuing distribution point is a critical CRL extension that
   identifies the CRL distribution point for a particular CRL, and it
   indicates whether the CRL covers revocation for end entity
   certificates only, CA certificates only, or a limitied set of reason
   codes.  Since this extension is critical, all certificate users must
   be prepared to receive CRLs with this extension.

   The CRL is signed using the CA's private key.  CRL Distribution
   Points do not have their own key pairs.  If the CRL is stored in the
   X.500 Directory, it is stored in the Directory entry corresponding to
   the CRL distribution point, which may be different that the Directory
   entry of the CA.

   CRL distribution points, if used by a CA, should be partition the CRL
   on the basis of compromise and routine revocation.  That is, the
   revocations with reason code keyCompromise (1) shall appear in one
   distribution point, and the revocations with other reason codes shall
   appear in another distribution point.

   Where the issuingDistributionPoint extension contains a URL, this
   name the following semantics shall be assumed: the object is a
   pointer to the most current CRL issued by this CA.  The URI schemes
   ftp, http, mailto [RFC1738] and ldap [RFC1778] are defined for this
   purpose.  The URI must be an absolute, not relative, pathname and
   must specify the host.

   id-ce-issuingDistributionPoint OBJECT IDENTIFIER ::= { id-ce 28 }

   issuingDistributionPoint ::= SEQUENCE {
        distributionPoint       [0] DistributionPointName OPTIONAL,
        onlyContainsUserCerts   [1] BOOLEAN DEFAULT FALSE,
        onlyContainsCACerts     [2] BOOLEAN DEFAULT FALSE,
        onlySomeReasons         [3] ReasonFlags OPTIONAL,
        indirectCRL             [4] BOOLEAN DEFAULT FALSE }

5.2.5  Delta CRL Indicator

   The delta CRL indicator is a critical CRL extension that identifies a
   delta-CRL.  The use of delta-CRLs can significantly improve
   processing time for applications which store revocation information
   in a format other than the CRL structure.  This allows changes to be
   added to the local database while ignoring unchanged information that

Housley, Ford, Polk, & Solo                                    [Page 34]

INTERNET DRAFT                                             March 26 1996

   is already in the local databse.

   When a delta-CRL is issued, the CAs shall also issue a complete CRL.

   The value of BaseCRLNumber identifies the CRL number of the base CRL
   that was used as the starting point in the generation of this delta-
   CRL.  The delta-CRL contains the changes between the base CRL and the
   current CRL issued along with the delta-CRL.  It is the decision of a
   CA as to whether to provide delta-CRLs.  Again, a delta-CRL shall not
   be issued without a corresponding CRL.  The value of CRLNumber for
   both the delta-CRL and the corresponding CRL shall be identical.

   A CRL user constructing a locally held CRL from delta-CRLs shall
   consider the constructed CRL incomplete and unusable if the CRLNumber
   of the received delta-CRL is more that one greater that the CRLnumber
   of the delta-CRL last processed.

   id-ce-deltaCRLIndicator OBJECT IDENTIFIER ::= { id-ce 27 }

   deltaCRLIndicator ::= BaseCRLNumber

   BaseCRLNumber ::= CRLNumber

5.3  CRL Entry Extensions

   The CRL entry extensions already defined by ANSI X9 and ISO for X.509
   v2 CRLs [X.509-AM] [X9.55] provide methods for associating additional
   attributes with CRL entries.  The X.509 v2 CRL format also allows
   communities to define private CRL entry extensions to carry
   information unique to those communities.  Each extension in a CRL
   entry may be designated as critical or non-critical.  A CRL
   validation must fail if it encounters a critical CRL entry extension
   which it does not know how to process.  However, an unrecognized
   non-critical CRL entry extension may be ignored.  The following
   presents recommended extensions used within Internet CRL entries and
   standard locations for information.  Communities may elect to use
   additional CRL entry extensions; however, caution should be exercised
   in adopting any critical extensions in CRL entries which might be
   used in a general context.

   All CRL entry extensions are non-critical; support for these
   extensions is optional for conforming CAs and applications.  However,
   CAs that issue CRLs are strongly encouraged to include reason codes
   (5.3.1) whenever this information is available.

Housley, Ford, Polk, & Solo                                    [Page 35]

INTERNET DRAFT                                             March 26 1996

5.3.1  Reason Code

   The reasonCode is a non-critical CRL entry extension that identifies
   the reason for the certificate revocation. CAs are strongly
   encouraged to include reason codes in CRL entries; however, the
   reason code CRL entry extension should be absent instead of using the
   unspecified (0) reasonCode value.

   id-ce-cRLReason OBJECT IDENTIFIER ::= { id-ce 21 }

   -- reasonCode ::= { CRLReason }

   CRLReason ::= ENUMERATED {
        unspecified             (0),
        keyCompromise           (1),
        cACompromise            (2),
        affiliationChanged      (3),
        superseded              (4),
        cessationOfOperation    (5),
        certificateHold         (6),
        removeFromCRL           (8) }

5.3.2  Hold Instruction Code

   The hold instruction code is a non-critical CRL entry extension that
   provides a registered instruction identifier which indicates the
   action to be taken after encountering a certificate that has been
   placed on hold.

   id-ce-holdInstructionCode OBJECT IDENTIFIER ::= { id-ce 23 }

   holdInstructionCode ::= OBJECT IDENTIFIER

   The following instruction codes have been defined.  Conforming applications
   that process this extension shall recognize the following instruction codes.

   holdInstruction    OBJECT IDENTIFIER ::=
                          { iso(1) member-body(2) us(840) x9-57(10040) 2 }

   id-holdinstruction-none       OBJECT IDENTIFIER ::= {holdInstruction 1}
   id-holdinstruction-callissuer OBJECT IDENTIFIER ::= {holdInstruction 2}
   id-holdinstruction-reject     OBJECT IDENTIFIER ::= {holdInstruction 3}

   Conforming applications which encounter a id-holdinstruction-
   callissuer must call the certificate issuer or reject the
   certificate.  Conforming applications which encounter a id-
   holdinstruction-reject ID shall reject the transaction. id-
   holdinstruction-none is semantically equivalent to the absence of a

Housley, Ford, Polk, & Solo                                    [Page 36]

INTERNET DRAFT                                             March 26 1996

   holdInstructionCode.  Its use is strongly deprecated for the Internet
   PKI.

5.3.3  Invalidity Date

   The invalidity date is a non-critical CRL entry extension that
   provides the date on which it is known or suspected that the private
   key was compromised or that the certificate otherwise became invalid.
   This date may be earlier than the revocation date in the CRL entry,
   but it must be later than the issue date of the previously issued
   CRL.  Remember that the revocation date in the CRL entry specifies
   the date that the CA revoked the certificate.  Whenever this
   information is available, CAs are strongly encouraged to share it
   with CRL users.

   The GeneralizedTime values included in this field shall be expressed
   in Greenwich Mean Time (Zulu), and shall be specified and interpreted
   as defined in Section 4.1.2.5.2.

   id-ce-invalidityDate OBJECT IDENTIFIER ::= { id-ce 24 }

   invalidityDate ::=  GeneralizedTime

6  Certificate Path Validation

   Certification path validation procedures for the Internet PKI are
   based on Section 12.4.3 of [X.509-AM].

   Certification path processing verifies the binding between the
   subject distinguished name and subject public key.  The basic
   constraints and policy constraints extensions facilitate automated,
   self-contained implementation of certification path processing logic.

   The following is an outline of a procedure for validating
   certification paths.  An implementation shall be functionally
   equivalent to the external behaviour resulting from this procedure.
   Any algorithm may be used by a particular implementation so long as
   it derives the correct result.

   The inputs to the certification path processing procedure are:

      (a)  a set of certificates comprising a certification path;

      (b)  a CA name and trusted public key value (or an identifier of
      such a key if the key is stored internally to the certification
      path processing module) for use in verifying the first certificate
      in the certification path;

Housley, Ford, Polk, & Solo                                    [Page 37]

INTERNET DRAFT                                             March 26 1996

      (c)  a set of initial-policy identifiers (each comprising a
      sequence of policy element identifiers), which identifies one or
      more certificate policies, any one of which would be acceptable
      for the purposes of certification path processing; and

      (d)  the current date/time (if not available internally to the
      certification path processing module).

   The outputs of the procedure are:

      (a)  an indication of success or failure of certification path
      validation;

      (b)  if validation failed, a reason for failure; and

      (c)  if validation was successful, a (possibly empty) set of
      policy qualifiers obtained from CAs on the path.

   The procedure makes use of the following set of state variables:

      (a)  acceptable policy set:  A set of certificate policy
      identifiers comprising the policy or policies recognized by the
      public key user together with policies deemed equivalent through
      policy mapping;

      (b)  constrained subtrees:  A set of root names defining a set of
      subtrees within which all subject names in subsequent certificates
      in the certification path shall fall; if no restriction is in
      force this state variable takes the special value unbounded; and

      (c)  excluded subtrees:  A set of root names defining a set of
      subtrees within which no subject name in subsequent certificates
      in the certification path may fall; if no restriction is in force
      this state variable takes the special value empty.

      The procedure involves an initialization step, followed by a
      series of certificate-processing steps.  The initialization step
      comprises:

      (a)  Initialize the constrained subtress to unbounded;

      (b)  Initialize the excluded subtrees indicator to empty; and

      (c)  Initialize the acceptable policy set to the set of initial-
      policy identifiers.

   Each certificate is then processed in turn, starting with the
   certificate signed using the trusted CA public key which was input to

Housley, Ford, Polk, & Solo                                    [Page 38]

INTERNET DRAFT                                             March 26 1996

   this procedure.  The last certificate is processed as an end-entity
   certificate; all other certificates (if any) are processed as CA-
   certificates.

   The following checks are applied to all certificates:

      (a)  Check that the signature verifies, that dates are valid, that
      the subject and issuer names chain correctly, and that the
      certificate has not been revoked;

      If the certificate has an empty sequence in the name field, name
      chaining will use the critical altSubjectNames and altIssuerNames
      fields. If the certificate has a critical authorityInfoAccess or
      caInfoAccess extension, the information in that extension must be
      used to determine the status of the certificates.

      (b)  If a key usage restriction extension is present in the
      certificate and contains a certPolicySet component, check that at
      least one member of the acceptable policy set appears in the
      field;

      (c)  Check that the subject name or critical AltSubjectName
      extension is consistent with the constrained subtrees state
      variables; and

      (d)  Check that the subject name or critical AltSubjectName
      extension is consistent with the excluded subtrees state
      variables.

   If any one of the above checks fails, the procedure terminates,
   returning a failure indication and an appropriate reason.  If none of
   the above checks fail on the end-entity certificate, the procedure
   terminates, returning a success indication together with the set of
   all policy qualifier values encountered in the set of certificates.

   For a CA-certificate, the following constraint recording actions are
   then performed, in order to correctly set up the state variables for
   the processing of the next certificate:

      (a)  If permittedSubtrees is present in the certificate, set the
      constrained subtrees state variable to the intersection of its
      previous value and the value indicated in the extension field.

      (b)  If excludedSubtrees is present in the certificate, set the
      excluded subtrees state variable to the union of its previous
      value and the value indicated in the extension field.

      Note:  It is possible to specify an extended version of the above

Housley, Ford, Polk, & Solo                                    [Page 39]

INTERNET DRAFT                                             March 26 1996

      certification path processing procedure which results in default
      behaviour identical to the rules of Privacy Enhanced Mail [RFC
      1422].  In this extended version, additional inputs to the
      procedure are a list of one or more Policy Certification Authority
      (PCA) names and an indicator of the position in the certification
      path where the PCA is expected.  At the nominated PCA position,
      the CA name is compared against this list.  If a recognized PCA
      name is found, then a constraint of SubordinateToCA is implicitly
      assumed for the remainder of the certification path and processing
      continues.  If no valid PCA name is found, and if the
      certification path cannot be validated on the basis of identified
      policies, then the certification path is considered invalid.

7  Algorithm Support

   This section describes cryptographic algorithms which may be used
   with this standard.  The section describes one-way hash functions and
   digital signature algorithms which may be used to sign certificates
   and CRLs, and identifies object identifiers for public keys contained
   in a certificate.

   Conforming CAs and applications are not required to support the
   algorithms or algorithm identifiers described in this section.
   However, this profile requires conforming CAs and applications to
   conform when they use the algorithms identified here.

7.1  One-way Hash Functions

   This section identifies one-way hash functions for use in the
   Internet PKI.  One-way hash functions are also called message digest
   algorithms. SHA-1 is the preferred one-way hash function for the
   Internet PKI.  However, PEM uses MD2 for certificates [RFC 1422] [RFC
   1423].  For this reason, MD2 is included in this profile.

7.1.1  MD2 One-way Hash Function

   MD2 was developed by Ron Rivest, but RSA Data Security has not placed
   the MD2 algorithm in the public domain.  Rather, RSA Data Security
   has granted license to use MD2 for non-commerical Internet Privacy-
   Enhanced Mail.  For this reason, MD2 may continue to be used with PEM
   certificates, but SHA-1 is preferred.  MD2 is fully described in RFC
   1319 [RFC 1319].

   At the Selected Areas in Cryptography '95 conference in May 1995,
   Rogier and Chauvaud presented an attack on MD2 that can nearly find
   collisions [RC95].  Collisions occur when two different messages
   generate the same message digest.  A checksum operation in MD2 is the
   only remaining obstacle to the success of the attack.  For this

Housley, Ford, Polk, & Solo                                    [Page 40]

INTERNET DRAFT                                             March 26 1996

   reason, the use of MD2 for new applications is discouraged.  It is
   still reasonable to use MD2 to verify existing signatures, as the
   ability to find collisions in MD2 does not enable an attacker to find
   new messages having a previously computed hash value.

   << More information on the attack and its implications can be
   obtained from a RSA Laboratories security bulletin.  These bulletins
   are available from <http://www.rsa.com/>. >>

7.1.2  SHA-1 One-way Hash Function

   SHA-1 was developed by the U.S. Government.  SHA-1 is fully described
   in FIPS 180-1 [FIPS 180-1].

   SHA-1 is the one-way hash function of choice for use with both the
   RSA and DSA signature algorithms.

7.2  Signature Algorithms

   Certificates and CRLs described by this standard may be signed with
   any public key signature algorithm.  The certificate or CRL indicates
   the algorithm through an algorithmidentifier which appears in the
   signatureAlgorithm field in a Certificate or CertificateList.  This
   algorithmidentfier is an OID and has optionally associated
   parameters.  This section identifies algorithm identifiers and
   parameters that shall be used in the signatureAlgorithm field in a
   Certificate or CertificateList.

   RSA and DSA are the most popular signature algorithms used in the
   Internet.  Signature algorithms are always used in conjunction with a
   one-way hash function identified in Section 7.1.

   The signature algorithm (and one-way hash function) used to sign a
   certificate or CRL is indicated by use of an algorithm identifier.
   An algorithm identifier is an object identifier, and may include
   associated parameters.  This section identifies OIDS for RSA and DSA
   and the corresponding parameters.

   The data to be signed (e.g., the one-way hash function output value)
   is first ASN.1 encoded as an OCTET STRING and the result is encrypted
   (e.g., using RSA Encryption) to form the signed quantity.  This
   signature value is then ASN.1 encoded as a BIT STRING and included in
   the Certificate or CertificateList (in the signature field).

7.2.1  RSA Signature Algorithm

   A patent statement regarding the RSA algorithm can be found at the
   end of this profile.

Housley, Ford, Polk, & Solo                                    [Page 41]

INTERNET DRAFT                                             March 26 1996

   The RSA algorithm is named for it's inventors: Rivest, Shamir, and
   Adleman.  The RSA signature algorithm combines either the MD2 or the
   SHA-1 one-way hash function with the RSA asymmetric encryption
   algorithm.  The RSA signature algorithm with MD2 and the RSA
   encryption algorithm is defined in PKCS #1 [PKCS#1].  As defined in
   PKCS #1, the ASN.1 object identifier used to identify this signature
   algorithm is:

        md2WithRSAEncryption OBJECT IDENTIFIER  ::=  {
            iso(1) member-body(2) US(840) rsadsi(113549) pkcs(1)
            pkcs-1(1) 2  }

   The RSA signature algorithm with SHA-1 and the RSA encryption
   algorithm is defined in by the OSI Interoperability Workshop in [].
   As defined in [OIW], the ASN.1 object identifier used to identify
   this signature algorithm is:

        sha-1WithRSAEncryption OBJECT IDENTIFIER  ::=  {
            iso(1) identified-organization(3) oiw(14)
            secsig(3) algorithm(2) 29  }

   When either of these object identifiers is used within the ASN.1 type
   AlgorithmIdentifier, the parameters component of that type shall be
   the ASN.1 type NULL.

   When signing, the RSA algorithm generates an integer y.  This value
   is converted to a bit string such that the most significant bit in y
   is the first bit in the bit string and the least significant bit in y
   is the last bit in the bit string.

   (In general this occurs in two steps.  The integer y is converted to
   an octect string such that the first octect has the most significance
   and the last octect has the least significance. The octet string is
   converted into a bit string such that the most significant bit of the
   first octect shall become the first bit in the bit string, and the
   least significant bit of the last octect is the last bit in the BIT
   STRING.

7.2.2  DSA Signature Algorithm

   A patent statement regarding the DSA can be found at the end of this
   profile.

   The Digital Signature Algorithm (DSA) is also called the Digital
   Signature Standard (DSS).  DSA was developed by the U.S. Government,
   and DSA is used in conjunction with the the SHA-1 one-way hash
   function.  DSA is fully described in FIPS 186 [FIPS 186].  The ASN.1
   object identifiers used to identify this signature algorithm are:

Housley, Ford, Polk, & Solo                                    [Page 42]

INTERNET DRAFT                                             March 26 1996

           id-dsa-with-sha1 ID  ::=  {
                   iso(1) member-body(2) us(840) x9-57 (10040)
                   x9algorithm(4) 3 }

   The id-dsa-with-sha1 algorithm syntax has NULL parameters. The DSA
   parameters in the subjectPublicKeyInfo field of the certificate of
   the issuer shall apply to the verification of the signature.

   If the subjectPublicKeyInfo AlgorithmIdentifier field has NULL
   parameters and the CA signed the subject certificate using DSA, then
   the certificate issuer's parameters apply to the subject's DSA key.
   If the subjectPublicKeyInfo AlgorithmIdentifier field has NULL
   parameters and the CA signed the subject with a signature algorithm
   other than DSA, then clients shall not validate the certificate.

   When signing, the DSA algorithm generates two values.  These values
   are commonly referred to as r and s.  To easily transfer these two
   values as one signature, they shall be ASN.1 encoded using the
   following ASN.1 structure:

           Dss-Sig-Value  ::=  SEQUENCE  {
                   r       INTEGER,
                   s       INTEGER  }

7.3  Subject Public Key Algorithms

   Certificates described by this standard may convey a public key for
   any public key algorithm. The certificate indicates the algorithm
   through an algorithmidentifier.  This algorithmidentfieier is an OID
   and optionally associated parameters.

   This section identifies preferred OIDs and parameters for the RSA,
   DSA, KEA, and Diffie-Hellman algorithms.  Conforming CAs shall use
   the identified OIDs when issuing certificates containing public keys
   for these algorithms. Conforming applications supporting any of these
   algorithms shall, at a minimum, recognize the OID identified in this
   section.

7.3.1 RSA  Keys

   The object identifier rsaEncryption identifies RSA public keys.

        pkcs-1 OBJECT IDENTIFIER ::= { iso(1) member-body(2) US(840)
                       rsadsi(113549) pkcs(1) 1 }

        rsaEncryption OBJECT IDENTIFIER ::=  { pkcs-1 1}

   The rsaEncryption object identifier is intended to be used in the

Housley, Ford, Polk, & Solo                                    [Page 43]

INTERNET DRAFT                                             March 26 1996

   algorithm field of a value of type AlgorithmIdentifier. The
   parameters field shall have ASN.1 type NULL for this algorithm
   identifier.

   The rsa public key shall be encoded using the ASN.1 type
   RSAPublicKey:

      RSAPublicKey ::= SEQUENCE {
         modulus       INTEGER, -- n
         publicExponent     INTEGER  -- e
                             }

   where modulus is the modulus n, and publicExponent is the public
   exponent e.  The DER encoded RSAPublicKey is  the value of the BIT
   STRING subjectPubliKey.

   This object identifier is used in public key certificates for both
   RSA signature keys and RSA encryption keys. The intended application
   for the key may be indicated in the key usage field (see Section
   4.2.1.3).  The use of a single key for both signature and encryption
   purposes is not recommended, but is not forbidden.

7.3.2 Diffie-Hellman Key Exchange Key

   This diffie-hellman object identifier supported by this standard is
   defined by ANSI X9.42.

        dhpublicnumber OBJECT IDENTIFIER ::= { iso(1) member-body(2)
                  US(840) ansi-x942(10046) number-type(2) 1 }

        DHParameter ::= SEQUENCE {
             prime INTEGER, -- p
             base INTEGER, -- g }

   The dhpublicnumber object identifier is intended to be used in the
   algorithm field of a value of type AlgorithmIdentifier. The
   parameters field of that type, which has the algorithm-specific
   syntax ANY DEFINED BY algorithm, would have ASN.1 type DHParameter
   for this algorithm.

        DHParameter ::= SEQUENCE {
          prime INTEGER, -- p
          base INTEGER, -- g }

   The fields of type DHParameter have the following meanings:

      prime is the prime p.

Housley, Ford, Polk, & Solo                                    [Page 44]

INTERNET DRAFT                                             March 26 1996

      base is the base g.

   The Diffie-Hellman public key (an INTEGER) is mapped to a
   subjectPublicKey (a BIT STRING) as follows: the most significant bit
   (MSB) of the INTEGER becomes the MSB of the BIT STRING; the least
   significant bit (LSB) of the INTEGER becomes the LSB of the BIT
   STRING.

7.3.3 DSA Signature Keys

   The object identifier supported by this standard is

        id-dsa ID ::= { iso(1) member-body(2) us(840) x9-57(10040)
                  x9algorithm(4) 1 }

   The id-dsa algorithm syntax includes optional parameters.  These
   parameters are commonly referred to as p, q, and g.  If the DSA
   algorithm parameters are absent from the subjectPublicKeyInfo
   AlgorithmIdentifier and the CA signed the subject certificate using
   DSA, then the certificate issuer's DSA parameters apply to the
   subject's DSA key.  If the DSA algorithm parameters are absent from
   the subjectPublicKeyInfo AlgorithmIdentifier and the CA signed the
   subject certificate using a signature algorithm other than DSA, then
   the subject's DSA parameters are distributed by other means.  The
   parameters are included using the following ASN.1 structure:

        Dss-Parms  ::=  SEQUENCE  {
            p             INTEGER,
            q             INTEGER,
            g             INTEGER  }

   If the subjectPublicKeyInfo AlgorithmIdentifier field has NULL
   parameters and the CA signed the subject certificate using DSA, then
   the certificate issuer's parameters apply to the subject's DSA key.
   If the subjectPublicKeyInfo AlgorithmIdentifier field has NULL
   parameters and the CA signed the subject with a signature algorithm
   other than DSA, then clients shall not validate the certificate.

   When signing, DSA algorithm generates two values.  These values are
   commonly referred to as r and s.  To easily transfer these two values
   as one signature, they are ASN.1 encoded using the following ASN.1
   structure:

        Dss-Sig-Value  ::=  SEQUENCE  {
            r             INTEGER,
            s             INTEGER  }

   The encoded signature is conveyed as the value of the BIT STRING

Housley, Ford, Polk, & Solo                                    [Page 45]

INTERNET DRAFT                                             March 26 1996

   signature in a Certificate or CertificateList.

   The DSA public key shall be ASN.1 encoded as an INTEGER; this
   encoding shall be used as the contents (i.e., the value) of the
   subjectPublicKey component (a BIT STRING) of the SubjectPublicKeyInfo
   data element.

        DSAPublicKey ::= INTEGER -- public key Y

7.3.4 Key Exchange Algorithm (KEA)

   The Key Exchange Algorithm (KEA) is a classified algorithm for
   exchanging keys.  A KEA "pairwise key" may be generated between two
   users if their KEA public keys were generated with the same KEA
   parameters.  The KEA parameters are not included in a certificate;
   instead a "domain identifier" is supplied in the parameters field.

   When the subjectPublicKeyInfo field contains a KEA key, the algorithm
   identifier and parameters shall be as defined in [sdn.701r]:

      id-keyEncryptionAlgorithm  OBJECT IDENTIFIER   ::=
             { 2 16 840 1 101 2 1 1 22 }

      KEA-Parms-Id     ::= OCTET STRING

   The Kea-Parms-Id shall always appear when the subjectPublicKeyInfo
   field algorithm identifier is id-keyEncryptionAlgorithm. Kea-Parms-Id
   is the "domain identifier" and is ten octets in length. If the Kea-
   Parms-Id of two KEA keys are equivalent, the subjects possess the
   same KEA parameter values and may exchange keys.

   A KEA public key, y, is conveyed in the subjectPublicKey BIT STRING
   such that the most significant bit (MSB) of y becomes the MSB of the
   BIT STRING value field and the least significant bit (LSB) of y
   becomes the LSB of the BIT STRING value field.  This results in the
   following encoding: BIT STRING tag, BIT STRING length, 0 (indicating
   that there are zero unused bits in the final octet of y), BIT STRING
   value field including y.

8. Examples

8.1 Certificate

   This section contains an annotated hex dump of a 675 byte version 3
   certificate.  The certificate contains the following information:
   (a) the serial number is 2;

Housley, Ford, Polk, & Solo                                    [Page 46]

INTERNET DRAFT                                             March 26 1996

   (b) the certificate is signed with RSA and the MD5 hash algorithm;
   (c) the issuer's distinguished name is OU=esCert-
   UPC;O=UPC;L=Barcelona;STREET=Catalunya;C=ES
   (d) and the subject's distinguished name is
   CN=escert.upc.es;OU=esCert-
   UPC;O=UPC;L=Barcelona;STREET=Catalunya;C=ES
   (e) the certificate was issued on May 21, 1996 and will expire on May
   21, 1997;
   (f) the certificate contains a 768 bit RSA public key which is
   intended for generation of digital signatures;
   (g) the certificate is an end entity certificate (not a CA
   certificate);
   (h) the certificate includes two alternative names - an RFC 822
   address, and a URL.

 sequence length 029f=671 bytes
 30 82 02 9f
    sequence length 0208h=520 bytes
    30 82 02 08
       explicit tag 00 "Version"
       a0 03
          integer length 1 value 2 [version is 3]
          02 01 02
       integer length 1 value 2 [serial number 2]
       02 01 02
       sequence length 13 [signature]
       30 0d
          object identifier length 9 {1 2 840 113549 1 1 4}
                                {iso(1) member-body(2) us(840) etc.}
          06 09 2a 86 48 86 f7 0d 01 01 04
          null [null parameters]
          05 00
       sequence length 88 [issuer]
          30 58
             RDN length 11
             31 0b
                sequence length 9
                30 09
                   object identifier length 3  { 2 5 4 6 }
                   06 03 55 04 06
                   printable string length 2 "ES"
                   13 02 45 53
             RDN length 18
             31 12
                sequence length 16
                30 10
                   object identifier length 3 { 2 5 4 9 }
                   06 03 55 04 09

Housley, Ford, Polk, & Solo                                    [Page 47]

INTERNET DRAFT                                             March 26 1996

                   printable string length 9 "Catalunya"
                   13 09 43 61 74 61 6c 75 6e 79 61
             RDN length 18
             31 12
                sequence length 16
                30 10
                   object identifier length 3 { 2 5 4 7 }
                   06 03 55 04 07
                   printable string length 9 "Barcelona"
                   13 09 42 61 72 63 65 6c 6f 6e 61
             RDN length 12
             31 0c
                sequence length 10
                30 0a
                   object identifier {2 5 4 10 }
                   06 03 55 04 0a
                   printable string length 3 "UPC"
                   13 03 55 50 43
             RDN length 19
             31 13
                sequence length 17
                30 11
                   object identifier {2 5 4 13 }
                   06 03 55 04 0b
                   printable string length 10 "esCERT-UPC"
                   13 0a 65 73 43 45 52 54 2d 55 50 43
       sequence length 0x1e= 30
          30 1e
             UTCTime "960521095826Z"
             17 0d 39 36 30 35 32 31 30 39 35 38 32 36 5a
             UTCTime "979521095826Z"
             17 0d 39 37 30 35 32 31 30 39 35 38 32 36 5a
       sequence length
       30 70
          31 0b
             30 09
                { 2 5 4 6 }
                06 03 55 04 06
                "ES"
                13 02 45 53
          RDN
          31 12
             30 10
                { 2 5 4 9 }
                06 03 55 04 09
                "Catalunya"
                13 09 43 61 74 61 6c 75 6e 7961
          RDN

Housley, Ford, Polk, & Solo                                    [Page 48]

INTERNET DRAFT                                             March 26 1996

          31 12
             30 10
                { 2 5 4 7 }
                06 03 55 04 07
                "Barcelona"
                13 09 42 61 72 63 65 6c 6f 6e 61
          RDN
          31 0c
             30 0a
                { 2 5 4 10 }
                06 03 55 04 0a
                "UPC"
                13 03 55 50 43
          RDN
          31 13
             30 11
                { 2 5 4 11 }
                06 03 55 04 0b
                "esCERT-UPC"
                13 0a 65 73 43 45 52 54 2d 55 50 43
          RDN
          31 16
             30 14
                { 2 5 4 3 }
                06 03 55 04 03
                "escert.upc.es"
                13 0d 65 73 63 65 72 74 2e 75 70 63 2e 65 73
        subjectPublicKeyInfo
          30 7c
             algorithmIdentifier
             30 0d
                { 1 2 840 113549 1 1 1}
                06 09 2a 86 48 86 f7 0d 01 01 01
                null parameters
                05 00
             { subject's public key }
             03 6b  BIT STRING length 107 bytes (856 bits)
                               0030 6802 6100 beaa 8b77 54a3 afca 779f
                               2fb0 cf43 88ff a66d 7955 5b61 8c68 ec48
                               1e8a 8638 a4fe 19b8 6217 1d9d 0f47 2cff
                               638f 2991 04d1 52bc 7f67 b6b2 8f74 55c1
                               3321 6c8f ab01 9524 c8b2 7393 9d22 6150
                               a935 fb9d 5750 32ef 5652 5093 abb1 8894
                               7856 15c6 1c8b 0203 0100 01
         explicit tag 3 "extensions" length 0x84=132
         a3 81 84
            sequence 129 bytes
            30 81 81

Housley, Ford, Polk, & Solo                                    [Page 49]

INTERNET DRAFT                                             March 26 1996

               sequence 12 bytes
               30 0b
                  id-ce-keyUsage = { 2 5 29 15 }
                  06 03 55 1d 0f
                  by default, critical = FALSE
                  octect string
                  04 04 03 02 07 80
               30 09
                  id-ce-basicConstraints = { 2 5 29 19 }
                  06 03 55 1d 13
                  by default, critical = FALSE
                  octect string
                  04 02
                     null sequence - by default, subject is end entity
                     30 00
               30 3d
                  id-ce-subjectAltName = { 2 5 29 17 }
                  06 03 55 1d 11
                  by default, critical = FALSE
                  octect string
                  04 36
                     30 34
                        rfc822name
                        a1 1a
                           IA5String "[email-masked]"
                           16 18 65 73 63 65 72 74 2d 75 70 63 40 65 73 63
                           65 72 74 2e 75 70 63 2e 65 73
                        uniformResourceIdentifier
                        a6 16
                           IA5String "http://escert.upc.es"
                           16 14 68 74 74 70 3a 2f 2f 65 73 63 65 72 74 2e
                           75 70 63 2e 65 73
               30 28
                  id-ce-certificatePolicies = { 2 5 29 32 }
                  06 03 55 1d 20
                  by default, critical = FALSE
                  octect string
                  04 21
                     30 1f
                        30 1d
                           06 04 2a 84 80 00
                           { 2 2 32768 }
                     30 15
                        30 07
                           { 2 2 32768 1 }
                           06 05 2a 84 80 00 01
                         30 0a
                            { 2 2 32768 2 }

Housley, Ford, Polk, & Solo                                    [Page 50]

INTERNET DRAFT                                             March 26 1996

                            06 05 2a 84 80 00 02
                            02 01 0a
   sequence
   30 0d
      { 1 2 840 113549 1 1 4 }
      06 09 2a 86 48 86 f7 0d 01 01 04
      null parameters
      05 00
   bit string length 129  (signature)
   03 81 81 005b fdc2 a704 d483 4e17 6da6 fa27 e7c6
            f8ab b95d 9fd0 a1df d797 9fe0 20a6 c57a
            64cd 522f e9ae dabe 9ce4 d597 edf1 84c0
            d0fe 9bef 54b1 80e5 bf3c c9ed 9320 2d52
            21e9 bcb9 e34f ac11 650e 8fa1 6899 6347
            e53d e442 7313 fac5 c834 8cc0 4118 89d5
            e6a0 185b 5d86 1c1e c670 d80e 8964 9483
            8e3b 407c 59cf 2b2f b7ce 9798 1215 ef13
            d4

8.2 Certificate Revocation List

   This section contains an annotated hex dump of a version 2 CRL with
   one extension (cRLNumber). The CRL was issued by OU=ac;O=upc;C=es on
   July 7, 1996; the next scheduled issuance was August 7, 1996.  The
   CRL includes two revoked certificates: serial numbers 256 and 257.
   The CRL itself is number 3, and it was signed with RSA and MD5.

   TBSCertList
   30 82 01 07
    CertList
    30 81 b2
     version 2 CRL
     02 01 01
     signature
     30 0d
           object identifier RSAEncryptionwithMD5
           06 09 2a 8648 86f7 0d01 0104
           null (parameters)
           05 00
         sequence length 0x28
         30 28     issuer distinguished name
            RDN C=es
            31 0b
               30 09
                  object identifier { 2 5 4 6 }
                  06 03 55 04 06

Housley, Ford, Polk, & Solo                                    [Page 51]

INTERNET DRAFT                                             March 26 1996

                  printable string "es"
                  13 02 65 73
            RDN O=upc
            31 0c
               sequence
               30 0a
                  object identifier { 2 5 4 10 }
                  06 03 55 04 0a
                  printable string "upc"
                  13 03 75 70 63
            RDN
            31 0b OU=ac
               sequence
               30 09
                  06 03 55 04 0b { 2 5 4 11 }
                  printable string "ac"
                  13 02 61 63
          this update July 7, 1996
          17 0d 39 36 30 37 30 37 31 37 31 38 31 35 5a
          next update August 7, 1996
          17 0d 39 36 30 38 30 37 31 37 31 38 31 35 5a
       30 46
          30 21
             serial number 256
             02 02 01 00
             revocation date "960630171815Z"
             17 0d 39 36 30 36 33 30 31 37 31 38 31 35 5a
             30 0c
                30 0a
                   id-ce-reasonCode
                   { 2 5 77 21 }
                   06 03 55 1d 15
                   octet string 0x0a0140
                   04 03 0a 01 40
          30 21
             serial number 257
             02 02 01 01
             revocation date "960706171815Z"
             17 0d 39 36 30 37 30 36 31 37 31 38 31 35 5a
             30 0c
                30 0a
                   id-ce-reasonCode
                   { 2 5 77 21 }
                   06 03 55 1d 15
                   octet string 0x0a0110
                   04 03 0a 01  00
      private tag 0 "extensions"
      a0 0e

Housley, Ford, Polk, & Solo                                    [Page 52]

INTERNET DRAFT                                             March 26 1996

      sequence
      30 0c
         30 0a
            id-ce-cRLNumber = { 2 5 77 20 }
            06 03 55 1d 14
            by default, critical = FALSE
            octet string
            04 03
               integer = 3
               02 01 03
      30 0d
         { 1 2 840 113549 1 1 4 }
         06 09 2a 86 48 86 f7 0d 01 01 04
         null parameters
         05 00
      03 41 0029 23be 84e1 6cd6 ae52 9049 f1f1 bbe9
            ebb3 a6db 3c87 0c3e 9924 5e0d 1c06 b747
            deb3 124d c843 bb8b a61f 035a 7d09 3825
            1f5d d4cb fc96 f545 3b13 0d89 0a1c dbae
            32

9. ASN.1 Structures and OIDs

   PKIX1 DEFINITIONS IMPLICIT TAGS::=

   BEGIN

   -- UNIVERSAL Types defined in '93 ASN.1
   -- but required by this specification

   UniversalString [UNIVERSAL 28] IMPLICIT OCTET STRING
           -- UniversalString is defined in ASN.1:1993
   BMPString ::= [UNIVERSAL 30] IMPLICIT OCTET STRING
           -- BMPString is the subtype of
           -- UniversalString and models the Basic Multilingual Plane
           -- of ISO/IEC 10646-1

   -- attribute data types --

   Attribute       ::=     SEQUENCE {
           type    AttributeValue,
           values  SET OF AttributeValue
                   -- at least one value is required -- }

Housley, Ford, Polk, & Solo                                    [Page 53]

INTERNET DRAFT                                             March 26 1996

   AttributeType           ::=     OBJECT IDENTIFIER

   AttributeValue          ::=     ANY

   AttributeTypeAndValue           ::=     SEQUENCE {
           type    AttributeType,
           value   AttributeValue }

   AttributeValueAssertion ::=     SEQUENCE {AttributeType, AttributeValue}

   -- naming data types --

   Name            ::=     CHOICE { -- only one possibility for now --
                                                   rdnSequence  RDNSequence }

   RDNSequence     ::=     SEQUENCE OF RelativeDistinguishedName

   DistinguishedName       ::=     RDNSequence

   RelativeDistinguishedName  ::=  SET SIZE (1 .. MAX) OF AttributeTypeAndValue

   -- Directory string type --

   DirectoryString ::= CHOICE {
           teletexString           TeletexString (SIZE (1..maxSize)),
           printableString         PrintableString (SIZE (1..maxSize)),
           universalString         UniversalString (SIZE (1..maxSize))
                                                }

   -- certificate and CRL specific structures begin here

   Certificate  ::=  SEQUENCE  {
        tbsCertificate       TBSCertificate,
        signatureAlgorithm   AlgorithmIdentifier,
        signature            BIT STRING  }

   TBSCertificate  ::=  SEQUENCE  {
        version         [0]  EXPLICIT Version DEFAULT v1,
        serialNumber         CertificateSerialNumber,
        signature            AlgorithmIdentifier,
        issuer               Name,
        validity             Validity,
        subject              Name,
        subjectPublicKeyInfo SubjectPublicKeyInfo,
        issuerUniqueID  [1]  UniqueIdentifier OPTIONAL,
                             -- If present, version must be v2 or v3
        subjectUniqueID [2]  UniqueIdentifier OPTIONAL,
                             -- If present, version must be v2 or v3

Housley, Ford, Polk, & Solo                                    [Page 54]

INTERNET DRAFT                                             March 26 1996

        extensions      [3]  EXPLICIT Extensions OPTIONAL
                             -- If present, version must be v3
        }

   Version  ::=  INTEGER  {  v1(0), v2(1), v3(2)  }

   CertificateSerialNumber  ::=  INTEGER

   Validity ::= SEQUENCE {
        notBefore      CertificateValidityDate,
        notAfter       CertificateValidityDate }

   CertificateValidityDate ::= CHOICE {
        utcTime        UTCTime,
        generalTime    GeneralizedTime }

   UniqueIdentifier  ::=  BIT STRING

   SubjectPublicKeyInfo  ::=  SEQUENCE  {
        algorithm            AlgorithmIdentifier,
        subjectPublicKey     BIT STRING  }

   Extensions  ::=  SEQUENCE OF Extension

   Extension  ::=  SEQUENCE  {
        extnID      OBJECT IDENTIFIER,
        critical    BOOLEAN DEFAULT FALSE,
        extnValue   OCTET STRING  }

   -- Extension ::= { {id-ce 15}, ... , keyUsage }

   ID                  ::=  OBJECT IDENTIFIER
   joint-iso-ccitt     ID   ::=  { 2 }
   ds             ID   ::=  {joint-iso-ccitt 5}
   certificateExtension  ID ::=  {ds 29}
   -- id-ce          ID   ::=  certificateExtension
   id-ce          ID   ::= {ds 29}

   AuthorityKeyIdentifier ::= SEQUENCE {
         keyIdentifier                   [0] KeyIdentifier               OPTIONAL,
         authorityCertIssuer             [1] GeneralNames                OPTIONAL,
         authorityCertSerialNumber       [2] CertificateSerialNumber     OPTIONAL
     }
          ( WITH COMPONENTS       {..., authorityCertIssuer PRESENT,
                                          authorityCertSerialNumber PRESENT} |
           WITH COMPONENTS        {..., authorityCertIssuer ABSENT,
                                          authorityCertSerialNumber ABSENT} )

Housley, Ford, Polk, & Solo                                    [Page 55]

INTERNET DRAFT                                             March 26 1996

   -- authorityKeyIdentifier ::= AuthorityKeyIdentifier

   KeyIdentifier ::= OCTET STRING

   -- subjectKeyIdentifier ::= KeyIdentifier

   KeyUsage ::= BIT STRING {
        digitalSignature        (0),
        nonRepudiation          (1),
        keyEncipherment         (2),
        dataEncipherment        (3),
        keyAgreement            (4),
        keyCertSign             (5),
        cRLSign                 (6) }

   id-ce-privateKeyUsagePeriod OBJECT IDENTIFIER ::=  { id-ce 16 }

   PrivateKeyUsagePeriod ::= SEQUENCE {
        notBefore       [0]     GeneralizedTime OPTIONAL,
        notAfter        [1]     GeneralizedTime OPTIONAL }
        ( WITH COMPONENTS       {..., notBefore PRESENT} |
        WITH COMPONENTS         {..., notAfter PRESENT} )

   id-ce-certificatePolicies OBJECT IDENTIFIER ::=  { id-ce 32 }

   CertificatePolicies ::= SEQUENCE SIZE (1..MAX) OF PolicyInformation

   PolicyInformation ::= SEQUENCE {
        policyIdentifier   CertPolicyId,
        policyQualifiers   SEQUENCE SIZE (1..MAX) OF
                PolicyQualifierInfo OPTIONAL }

   CertPolicyId ::= OBJECT IDENTIFIER

   -- PolicyQualifierInfo ::= SEQUENCE {
   --       policyQualifierId  CERT-POLICY-QUALIFIER.&id
   --                                ({SupportedPolicyQualifiers}),
   --       qualifier          CERT-POLICY-QUALIFIER.&Qualifier
   --
   -- ({SupportedPolicyQualifiers}{@policyQualifierId})
   --                                         OPTIONAL }

   -- SupportedPolicyQualifiers CERT-POLICY-QUALIFIER ::= { ... }

   PolicyQualifierInfo ::= SEQUENCE {
          policyQualifierId  PolicyQualifierId,
          qualifier        ANY DEFINED BY policyQualifierId }

Housley, Ford, Polk, & Solo                                    [Page 56]

INTERNET DRAFT                                             March 26 1996

   PolicyQualifierId ::= ENUMERATED {
           qualId1 (1), qualId2 (2), qualId3 (3), qualId4 (4), qualId5 ( 5 ) }

   id-ce-policyMappings OBJECT IDENTIFIER ::=  { id-ce 33 }

   PolicyMappings ::= SEQUENCE SIZE (1..MAX) OF SEQUENCE {
        issuerDomainPolicy      CertPolicyId,
        subjectDomainPolicy     CertPolicyId }

   id-ce-subjectAltName OBJECT IDENTIFIER ::=  { id-ce 17 }

   SubjectAltName ::= GeneralNames

   GeneralNames ::= SEQUENCE SIZE (1..MAX) OF GeneralName

   GeneralName ::= CHOICE {
   -- OTHER-NAME ::= TYPE-IDENTIFIER  note: not supported in '88 ASN.1
        otherName                       [0]     anotherName,
        rfc822Name                      [1]     IA5String,
        dNSName                         [2]     IA5String,
        x400Address                     [3]     ORAddress,
        directoryName                   [4]     Name,
        ediPartyName                    [5]     EDIPartyName,
        uniformResourceIdentifier       [6]     IA5String,
        iPAddress                       [7]     OCTET STRING,
        registeredID                    [8]     OBJECT IDENTIFIER }

   anotherName ::= SEQUENCE {
        type-id    OBJECT IDENTIFER,
        value      [0] EXPLICIT ANY DEFINED BY type-id
        }

   EDIPartyName ::= SEQUENCE {
        nameAssigner            [0]     DirectoryString OPTIONAL,
        partyName               [1]     DirectoryString }

   id-ce-issuerAltName OBJECT IDENTIFIER ::=  { id-ce 18 }

   IssuerAltName ::= GeneralNames

   id-ce-subjectDirectoryAttributes OBJECT IDENTIFIER ::=  { id-ce 9 }

   SubjectDirectoryAttributes ::= SEQUENCE SIZE (1..MAX) OF Attribute

   id-ce-basicConstraints OBJECT IDENTIFIER ::=  { id-ce 19 }

   BasicConstraints ::= SEQUENCE {
        cA                      BOOLEAN DEFAULT FALSE,

Housley, Ford, Polk, & Solo                                    [Page 57]

INTERNET DRAFT                                             March 26 1996

        pathLenConstraint       INTEGER (0..MAX) OPTIONAL }

   id-ce-nameConstraints OBJECT IDENTIFIER ::=  { id-ce 30 }

   NameConstraints ::= SEQUENCE {
        permittedSubtrees       [0]     GeneralSubtrees OPTIONAL,
        excludedSubtrees        [1]     GeneralSubtrees OPTIONAL }

   GeneralSubtrees ::= SEQUENCE SIZE (1..MAX) OF GeneralSubtree

   GeneralSubtree ::= SEQUENCE {
        base                    GeneralName,
        minimum         [0]     BaseDistance DEFAULT 0,
        maximum         [1]     BaseDistance OPTIONAL }

   BaseDistance ::= INTEGER (0..MAX)

   id-ce-policyConstraints OBJECT IDENTIFIER ::=  { id-ce 34 }

   PolicyConstraints ::= SEQUENCE SIZE (1..MAX) OF SEQUENCE {
        policySet                       [0] CertPolicySet OPTIONAL,
        requireExplicitPolicy           [1] SkipCerts OPTIONAL,
        inhibitPolicyMapping            [2] SkipCerts OPTIONAL }

   SkipCerts ::= INTEGER (0..MAX)

   CertPolicySet ::= SEQUENCE SIZE (1..MAX) OF CertPolicyId

   -- cRLDistributionPoints CRLDistPointsSyntax ::=
   --              SEQUENCE SIZE (1..MAX) OF DistributionPoint

   CRLDistPointsSyntax ::= SEQUENCE SIZE (1..MAX) OF DistributionPoint

   DistributionPoint ::= SEQUENCE {
        distributionPoint       [0]     DistributionPointName OPTIONAL,
        reasons                 [1]     ReasonFlags OPTIONAL,
        cRLIssuer               [2]     GeneralNames OPTIONAL }

   DistributionPointName ::= CHOICE {
        fullName                [0]     GeneralNames,
        nameRelativeToCRLIssuer [1]     RelativeDistinguishedName }

   ReasonFlags ::= BIT STRING {
        unused                  (0),
        keyCompromise           (1),
        cACompromise            (2),
        affiliationChanged      (3),
        superseded              (4),

Housley, Ford, Polk, & Solo                                    [Page 58]

INTERNET DRAFT                                             March 26 1996

        cessationOfOperation    (5),
        certificateHold         (6) }

   -- private extensions

   pkix  OBJECT IDENTIFIER ::= { 1 3 6 1 5 5 7 }

   id-pkix-subjectInfoAccess OBJECT-IDENTIFIER ::= { pkix 1}

   -- subjectInfoAccess ::=  { SubjectInfoAccessSyntax }

   SubjectInfoAccessSyntax ::= SEQUENCE SIZE (1..MAX) OF AccessDescription

   AccessDescription  ::=  SEQUENCE  {
        subjectInfo        GeneralName  }

   id-pkix-authorityInfoAccess OBJECT-IDENTIFIER ::= { pkix 2 }

   -- authorityInfoAccess ::=  { AuthorityInfoAccessSyntax  }

   AuthorityInfoAccessSyntax  ::=  SEQUENCE  {
        authorityInfo     [0] SEQUENCE OF GeneralName OPTIONAL,
        certStatus        [1] SEQUENCE OF GeneralName OPTIONAL }

   -- CRL structures

   CertificateList  ::=  SEQUENCE  {
        tbsCertList          TBSCertList,
        signatureAlgorithm   AlgorithmIdentifier,
        signature            BIT STRING  }

   TBSCertList  ::=  SEQUENCE  {
        version                 Version OPTIONAL,
                                     -- if present, must be v2
        signature               AlgorithmIdentifier,
        issuer                  Name,
        thisUpdate              ChoiceOfTime,
        nextUpdate              ChoiceOfTime,
        revokedCertificates     SEQUENCE OF SEQUENCE  {
             userCertificate         CertificateSerialNumber,
             revocationDate          ChoiceOfTime,
             crlEntryExtensions      Extensions OPTIONAL
                                                 -- if present, must be v2
                                  }  OPTIONAL,
        crlExtensions           [0]  EXPLICIT Extensions OPTIONAL
                                                 -- if present, must be v2
                                  }

Housley, Ford, Polk, & Solo                                    [Page 59]

INTERNET DRAFT                                             March 26 1996

   Version  ::= INTEGER  {  v1(0), v2(1), v3(2)  }

   AlgorithmIdentifier  ::=  SEQUENCE  {
        algorithm               OBJECT IDENTIFIER,
        parameters              ANY DEFINED BY algorithm OPTIONAL  }
                                     -- contains a value of the type
                                     -- registered for use with the
                                     -- algorithm object identifier value

   ChoiceOfTime ::= CHOICE {
        utcTime        UTCTime,
        generalTime    GeneralizedTime }

   CertificateSerialNumber  ::=  INTEGER

   Extensions  ::=  SEQUENCE OF Extension

   Extension  ::=  SEQUENCE  {
        extnId                  OBJECT IDENTIFIER,
        critical                BOOLEAN DEFAULT FALSE,
        extnValue               OCTET STRING  }
                                     -- contains a DER encoding of a value
                                     -- of the type registered for use with
                                     -- the extnId object identifier value

   id-ce-cRLNumber OBJECT IDENTIFIER ::= { id-ce 20 }

   CRLNumber ::= INTEGER (0..MAX)

   id-ce-issuingDistributionPoint OBJECT IDENTIFIER ::= { id-ce 28 }

   IssuingDistributionPoint ::= SEQUENCE {
        distributionPoint       [0] DistributionPointName OPTIONAL,
        onlyContainsUserCerts   [1] BOOLEAN DEFAULT FALSE,
        onlyContainsCACerts     [2] BOOLEAN DEFAULT FALSE,
        onlySomeReasons         [3] ReasonFlags OPTIONAL,
        indirectCRL             [4] BOOLEAN DEFAULT FALSE }

   id-ce-deltaCRLIndicator OBJECT IDENTIFIER ::= { id-ce 27 }

   -- deltaCRLIndicator ::= BaseCRLNumber

   BaseCRLNumber ::= CRLNumber

   id-ce-cRLNumber OBJECT IDENTIFIER ::= { id-ce 20 }

   -- reasonCode EXTENSION ::= {

Housley, Ford, Polk, & Solo                                    [Page 60]

INTERNET DRAFT                                             March 26 1996

   --      SYNTAX  CRLReason
   --      IDENTIFIED BY { id-ce 21 } }

   CRLReason ::= ENUMERATED {
        unspecified             (0),
        keyCompromise           (1),
        cACompromise            (2),
        affiliationChanged      (3),
        superseded              (4),
        cessationOfOperation    (5),
        certificateHold         (6),
        removeFromCRL           (8) }

   id-ce-holdInstructionCode OBJECT IDENTIFIER ::= { id-ce 23 }

   HoldInstructionCode ::= OBJECT IDENTIFIER

   member-body ID ::= { iso 2 }
   us ID ::= { member-body 840 }
   x9cm ID ::= { us 10040 }
   holdInstruction ID ::= {x9cm 2}

   id-holdinstruction-none ID ::= {holdInstruction 1}
   id-holdinstruction-callissuer ID ::= {holdInstruction 2}
   id-holdinstruction-reject ID ::= {holdInstruction 3}

   id-ce-invalidityDate OBJECT IDENTIFIER ::= { id-ce 24 }

   InvalidityDate ::=  GeneralizedTime

   -- Algorithm structures

        md2WithRSAEncryption OBJECT IDENTIFIER  ::=  {
            iso(1) member-body(2) US(840) rsadsi(113549) pkcs(1)
            pkcs-1(1) 2  }

        sha-1WithRSAEncryption OBJECT IDENTIFIER  ::=  {
            iso(1) identified-organization(3) oiw(14) secsig(3)
            algorithm(2) 29  }

        id-dsa-with-sha1 ID  ::=  {
                   iso(1) member-body(2) us(840) x9-57 (10040)
                   x9algorithm(4) 3 }

        Dss-Sig-Value  ::=  SEQUENCE  {
                   r       INTEGER,
                   s       INTEGER  }

Housley, Ford, Polk, & Solo                                    [Page 61]

INTERNET DRAFT                                             March 26 1996

        pkcs-1 OBJECT IDENTIFIER ::= { iso(1) member-body(2) US(840)
                       rsadsi(113549) pkcs(1) 1 }

        rsaEncryption OBJECT IDENTIFIER ::=  { pkcs-1 1}

        dhpublicnumber OBJECT IDENTIFIER ::= { iso(1) member-body(2)
                  US(840) ansi-x942(10046) 1 }

        DHParameter ::= SEQUENCE {
             prime INTEGER, -- p
             base INTEGER -- g
                   }

        id-dsa ID ::= { iso(1) member-body(2) us(840) x9-57(10040)
                   x9algorithm(4) 1 }

        Dss-Parms  ::=  SEQUENCE  {
            p             INTEGER,
            q             INTEGER,
            g             INTEGER  }

        Dss-Sig-Value  ::=  SEQUENCE  {
            r             INTEGER,
            s             INTEGER  }

        id-keyEncryptionAlgorithm  OBJECT IDENTIFIER   ::=
             { 2 16 840 1 101 2 1 1 22 }

        KEA-Parms-Id     ::= OCTET STRING

   id-ce-subjectKeyIdentifier OBJECT IDENTIFIER ::=  { id-ce 14 }
   id-ce-keyUsage OBJECT IDENTIFIER ::=  { id-ce 15 }
   id-ce-authorityKeyIdentifier OBJECT IDENTIFIER ::=  { id-ce 35 }
   id-pkix-policy-CPS OBJECT IDENTIFIER ::= { pkix 4 }

   CPSuri ::= IA5String

   id-pkix-policy-userNotice OBJECT IDENTIFIER ::= { pkix 5 }

   UserNotice ::= CHOICE {
     visibleString     VisibleString,
     bmpString         BMPString
                         }

   -- x400 address syntax starts here
   --      OR Names

   ORAddressAndOrDirectoryName ::= ORName

Housley, Ford, Polk, & Solo                                    [Page 62]

INTERNET DRAFT                                             March 26 1996

   ORAddressAndOptionalDirectoryName ::= ORName

   ORName ::= [APPLICATION 0] SEQUENCE {
      -- address -- COMPONENTS OF ORAddress,
      directory-name [0] Name OPTIONAL }

   ORAddress ::= SEQUENCE {
      built-in-standard-attributes BuiltInStandardAttributes,
      built-in-domain-defined-attributes
                           BuiltInDomainDefinedAttributes OPTIONAL,
      -- see also teletex-domain-defined-attributes
      extension-attributes ExtensionAttributes OPTIONAL }
   --      The OR-address is semantically absent from the OR-name if the
   --      built-in-standard-attribute sequence is empty and the
   --      built-in-domain-defined-attributes and extension-attributes are
   --      both omitted.

   --      Built-in Standard Attributes
   BuiltInStandardAttributes ::= SEQUENCE {
      country-name CountryName OPTIONAL,
      administration-domain-name AdministrationDomainName OPTIONAL,
      network-address      [0] NetworkAddress OPTIONAL,
      -- see also extended-network-address
      terminal-identifier  [1] TerminalIdentifier OPTIONAL,
      private-domain-name  [2] PrivateDomainName OPTIONAL,
      organization-name    [3] OrganizationName OPTIONAL,
      -- see also teletex-organization-name
      numeric-user-identifier      [4] NumericUserIdentifier OPTIONAL,
      personal-name        [5] PersonalName OPTIONAL,
      -- see also teletex-personal-name
      organizational-unit-names    [6] OrganizationalUnitNames OPTIONAL
      -- see also teletex-organizational-unit-names -- }

   CountryName ::= [APPLICATION 1] CHOICE {
      x121-dcc-code NumericString
                   (SIZE (ub-country-name-numeric-length)),
      iso-3166-alpha2-code PrintableString
                   (SIZE (ub-country-name-alpha-length)) }

   AdministrationDomainName ::= [APPLICATION 2] CHOICE {
      numeric NumericString (SIZE (0..ub-domain-name-length)),
      printable PrintableString (SIZE (0..ub-domain-name-length)) }

   NetworkAddress ::= X121Address
   -- see also extended-network-address

   X121Address ::= NumericString (SIZE (1..ub-x121-address-length))

Housley, Ford, Polk, & Solo                                    [Page 63]

INTERNET DRAFT                                             March 26 1996

   TerminalIdentifier ::= PrintableString (SIZE (1..ub-terminal-id-length))

   PrivateDomainName ::= CHOICE {
      numeric NumericString (SIZE (1..ub-domain-name-length)),
      printable PrintableString (SIZE (1..ub-domain-name-length)) }

   OrganizationName ::= PrintableString (SIZE (1..ub-organization-name-length))
   -- see also teletex-organization-name

   NumericUserIdentifier ::= NumericString (SIZE (1..ub-numeric-user-id-length))

   PersonalName ::= SET {
      surname [0] PrintableString (SIZE (1..ub-surname-length)),
      given-name [1] PrintableString
                           (SIZE (1..ub-given-name-length)) OPTIONAL,
      initials [2] PrintableString (SIZE (1..ub-initials-length)) OPTIONAL,
      generation-qualifier [3] PrintableString
                   (SIZE (1..ub-generation-qualifier-length)) OPTIONAL}
   -- see also teletex-personal-name

   OrganizationalUnitNames ::= SEQUENCE SIZE (1..ub-organizational-units)
                                           OF OrganizationalUnitName
   -- see also teletex-organizational-unit-names

   OrganizationalUnitName ::= PrintableString (SIZE
                           (1..ub-organizational-unit-name-length))

   --      Built-in Domain-defined Attributes
   BuiltInDomainDefinedAttributes ::= SEQUENCE SIZE
                                   (1..ub-domain-defined-attributes) OF
                                   BuiltInDomainDefinedAttribute

   BuiltInDomainDefinedAttribute ::= SEQUENCE {
      type PrintableString (SIZE
                           (1..ub-domain-defined-attribute-type-length)),
      value PrintableString (SIZE
                           (1..ub-domain-defined-attribute-value-length)) }
   --      Extension Attributes
   ExtensionAttributes ::= SET SIZE (1..ub-extension-attributes) OF
                           ExtensionAttribute
   ExtensionAttribute ::= EXTENSION-ATTRIBUTE

   EXTENSION-ATTRIBUTE ::= SEQUENCE {
      extension-attribute-type [0] INTEGER (0..ub-extension-attributes) UNIQUE,
      extension-attribute-value [1] ANY DEFINED BY extension-attribute-type
                                   }

   ExtensionAttributeTable EXTENSION-ATTRIBUTE ::= {

Housley, Ford, Polk, & Solo                                    [Page 64]

INTERNET DRAFT                                             March 26 1996

      common-name |
      teletex-common-name |
      teletex-organization-name |
      teletex-personal-name |
      teletex-organizational-unit-names |
      teletex-domain-defined-attributes |
      pds-name |
      physical-delivery-country-name |
      postal-code |
      physical-delivery-office-name |
      physical-delivery-office-number |
      extension-OR-address-components |
      physical-delivery-personal-name |
      physical-delivery-organization-name |
      extension-physical-delivery-address-components |
      unformatted-postal-address |
      street-address |
      post-office-box-address |
      poste-restante-address |
      unique-postal-name |
      local-postal-attributes |
      extended-network-address |
      terminal-type }

   --      Extension Standard Attributes

   common-name EXTENSION-ATTRIBUTE ::= {CommonName IDENTIFIED BY 1}

   CommonName ::= PrintableString (SIZE (1..ub-common-name-length))

   teletex-common-name EXTENSION-ATTRIBUTE ::=
                           {TeletexCommonName IDENTIFIED BY 2}

   TeletexCommonName ::= TeletexString (SIZE (1..ub-common-name-length))

   teletex-organization-name EXTENSION-ATTRIBUTE ::=
                           {TeletexOrganizationName IDENTIFIED BY 3}

   TeletexOrganizationName ::= TeletexString (SIZE (1..ub-organization-name-length))

   teletex-personal-name EXTENSION-ATTRIBUTE ::=
                           {TeletexPersonalName IDENTIFIED BY 4}

   TeletexPersonalName ::= SET {
      surname [0] TeletexString (SIZE (1..ub-surname-length)),
      given-name [1] TeletexString (SIZE (1..ub-given-name-length)) OPTIONAL,
      initials [2] TeletexString (SIZE (1..ub-initials-length)) OPTIONAL,
      generation-qualifier [3] TeletexString (SIZE

Housley, Ford, Polk, & Solo                                    [Page 65]

INTERNET DRAFT                                             March 26 1996

                            (1..ub-generation-qualifier-length)) OPTIONAL }

   teletex-organizational-unit-names EXTENSION-ATTRIBUTE ::=
      {TeletexOrganizationalUnitNames IDENTIFIED BY 5}

   TeletexOrganizationalUnitNames ::= SEQUENCE SIZE
           (1..ub-organizational-units) OF TeletexOrganizationalUnitName

   TeletexOrganizationalUnitName ::= TeletexString
                           (SIZE (1..ub-organizational-unit-name-length))

   pds-name EXTENSION-ATTRIBUTE ::= {PDSName IDENTIFIED BY 7}

   PDSName ::= PrintableString (SIZE (1..ub-pds-name-length))

   physical-delivery-country-name EXTENSION-ATTRIBUTE ::=
      {PhysicalDeliveryCountryName IDENTIFIED BY 8}

   PhysicalDeliveryCountryName ::= CHOICE {
      x121-dcc-code NumericString (SIZE (ub-country-name-numeric-length)),
      iso-3166-alpha2-code PrintableString
                           (SIZE (ub-country-name-alpha-length)) }

   postal-code EXTENSION-ATTRIBUTE ::= {PostalCode IDENTIFIED BY 9}

   PostalCode ::= CHOICE {
      numeric-code NumericString (SIZE (1..ub-postal-code-length)),
      printable-code PrintableString (SIZE (1..ub-postal-code-length)) }

   physical-delivery-office-name EXTENSION-ATTRIBUTE ::=
                           {PhysicalDeliveryOfficeName IDENTIFIED BY 10}

   PhysicalDeliveryOfficeName ::= PDSParameter

   physical-delivery-office-number EXTENSION-ATTRIBUTE ::=
      {PhysicalDeliveryOfficeNumber IDENTIFIED BY 11}

   PhysicalDeliveryOfficeNumber ::= PDSParameter

   extension-OR-address-components EXTENSION-ATTRIBUTE ::=
      {ExtensionORAddressComponents IDENTIFIED BY 12}

   ExtensionORAddressComponents ::= PDSParameter

   physical-delivery-personal-name EXTENSION-ATTRIBUTE ::=
      {PhysicalDeliveryPersonalName IDENTIFIED BY 13}

   PhysicalDeliveryPersonalName ::= PDSParameter

Housley, Ford, Polk, & Solo                                    [Page 66]

INTERNET DRAFT                                             March 26 1996

   physical-delivery-organization-name EXTENSION-ATTRIBUTE ::=
      {PhysicalDeliveryOrganizationName IDENTIFIED BY 14}

   PhysicalDeliveryOrganizationName ::= PDSParameter

   extension-physical-delivery-address-components EXTENSION-ATTRIBUTE ::=
      {ExtensionPhysicalDeliveryAddressComponents IDENTIFIED BY 15}

   ExtensionPhysicalDeliveryAddressComponents ::= PDSParameter

   unformatted-postal-address EXTENSION-ATTRIBUTE ::=
                           {UnformattedPostalAddress IDENTIFIED BY 16}

   UnformattedPostalAddress ::= SET {
      printable-address SEQUENCE SIZE (1..ub-pds-physical-address-lines) OF
              PrintableString (SIZE (1..ub-pds-parameter-length)) OPTIONAL,
      teletex-string TeletexString (SIZE
                            (1..ub-unformatted-address-length)) OPTIONAL }

   street-address EXTENSION-ATTRIBUTE ::=
                   {StreetAddress IDENTIFIED BY 17}

   StreetAddress ::= PDSParameter

   post-office-box-address EXTENSION-ATTRIBUTE ::=
                   {PostOfficeBoxAddress IDENTIFIED BY 18}

   PostOfficeBoxAddress ::= PDSParameter

   poste-restante-address EXTENSION-ATTRIBUTE ::=
                   {PosteRestanteAddress IDENTIFIED BY 19}

   PosteRestanteAddress ::= PDSParameter

   unique-postal-name EXTENSION-ATTRIBUTE ::=
                   {UniquePostalName IDENTIFIED BY 20}

   UniquePostalName ::= PDSParameter

   local-postal-attributes EXTENSION-ATTRIBUTE ::=
                   {LocalPostalAttributes IDENTIFIED BY 21}

   LocalPostalAttributes ::= PDSParameter

   PDSParameter ::= SET {
      printable-string PrintableString (SIZE(1..ub-pds-parameter-length)) OPTIONAL,
      teletex-string TeletexString (SIZE(1..ub-pds-parameter-length)) OPTIONAL }

Housley, Ford, Polk, & Solo                                    [Page 67]

INTERNET DRAFT                                             March 26 1996

   extended-network-address EXTENSION-ATTRIBUTE ::=
                           {ExtendedNetworkAddress IDENTIFIED BY 22}

   ExtendedNetworkAddress ::= CHOICE {

      e163-4-address SEQUENCE {
           number [0] NumericString (SIZE (1..ub-e163-4-number-length)),
           sub-address [1] NumericString
                           (SIZE (1..ub-e163-4-sub-address-length)) OPTIONAL },
           psap-address [0] PresentationAddress }

   terminal-type EXTENSION-ATTRIBUTE ::= {TerminalType IDENTIFIED BY 23}

   TerminalType ::= INTEGER {
      telex (3),
      teletex (4),
      g3-facsimile (5),
      g4-facsimile (6),
      ia5-terminal (7),
      videotex (8) } (0..ub-integer-options)

   --      Extension Domain-defined Attributes

   teletex-domain-defined-attributes EXTENSION-ATTRIBUTE ::=
      {TeletexDomainDefinedAttributes IDENTIFIED BY 6}

   TeletexDomainDefinedAttributes ::= SEQUENCE SIZE
      (1..ub-domain-defined-attributes) OF TeletexDomainDefinedAttribute

   TeletexDomainDefinedAttribute ::= SEQUENCE {
       type TeletexString (SIZE (1..ub-domain-defined-attribute-type-length)),
       value TeletexString (SIZE (1..ub-domain-defined-attribute-value-length)) }

   --  specifications of Upper Bounds
   --  must be regarded as mandatory
   --  from Annex B of ITU-T X.411
   --  Reference Definition of MTS Parameter Upper Bounds

   --      Upper Bounds
   ub-additional-info INTEGER ::= 1024
   ub-bilateral-info INTEGER ::= 1024
   ub-bit-options INTEGER ::= 16
   ub-built-in-content-type INTEGER ::= 32767
   ub-built-in-encoded-information-types INTEGER ::= 32
   ub-common-name-length INTEGER ::= 64
   ub-content-correlator-length INTEGER ::= 512
   ub-content-id-length INTEGER ::= 16
   ub-content-length INTEGER ::= 2147483647   -- the largest integer in 32 bits

Housley, Ford, Polk, & Solo                                    [Page 68]

INTERNET DRAFT                                             March 26 1996

   ub-content-types INTEGER ::= 1024
   ub-country-name-alpha-length INTEGER ::= 2
   ub-country-name-numeric-length INTEGER ::= 3
   ub-diagnostic-codes INTEGER ::= 32767
   ub-deliverable-class INTEGER ::= 256
   ub-dl-expansions INTEGER ::= 512
   ub-domain-defined-attributes INTEGER ::= 4
   ub-domain-defined-attribute-type-length INTEGER ::= 8
   ub-domain-defined-attribute-value-length INTEGER ::= 128
   ub-domain-name-length INTEGER ::= 16
   ub-encoded-information-types INTEGER ::= 1024
   ub-extension-attributes INTEGER ::= 256
   ub-extension-types INTEGER ::= 256
   ub-e163-4-number-length INTEGER ::= 15
   ub-e163-4-sub-address-length INTEGER ::= 40
   ub-generation-qualifier-length INTEGER ::= 3
   ub-given-name-length INTEGER ::= 16
   ub-initials-length INTEGER ::= 5
   ub-integer-options INTEGER ::= 256
   ub-labels-and-redirections INTEGER ::= 256
   ub-local-id-length INTEGER ::= 32
   ub-mta-name-length INTEGER ::= 32
   ub-mts-user-types INTEGER ::= 256
   ub-numeric-user-id-length INTEGER ::= 32
   ub-organization-name-length INTEGER ::= 64
   ub-organizational-unit-name-length INTEGER ::= 32
   ub-organizational-units INTEGER ::= 4
   ub-orig-and-dl-expansions INTEGER ::= 513   -- ub-dl-expansions plus one
   ub-password-length INTEGER ::= 62
   ub-pds-name-length INTEGER ::= 16
   ub-pds-parameter-length INTEGER ::= 30
   ub-pds-physical-address-lines INTEGER ::= 6
   ub-postal-code-length INTEGER ::= 16
   ub-privacy-mark-length INTEGER ::= 128
   ub-queue-size INTEGER ::= 2147483647    -- the largest integer in 32 bits
   ub-reason-codes INTEGER ::= 32767
   ub-recipient-number-for-advice-length INTEGER ::= 32
   ub-recipients INTEGER ::= 32767
   ub-redirection-classes INTEGER ::= 256
   ub-redirections INTEGER ::= 512
   ub-restrictions INTEGER ::= 1024
   ub-security-categories INTEGER ::= 64
   ub-security-labels INTEGER ::= 256
   ub-security-problems INTEGER ::= 256
   ub-supplementary-info-length INTEGER ::= 256
   ub-surname-length INTEGER ::= 40
   ub-teletex-private-use-length INTEGER ::= 128
   ub-terminal-id-length INTEGER ::= 24

Housley, Ford, Polk, & Solo                                    [Page 69]

INTERNET DRAFT                                             March 26 1996

   ub-transfers INTEGER ::= 512
   ub-tsap-id-length INTEGER ::= 16
   ub-unformatted-address-length INTEGER ::= 180
   ub-x121-address-length INTEGER ::= 16

   -- Note - upper bounds on TeletexString are measured in characters.
   -- A significantly greater number of octets will be required to hold
   -- such a value.  As a minimum, 16 octets, or twice the specified upper
   -- bound, whichever is the larger, should be allowed.

   END

   References

   [COR95]    ISO/IEC JTC 1/SC 21, Technical Corrigendum 2 to ISO/IEC
   9594-8:             1990 & 1993 (1995:E), July 1995.

   [FIPS 180-1]  Federal Information Processing Standards Publication
              (FIPS PUB) 180-1, Secure Hash Standard, 17 April 1995.
              [Supersedes FIPS PUB 180 dated 11 May 1993.]

   [FIPS 186] Federal Information Processing Standards Publication
              (FIPS PUB) 186, Digital Signature Standard, 18 May 1994.

   [PKCS#1]   PKCS #1: RSA Encryption Standard, Version 1.4, RSA Data
              Security, Inc., 3 June 1991.

   [RC95]     Rogier, N. and Chauvaud, P., "The compression function of
              MD2 is not collision free," Presented at Selected Areas in
              Cryptography '95, Carleton University, Ottawa, Canada,
              18-19 May 1995.

   [RFC 1319] Kaliski, B., "The MD2 Message-Digest Algorithm," RFC 1319,
              RSA Laboratories, April 1992.

   [RFC 1422] Kent, S.,  "Privacy Enhancement for Internet Electronic
              Mail: Part II: Certificate-Based Key Management," RFC
              1422, BBN Communications, February 1993.

   [RFC 1423] Balenson, D., "Privacy Enhancement for Internet Electronic
              Mail: Part III: Algorithms, Modes, and Identifiers,"
              RFC 1423, Trusted Information Systems, February 1993.

   [RFC 1738] T. Berners-Lee, L. Masinter & M. McCahill, "Uniform
   Resource            Locators (URL)," December 1994.

   [RFC 1777] W. Yeong, T. Howes & S. Kille, "Lightweight Directory
              Access Protocol," March 1995.

Housley, Ford, Polk, & Solo                                    [Page 70]

INTERNET DRAFT                                             March 26 1996

   [RFC 1959] T. Howes, M. Smith, "An LDAP URL Format", RFC 1959,
              June 1996.

   [SDN.701R] SDN.701, "Message Security Protocol", Revision 4.0
              1996-06-07 with "Corrections to Message Security Protocol,
              SDN.701, Rev 4.0, 96-06-07." August 30, 1996.

   [X.208]    CCITT Recommendation X.208: Specification of Abstract
              Syntax Notation One (ASN.1), 1988.

   [X.509-AM] ISO/IEC JTC1/SC 21, Draft Amendments DAM 4 to ISO/IEC
              9594-2, DAM 2 to ISO/IEC 9594-6, DAM 1 to ISO/IEC 9594-7,
              and DAM 1 to ISO/IEC 9594-8 on Certificate Extensions,
              1 December, 1996.

   [X9.55]    ANSI X9.55-1995, Public Key Cryptography For The Financial
              Services Industry: Extensions To Public Key Certificates
              And Certificate Revocation Lists, 8 December, 1995.

   [X9.57]    ANSI X9.57-199x, Public Key Cryptography For The Financial
              Services Industry: Certificate Management (Working Draft),
              21 June, 1996.

Patent Statements

   The Internet PKI relies on the use of patented public key technology.
   The Internet Standards Process as defined in RFC 1310 requires a
   written statement from the Patent holder that a license will be made
   available to applicants under reasonable terms and conditions prior
   to approving a specification as a Proposed, Draft or Internet
   Standard.

   Patent statements for DSA, RSA, and Diffie-Hellman follow.  These
   statements have been supplied by the patent holders, not the authors
   of this profile.

   This specification relies on the use of patented public key
   encryption technology and secure hash technology for digital
   signature services.  This specification also references public key
   encryption technology for provisioning key exchange services.

   The Internet Standards Process as defined in RFC 1310 requires a
   written statement from the Patent holder that a license will be made
   available to applicants under reasonable terms and conditions prior
   to approving a specification as a Proposed, Draft or Internet
   Standard.

   The Internet Society, Internet Architecture Board, Internet

Housley, Ford, Polk, & Solo                                    [Page 71]

INTERNET DRAFT                                             March 26 1996

   Engineering Steering Group and the Corporation for National Research
   Initiatives take no position on the validity or scope of the
   following patents and patent applications, nor on the appropriateness
   of the terms of the assurance. The Internet Society and other groups
   mentioned above have not made any determination as to any other
   intellectual property rights which may apply to the practice of this
   standard.  Any further consideration of these matters is the user's
   own responsibility.

   Digital Signature Algorithm (DSA)

      The U.S. Government holds patent 5,231,668 on the Digital
      Signature Algorithm (DSA), which has been incorporated into
      Federal Information Processing Standard (FIPS) 186.  The patent
      was issued on July 27, 1993.

      The National Institute of Standards and Technology (NIST) has a
      long tradition of supplying U.S. Government-developed techniques
      to committees and working groups for inclusion into standards on a
      royalty-free basis.  NIST has made the DSA patent available
      royalty-free to users worldwide.

      Regarding patent infringement, FIPS 186 summarizes our position;
      the Department of Commerce is not aware of any patents that would
      be infringed by the DSA.  Questions regarding this matter may be
      directed to the Deputy Chief Counsel for NIST.

   RSA Signature and Encryption

      <<A revised patent statement for RSA from RSADSI is needed. >>

      The Massachusetts Institute of Technology has granted RSA Data
      Security, Inc., exclusive sub-licensing rights to the following
      patent issued in the United States:

      Cryptographic Communications System and Method ("RSA"), No.
      4,405,829

   Diffie-Hellman Key Agreement and Hellman-Merkle Public Key
   Cryptography

      I.      Patents Relevant To Public Key Standards

      On September 6, 1995, Cylink Corporation obtained an order of
      dissolution for Public Key Partners.  Cylink, through its wholly
      owned subsidiary Caro-Kann Corporation, now holds exclusive
      sublicensing rights to certain patents owned by Stanford

Housley, Ford, Polk, & Solo                                    [Page 72]

INTERNET DRAFT                                             March 26 1996

      University, including the following:

         Cryptographic Apparatus and Method
         ("Diffie-Hellman")......................... No. 4,200,770

         Public Key Cryptographic Apparatus
         and Method ("Hellman-Merkle").............. No. 4,218,582

      These patents cover all known methods of practicing the art of
      Public Key, including the signature techniques known as DSS and
      RSA.

      II.     Cylink's Licensing Policy

      It is Cylink's policy to license the foregoing patents in
      accordance with the guidelines of the American National Standards
      Institute, the IEEE, and the IETF to any party interested in
      practicing Public Key Technology. A copy of Cylink's standard
      terms and conditions is enclosed.

      III.    Licensing Fees

      The standard terms require the payment of a single License Fee at
      the time of execution.  No royalties or annual payments are
      required. The current fee schedule is available on request from
      Cylink, c/o Robert B. Fougner, Esq. (e-mail [email-masked]).
      In addition, in order to promote royalty free public key
      standards, Cylink authorizes any of its existing or future
      licensees to provide a royalty free reference implementation for
      commercial use of any accredited standard in accordance with the
      attached statement.

      Cylink Statement on Royalty Free Reference Implementations

      CYLINK'S SUPPORT FOR OPEN PUBLIC KEY STANDARDS EXISTING AND
      PROSPECTIVE CYLINK LICENSEES OF THE STANFORD PUBLIC KEY PATENTS
      MAY SUPPLEMENT THEIR LICENSES IN ACCORDANCE WITH THE FOLLOWING
      STATEMENT:

      STATEMENT OF PATENT POSITION
      Cylink Corporation, through its wholly owned subsidiary Caro-Kann
      Corporation, holds exclusive sublicensing rights to the following
      U.S. patents owned by the Leland Stanford Junior University:

         Cryptographic Apparatus and Method
         ("Diffie-Hellman")......................... No. 4,200,770

         Public Key Cryptographic Apparatus

Housley, Ford, Polk, & Solo                                    [Page 73]

INTERNET DRAFT                                             March 26 1996

         and Method ("Hellman-Merkle").............. No. 4,218,582

      In order to promote the widespread use of these inventions from
      Stanford University and adoption of the [Name Standard] reference,
      [Name of Licensee] has acquired the right under its sublicense
      from Cylink to offer the [Name Standard]reference implementation
      to all third parties on a royalty free basis.  This royalty free
      privilege is limited to use of the [Name Standard] reference
      implementation in accordance with proposed, pending or approved
      [Name of Accredited Standards Body]standards, and applies only
      when used with Diffie-Hellman key exchange, the Digital Signature
      Standard, or any other public key techniques which are publicly
      available for commercial use on a royalty free basis.  Any use of
      the [Name Standard] reference implementation which does not
      satisfy these conditions and incorporates the practice of public
      key may require a separate patent license to the Stanford Patents
      which must be negotiated with Cylink's subsidiary, Caro-Kann
      Corporation.

Security Considerations

   This entire memo is about security mechanisms.

Author Addresses:

   Russell Housley
   SPYRUS
   PO Box 1198
   Herndon, VA 20172
   USA
   [email-masked]

   Warwick Ford
   VeriSign, Inc.
   One Alewife Center
   Cambridge, MA 02140
   USA
   [email-masked]

   Tim Polk
   NIST
   Building 820, Room 426
   Gaithersburg, MD 20899
   USA
   [email-masked]

   David Solo
   BBN

Housley, Ford, Polk, & Solo                                    [Page 74]

INTERNET DRAFT                                             March 26 1996

   150 CambridgePark Drive
   Cambridge, MA 02140
   USA
   [email-masked]

Housley, Ford, Polk, & Solo                                    [Page 75]

To: IETF-Announce:;@tandem.com
cc: [email-masked]
From: [email-masked]
Reply-to: [email-masked]
Subject: I-D ACTION:draft-ietf-pkix-ipki-part4-00.txt
Date: Thu, 27 Mar 1997 09:54:41 -0500
Sender: [email-masked]

--NextPart

 A New Internet-Draft is available from the on-line Internet-Drafts 
 directories. This draft is a work item of the Public-Key Infrastructure 
 (X.509) Working Group of the IETF.                                        

       Title     : Internet Public Key Infrastructure  Part IV: Certificate
                   Policy and Certification Practices Framework            
       Author(s) : S. Chokhani, W. Ford
       Filename  : draft-ietf-pkix-ipki-part4-00.txt
       Pages     : 42
       Date      : 03/26/1997

This document presents a framework to assist the writers of certificate 
policies or certification practice statements for certification authorities
and public key infrastructures.   In particular, the framework provides a 
comprehensive list of topics that potentially (at the writer's discretion) 
need to be covered in a certificate policy definition or a certification 
practice statement. It is intended that this document, when fully 
developed, be published as an Informational RFC.                           

Internet-Drafts are available by anonymous FTP.  Login with the username
"anonymous" and a password of your e-mail address.  After logging in,
type "cd internet-drafts" and then
     "get draft-ietf-pkix-ipki-part4-00.txt".
A URL for the Internet-Draft is:
ftp://ds.internic.net/internet-drafts/draft-ietf-pkix-ipki-part4-00.txt
 
Internet-Drafts directories are located at:	
	                                                
     o  Africa:  ftp.is.co.za                    
	                                                
     o  Europe:  ftp.nordu.net            	
                 ftp.nis.garr.it                 
	                                                
     o  Pacific Rim: munnari.oz.au               
	                                                
     o  US East Coast: ds.internic.net           
	                                                
     o  US West Coast: ftp.isi.edu               
	                                                
Internet-Drafts are also available by mail.	
	                                                
Send a message to:  [email-masked]. In the body type: 
     "FILE /internet-drafts/draft-ietf-pkix-ipki-part4-00.txt".
							
NOTE: The mail server at ds.internic.net can return the document in
      MIME-encoded form by using the "mpack" utility.  To use this
      feature, insert the command "ENCODING mime" before the "FILE"
      command.  To decode the response(s), you will need "munpack" or
      a MIME-compliant mail reader.  Different MIME-compliant mail readers
      exhibit different behavior, especially when dealing with
      "multipart" MIME messages (i.e., documents which have been split
      up into multiple messages), so check your local documentation on
      how to manipulate these messages.

Below is the data which will enable a MIME compliant mail reader 
implementation to automatically retrieve the ASCII version
of the Internet-Draft.

--NextPart
Content-Type: Multipart/Alternative; Boundary="OtherAccess"

--OtherAccess
Content-Type:  Message/External-body;
        access-type="mail-server";
        server="[email-masked]"

Content-Type: text/plain
Content-ID: <[email-masked]>

ENCODING mime
FILE /internet-drafts/draft-ietf-pkix-ipki-part4-00.txt

--OtherAccess
Content-Type:   Message/External-body;
        name="draft-ietf-pkix-ipki-part4-00.txt";
        site="ds.internic.net";
        access-type="anon-ftp";
        directory="internet-drafts"

Content-Type: text/plain
Content-ID: <[email-masked]>

--OtherAccess--

--NextPart--

Date: Thu, 27 Mar 97 09:02 GMT0
From: [email-masked] (A M Seymour BACS Ltd Accounts)
Subject: Re: sample X.509 certificates
To: [email-masked]
Cc: [email-masked]
Reply-To: [email-masked]

In-Reply-To: <[email-masked]>
I tried your ca links. Unfortunately they did not work at all. Your 
first link to magnacom produced some certificates, but they were 
unreadable, being shown in unprintable characters.
Your second link to pca.dfn.de  gave dns error.
Have you tried each of these links recently?

From: Sharon Boeyen <[email-masked]>
To: "[email-masked]'" <[email-masked]>, "'Peter Williams'" <[email-masked]>
Cc: "'Mike Smith (Zions)'" <[email-masked]>
Subject: RE: pkix part 2
Date: Wed, 26 Mar 1997 14:59:40 -0500
Encoding: 154 TEXT

Peter,

When the authors of this draft of PKIX Part 2 discussed the options,
HTTP was discussed and was proposed for inclusion by Michael Smith. 

No one was able to commit the resources at the time to prime that
section of the document and there were concerns expressed by myself and
others about keeping the number of options down so that we don't create
unnecessary barriers to interoperability. Resources were committed for
the LDAP, FTP and OCSP. 

I take your point however and also just saw another new Internet Draft
"draft-kikuchi-web-cert-repository-00.txt" Intitled "Internet Public Key
Infrastructure: Web-based Certificate and CRL Repository", which I
wasn't aware was in the works. We probably need to consider that draft
in conjunction with PKIX Part 2 and try to determine the relationship
between the two.

I am concerned however about standardizing x number of protocols for
satisfying the same requirement of cert and CRL retrieval and the impact
that will have on interoperability among domains (e.g. one domain uses
LDAP, while another uses HTTP and another FTP)

------------------
Sharon Boeyen                 
Entrust Technologies
mailto:[email-masked]       Tel: (613) 765-4931
http://www.entrust.com          Fax: (613) 765-3520

         Orchestrating Enterprise Security

>----------
>From: 	Peter Williams[SMTP:[email-masked]]
>Sent: 	March 24, 1997 2:54 PM
>To: 	[email-masked]
>Subject: 	pkix part 2
>
><<File: smime.p7s>>
>I ran a little technology experiment to gauge how realistic some of the
>elements of the PKIX-2 I-D recently published is in today's world. Here
>is the activity in summary, the repeatable results,
>and some first generation comments and/or recommendations about
>scope and content which derived from my own first review of
>the entire ID.
>
>I took the recent PKIX 2 draft to heart, and played with
>some technology to see how it works with available
>multi-vendor products, which were not specifically
>designed to work together. This is a good Internet test
>when analysing protocols.
>
>I received a bunch of signed S/MIME messages (0 mins)
>in my UA, and then exported a group of certificate chains (without
>their current CRLs, I believe) belong to principals I deal with from
>my security manager as p7c files (S/MIME chains used to convey
>certificates and associated Crls) using the Worldtalk/Demings/S-MIME
>email package plugin to Eudora.
>
>When selecting names for listing, I used highly descriptive long file
>names which were obtained by cutting and pasting the presentation of the
>subject DN of the certificate being exported. (30 secs a
>name)
>
>I then exposed these files (now formally X.500 objects!) to the
>local world on a web server setup with access control, and equipped
>set of hierarchical folders on the local file system
>to model, X.500 DN-style, an organization of those names for
>sensible listing. (5 mins to install win95 web server, 5 mins
>to make some folders)
>
>Using Microsoft Frontpage file import facility, I
>filled my DIB (aka webserver file store) and thereby populated
>a simple hierarchical DIT (aka set of hierarchically-named folders)
>(5 mins). For fun, I created a virtual web URI path also to a portion
>of the file store, to emulate a X.500 yellow pages listing, a
>and even made an X.500 alias record. (30 secs, + 5 mins for
>unessential fun activities)
>
>Then I mailed myself the URL pointer in a signed memo with an
>attachment noting the URI to the top page of links listing each
>the entry. ( 1 minute) (This was a simulation of the X.509 v3 extension
>conveying the URI of the certificate distribution and revocation
>service, where such information would more naturally be authoritatively
>obtained from.)
>
>Upon accepting the signed message, the browser launches from
>within the email package by clicking on the URL in the GUI.
>Upon selecting the relevant party using the wonderful search function
>known as control-F, and/or navigating down to the RDN listing
>tree by clicking on named folders, the browser pulled the
>file using http (but could have been https). (an interactive process
>taking 60 seconds for me)
>
>Given my local configuration, arrival of the file automatically
>invoked the security manager to import the chain. (a laborious 1 minute
>per import, given all the rather insistent confirmation dialogs)
>
>Then I sent someone a private mail, having just obtained
>their certificate, having had (logical but not actual) 
>access to all relevant revocation information from the
>web server.
>
> 
>I started then to fiddle with the setup to use ftp, rather 
>than http and https, so as to conform with intentions
>of the pkix part 2.
>
>Then I asked myself, why does PKIX-2 limit the URI for
>this file-centric type of service to only ftp?
>
>One might say, well, ftp can serve bulk download; a whole
>batch of cert chains, not just one. But, so can http,
>using the client pull, or multipart content response.
>
>The great advantage to using http over ftp in these matters
>is that many firewalls will pass the http data to the desktop.
>See how Microsoft used http streaming in their delivery of
>realtime video/audio etc where folks cannot obtain
>udp or rtp within the LAN context.
>
>(http streaming, like http transport of DCOM, and certificate
>distribution obviously allows use of https security, for obvious
>integrity and some privacy benefits..)
>
>Finally, http based servers are functionally highly advanced
>with respect of protection against unwarranted browsing
>or trawling of data served via http. Few ftp servers have
>the same feature set. Mass distribution of data via http
>is not a problem, and does not have to hurt the TCP network
>performance when folks navigate, given http keep-alive, and
>multipart response options.
>
>The advantage to not excluding http is the ability of
>a large number of existing deployed browsers to take part NOW
>in certificate distribution and revocation schemes, versus be excluded
>due to their absence of support of ldap, or the lack
>of CAs offering ldap or X.500 DSP access. My practical
>experiments summarized above are put forward as evidence
>of this fact.
>
>
>"
>>End entities and CAs retrieve certificates and/or CRLs from the 
>>repository using either the Lightweight Directory Access Protocol 
>>(LDAP) profile defined in section 2 or the File Transfer Protocol 
>>(FTP) profile defined in section 3 of this specification.
>>
>>Otherwise, entities validate the status of a certificate, by 
>>communicating directly with a CA, using the Online Certificate 
>>Status Protocol (OCSP) defined in section 4 of this specification.
>"
>

Date: Wed, 26 Mar 1997 09:03:29 -0500
From: [email-masked] (David P. Kemp)
To: [email-masked]
Subject: Re: ISO DAM on X.509 download site?

> From: Ned Smith <[email-masked]>

ftp://ftp.bull.com

Date: Wed, 26 Mar 1997 09:11:54 -0500
From: [email-masked] (David P. Kemp)
To: [email-masked]
Subject: Re: ISO DAM on X.509 download site?

> From: Ned Smith <[email-masked]>
> 
> Where can I get a copy of ISO DAM on X.509? (Didn't see it on the IETF-PKIX
> web page).

ftp://ftp.bull.com/pub/OSIdirectory/Certificates/Certificates1Dec.US.ps

(sorry for the spam if an incomplete version of this message escaped)

From: Sharon Boeyen <[email-masked]>
To: "[email-masked]'" <[email-masked]>, "'Nick Pope'" <[email-masked]>
Subject: RE: ipki2opp - encoding of certificates
Date: Wed, 26 Mar 1997 08:56:14 -0500
Encoding: 48 TEXT

Nick,

Thanks for catching that. You are, in my opinion, correct and I'll plan
to add clarifying text to the PKIX part 2 draft.

------------------
Sharon Boeyen                 
Entrust Technologies
mailto:[email-masked]       Tel: (613) 765-4931
http://www.entrust.com          Fax: (613) 765-3520

         Orchestrating Enterprise Security

>----------
>From: 	Nick Pope[SMTP:[email-masked]]
>Sent: 	March 24, 1997 10:30 AM
>To: 	[email-masked]
>Subject: 	ipki2opp - encoding of certificates
>
>The recent Internet Draft PKI Part 2- Operational Protocols, decsribes 
>use of LDAP RFC 1777 for retriving certificates.
>
>No mention is made of the use of RFC 1778 definition of the character 
>encoded userCertificate, which I understand doesn't work as the 
>encoding of the distinguished name cannot be uniquely re-created to 
>validate the signature.  Also, this doesn't support X.509 V3.
>
>Do I presume that the Certificate is to be transferred as an DER 
>encoded binary carried in the OCTET STRING?
>
>Nick Pope
>
>-------------------------------------
>
>
>Security & Standards
>Suite A
>191 Moulsham St.
>Chelmsford
>Essex
>CM2 0LG
>U.K.
>
>Tel: +44 1245 495018
>Fax: +44 1245 494517
>

Date: Wed, 26 Mar 1997 10:37:38 +0100
To: [email-masked], [email-masked]
From: Keutel <[email-masked]>
Subject: sample code - parsing X.509 certificate with LDAP routines

--=====================_859365458==_
Content-Type: text/plain; charset="iso-8859-1"
Content-Transfer-Encoding: quoted-printable

Hello,
  I got a lot of answers - a lot of people seem to be interested in my
sample code. So I=B4ll attach it here. I=B4ll put it online later.

The sample code "print_certificates.c" opens a file containing a X.509
certificate and prints it=B4s content to stdout. It=B4s really a sample prog=
ram
- so it has a lot of restrictions, for example:
- it doesn=B4t free any memory
- it decodes only X.509-V1 certificates; esp. it doesn=B4t handle the tag [0=
]
before Version
- it doesn=B4t handle other parameters than INTEGER in algorithmIdentifier
- it prints subjectPublicKey as a OCTET STRING (not as a BIT STRING)
- it doesn=B4t print the components of SIGNED
- ...

I post it today because I=B4ll be in vacations the next 2 weeks. Probably
I=B4ll enhance the code for proper X.509-V3 certificates later.
  I think the sample code is self explaining - everybody should be able to
take this code and change it for his own purposes.
  The code should compile on all UNIX platforms; it should also compile on
Windows (but this it not tested) - I tried to use strict ANSI C. Attached
makefile is for gcc on LINUX.

I hope that some people will find this code useful. Feel free to use the
code - it=B4s free.
Bye,
		Jochen.

P.S. The LDAP code (and binary libldap.dll for Windows) are available from
http://www.umich.edu/~rsug/ldap/ .
---
Dr. Jochen Keutel		(Senior Consultant (X.500, Security, DCE, ...))
Heinrichstr. 55
64331 Weiterstadt
Germany
E-Mail: [email-masked]; [email-masked]
--=====================_859365458==_
Content-Type: text/plain; charset="us-ascii"
Content-Disposition: attachment; filename="Makefile"

CC = gcc
DEBUGFLAGS = -g
CFLAGS = $(DEBUGFLAGS) -Wall
INCFLAGS = -I/usr/local/ldap-3.3/include
LDFLAGS = $(DEBUGFLAGS) -L/usr/local/ldap-3.3/lib
LIBS = -lldap -llber

all: print_certificates

print_certificates: print_certificates.o
	$(CC) $(LDFLAGS) -o print_certificates print_certificates.o $(LIBS)

print_certificates.o: print_certificates.c
	$(CC) $(CFLAGS) $(INCFLAGS) -c print_certificates.c

--=====================_859365458==_
Content-Type: text/plain; charset="iso-8859-1"
Content-Transfer-Encoding: quoted-printable
Content-Disposition: attachment; filename="Print_certificates.c"

/*
sample code for parsing X.509 certificates
with the LDAP-3.3 LBER routines

Author:
Jochen Keutel
Heinrichstr. 55
64331 Weiterstadt
Germany

E-Mail:
[email-masked]
[email-masked]
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <lber.h>
extern int lber_debug;

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

#define CERT_LENGTH 1000

int main ( int , char ** );
void print_certificate ( unsigned char * , int );
static int print_dn ( BerElement * );
static int print_alg_id ( BerElement * );
static void print_oid ( struct berval * );
static void print_octet_string ( struct berval * );
static int print_public_key_info ( BerElement * );

int main (
  int argc,
  char ** argv)
{
int i_getopt;

FILE * fd;
char * filename;
int ret;
unsigned char * cert;
int length;
int allocated;

setbuf(stdout,NULL);

/* get command line parameters */
while ((i_getopt =3D getopt(argc,argv,"d:f:")) !=3D EOF)
  {
  switch (i_getopt)
    {
    case 'd':	/* debugging */
	lber_debug =3D atoi(optarg);
	break;
    case 'f':	/* file name */
	filename =3D strdup(optarg);
	break;
    default:
	fprintf(stderr,"Usage: ...\n");
	exit(1);
    }
  }

fd =3D fopen(filename,"r");
if (fd =3D=3D NULL)
  {
  perror("error opening input file");
  exit(2);
  }

cert =3D malloc(CERT_LENGTH + 1);
if (cert =3D=3D NULL)
  {
  fprintf(stderr,"malloc of %d bytes failed.\n",CERT_LENGTH + 1);
  exit(3);
  }

length =3D 0;
allocated =3D CERT_LENGTH;
memset(cert,0,CERT_LENGTH + 1);
while ((ret =3D fgetc(fd)) !=3D EOF)
  {
  if (length > allocated)
    {
    cert =3D realloc(cert,allocated + CERT_LENGTH + 1);
    if (cert =3D=3D NULL)
      {
      fprintf(stderr,"realloc of %d bytes failed.\n",
						allocated + CERT_LENGTH + 1);
      exit(4);
      }
    }
  cert[length] =3D ret;
  length++;
  }

print_certificate(cert,length);
printf("\n");

exit(0);
}

void print_certificate(
  unsigned char * cert,
  int len)
{
BerElement ber;
BerElement ber_sav;
int version;
int certificate_number;
char * not_before;
char * not_after;

ber_init(&ber,0);
ber.ber_ptr =3D cert;
ber.ber_end =3D cert + len;

/* version */
ber_sav =3D ber;
if (ber_scanf(&ber,"{{i",&version) =3D=3D LBER_ERROR)
  {
  fprintf(stderr,"no version given; 1 (default) assumed\n");
  }
else
  {
  printf("version: %d\n",version);
  }
ber =3D ber_sav;

/* certificateNumber */
if (ber_scanf(&ber,"{{i",&certificate_number) =3D=3D LBER_ERROR)
  {
  fprintf(stderr,"error for certificateNumber\n");
  exit(1);
  }
else
  {
  printf("certificateNumber: %d\n",certificate_number);
  }

/* signature */
printf("signature: ");
if (print_alg_id(&ber) !=3D 0)
  {
  fprintf(stderr,"decoding of signature failed.\n");
  exit(1);
  }
printf("\n");
  
/* issuer */
printf("issuer:\n");
if (print_dn(&ber) !=3D 0)
  {
  fprintf(stderr,"decoding of issuer failed.\n");
  exit(1);
  }

/* validity */
printf("validity: ");
if (ber_scanf(&ber,"{aa}",&not_before,&not_after) =3D=3D LBER_ERROR)
  {
  fprintf(stderr,"error for validity\n");
  exit(1);
  }
else
  {
  printf("from %s to %s\n",not_before,not_after);
  }

/* subject */
printf("subject:\n");
if (print_dn(&ber) !=3D 0)
  {
  fprintf(stderr,"decoding of subject failed.\n");
  exit(1);
  }

printf("subjectPublicKeyInfo: ");
if (print_public_key_info(&ber) !=3D 0)
  {
  fprintf(stderr,"decoding of subjectPublicKeyInfo failed.\n");
  exit(1);
  }
printf("\n");

} /* end of print_certificate */

static int print_dn(
  BerElement * ber)
{
struct berval ** rdn;
int i;
BerElement ber_rdn;
int no_ava;
struct berval * type;
char * value;

if (ber_scanf(ber,"{V}",&rdn) =3D=3D LBER_ERROR)
  {
  fprintf(stderr,"error decoding distinguished name\n");
  return (-1);
  }
else
  {
  for (i =3D 0;rdn[i] !=3D NULL;i++)
    {
    printf("/");
    ber_init(&ber_rdn,0);
    ber_rdn.ber_ptr =3D rdn[i]->bv_val;
    ber_rdn.ber_end =3D rdn[i]->bv_val + rdn[i]->bv_len;
    no_ava =3D 0;
    while (ber_scanf(&ber_rdn,"{Oa}",&type,&value) !=3D LBER_ERROR)
      {
      if (no_ava !=3D 0)
        {
        printf(" , ");
        }
      print_oid(type);
      printf("=3D %s",value);
      no_ava++;
      }
    printf("\n");
    }
  }
return(0);
}

static int print_alg_id(
  BerElement * ber)
{
struct berval * alg_id;
int option;
BerElement ber_sav;

if (ber_scanf(ber,"{O",&alg_id) =3D=3D LBER_ERROR)
  {
  fprintf(stderr,"error decoding algorithmIdentifier\n");
  return (-1);
  }
print_oid(alg_id);
ber_sav =3D *ber;
if (ber_scanf(ber,"i",&option) =3D=3D LBER_ERROR)
  {
  fprintf(stderr,"no integer option given.\n");
  *ber =3D ber_sav;
  }
else
  {
  printf(" ; option: %d",option);
  }

return(0);
}

static int print_public_key_info(
  BerElement * ber)
{
struct berval * public_key;

if (ber_scanf(ber,"{") =3D=3D LBER_ERROR)
  {
  fprintf(stderr,"error decoding publicKeyInfo\n");
  return (-1);
  }
printf("\n\talgorithmIdentifier: ");
if (print_alg_id(ber) !=3D 0)
  {
  fprintf(stderr,"decoding of algorithmIdentifier in publicKeyInfo=
 failed.\n");
  return(-1);
  }
if (ber_scanf(ber,"O",&public_key) =3D=3D LBER_ERROR)
  {
  fprintf(stderr,"error decoding publicKey in publicKeyInfo\n");
  return (-1);
 =
 }
printf("\n\tpublicKey:\n");
print_octet_string(public_key);
return(0);
}

static void print_oid(
  struct berval * oid)
{
print_octet_string(oid);
}

static void print_octet_string(
  struct berval * octet_string)
{
int i;
for (i =3D 0;i < octet_string->bv_len;i++)
  {
  printf("%2x ",*((unsigned char *)(octet_string->bv_val + i)));
  }
}

--=====================_859365458==_
Content-Type: text/plain; charset="us-ascii"

--=====================_859365458==_--

From: <[email-masked]>
Date: Tue, 25 Mar 1997 16:01:10 -0500
Subject: Delivery-Report (failure) for [email-masked]
To: [email-masked]
Importance: low
Message-Type: Delivery Report

	messsage id:	<[email-masked]>
	subject:	Re: sample X.509 certificates
Delivery failed to [email-masked]
	reason:	 INVALID DESTINATION ADDRESS 

Date: Tue, 25 Mar 1997 13:20:31 +0000
To: [email-masked]
From: Ned Smith <[email-masked]>
Subject: ISO DAM on X.509 download site?

Where can I get a copy of ISO DAM on X.509? (Didn't see it on the IETF-PKIX
web page).
Thanks,
Ned 
Ned Smith~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Intel Architecture Labs  2111 N.E. 25th Ave.  Hillsboro, OR. 97124
Ph: 503.264.2692 Fax: x1805  Email: mailto:[email-masked]
http://www.intel.com/ial/security/index.htm
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Date: Tue, 25 Mar 1997 10:53:01 -0700
To: "Housley, Russ" <[email-masked]>, [email-masked], [email-masked], [email-masked]
From: michael myers <[email-masked]>
Subject: Re: private PKIX-1 extensions

At 05:02 PM 3/24/97, Housley, Russ wrote:
>
>>The extent to which the CA must give notice in some legal sense is a 
>>question perhaps better dealt with in a different forum.  Also, this seems 
>>topic better suited for PKIX-2.  PKIX-2 is intended to address sustaining 
>>operations, such as queries regarding CA policy.
>
>Mike, I do not see this as just a PKIX-2 issue.  In my view, PKIX-4 has a 
>huge impact here too.
>
>Russ
>

No argument.  We agree.  PKIX 4 is hugely relevant to policy issues.   I do
want to consider technical mechansisms as well--how policy gets reduced to
practice.

Michael Myers, Verisign, Inc.
<[email-masked], [email-masked]>

From: Stefan Kelm <[email-masked]>
Date: Tue, 25 Mar 1997 09:12:36 +0100 (MET)
To: [email-masked]
Subject: Re: sample X.509 certificates
Reply-To: [email-masked]

Jochen,

>   I´m sure this is a FAQ - but I don´t know the answer: Where can I find
> some sample X.509 certificates to test my ASN.1 decoding client?

there are some sample X.509 certificates available from:

http://www.magmacom.com/~mbartel/iso/certificates/samples/sample_certificates.html

You might also want to have a look at:

http://www.pca.dfn.de/eng/team/ske/pem-dok.html#CA

where I collected links to several certification authorities, most of which
offer certificates to download and test.

Cheers,

	Stefan.

______________________________________________________________________________
Stefan Kelm                                                  <[email-masked]>
DFN-PCA, University of Hamburg                    http://www.pca.dfn.de/~kelm/
Vogt-Koelln-Str. 30             "finger [email-masked]" to get my PGP key
22527 Hamburg (Germany)          Tel: +49 40 5494 2262 / Fax: +49 40 5494 2241

Date: Mon, 24 Mar 97 17:02:33 
From: "Housley, Russ" <[email-masked]>
Encoding: 699 Text
To: [email-masked], [email-masked], [email-masked], michael myers <[email-masked]>
Subject: Re: private PKIX-1 extensions

>>>Must a PKIX conformant CA confirm all data, or may it give notice 
>>>that private extensions values {x, y, z} are unverified.
>>
>>PKIX-1 is silent here. I *believe* that is a policy issue, and could 
>>be addressed with the PKIX-1 policy qualifiers.  Carlisle, does PKIX-3 
>>address this issue?
>
>The extent to which the CA must give notice in some legal sense is a 
>question perhaps better dealt with in a different forum.  Also, this seems 
>topic better suited for PKIX-2.  PKIX-2 is intended to address sustaining 
>operations, such as queries regarding CA policy.

Mike, I do not see this as just a PKIX-2 issue.  In my view, PKIX-4 has a 
huge impact here too.

Russ

Date: Tue, 25 Mar 1997 08:01:34 --800
From: [email-masked] (Robert Deng)
To: [email-masked]
Subject: unsubscribe

unsubscribe

Date: Mon, 24 Mar 1997 22:39:45 +0100
From: Jochen Keutel <[email-masked]>
Reply-To: [email-masked]
Organization: private
To: [email-masked]
Subject: sample X.509 certificates

Hello,
  I=B4m sure this is a FAQ - but I don=B4t know the answer: Where can I f=
ind
some sample X.509 certificates to test my ASN.1 decoding client?
Thanks,
		Jochen.

Date: Mon, 24 Mar 1997 11:54:39 -0800
To: [email-masked]
From: Peter Williams <[email-masked]>
Subject: pkix part 2

-----=_=_ 235860191-6741220-12279392 _=_=---
Mime-Version: 1.0
Content-Type: text/plain; charset="us-ascii"

I ran a little technology experiment to gauge how realistic some of the
elements of the PKIX-2 I-D recently published is in today's world. Here
is the activity in summary, the repeatable results,
and some first generation comments and/or recommendations about
scope and content which derived from my own first review of
the entire ID.

I took the recent PKIX 2 draft to heart, and played with
some technology to see how it works with available
multi-vendor products, which were not specifically
designed to work together. This is a good Internet test
when analysing protocols.

I received a bunch of signed S/MIME messages (0 mins)
in my UA, and then exported a group of certificate chains (without
their current CRLs, I believe) belong to principals I deal with from
my security manager as p7c files (S/MIME chains used to convey
certificates and associated Crls) using the Worldtalk/Demings/S-MIME
email package plugin to Eudora.

When selecting names for listing, I used highly descriptive long file
names which were obtained by cutting and pasting the presentation of the
subject DN of the certificate being exported. (30 secs a
name)

I then exposed these files (now formally X.500 objects!) to the
local world on a web server setup with access control, and equipped
set of hierarchical folders on the local file system
to model, X.500 DN-style, an organization of those names for
sensible listing. (5 mins to install win95 web server, 5 mins
to make some folders)

Using Microsoft Frontpage file import facility, I
filled my DIB (aka webserver file store) and thereby populated
a simple hierarchical DIT (aka set of hierarchically-named folders)
(5 mins). For fun, I created a virtual web URI path also to a portion
of the file store, to emulate a X.500 yellow pages listing, a
and even made an X.500 alias record. (30 secs, + 5 mins for
unessential fun activities)

Then I mailed myself the URL pointer in a signed memo with an
attachment noting the URI to the top page of links listing each
the entry. ( 1 minute) (This was a simulation of the X.509 v3 extension
conveying the URI of the certificate distribution and revocation
service, where such information would more naturally be authoritatively
obtained from.)

Upon accepting the signed message, the browser launches from
within the email package by clicking on the URL in the GUI.
Upon selecting the relevant party using the wonderful search function
known as control-F, and/or navigating down to the RDN listing
tree by clicking on named folders, the browser pulled the
file using http (but could have been https). (an interactive process
taking 60 seconds for me)

Given my local configuration, arrival of the file automatically
invoked the security manager to import the chain. (a laborious 1 minute
per import, given all the rather insistent confirmation dialogs)

Then I sent someone a private mail, having just obtained
their certificate, having had (logical but not actual) 
access to all relevant revocation information from the
web server.

I started then to fiddle with the setup to use ftp, rather 
than http and https, so as to conform with intentions
of the pkix part 2.

Then I asked myself, why does PKIX-2 limit the URI for
this file-centric type of service to only ftp?

One might say, well, ftp can serve bulk download; a whole
batch of cert chains, not just one. But, so can http,
using the client pull, or multipart content response.

The great advantage to using http over ftp in these matters
is that many firewalls will pass the http data to the desktop.
See how Microsoft used http streaming in their delivery of
realtime video/audio etc where folks cannot obtain
udp or rtp within the LAN context.

(http streaming, like http transport of DCOM, and certificate
distribution obviously allows use of https security, for obvious
integrity and some privacy benefits..)

Finally, http based servers are functionally highly advanced
with respect of protection against unwarranted browsing
or trawling of data served via http. Few ftp servers have
the same feature set. Mass distribution of data via http
is not a problem, and does not have to hurt the TCP network
performance when folks navigate, given http keep-alive, and
multipart response options.

The advantage to not excluding http is the ability of
a large number of existing deployed browsers to take part NOW
in certificate distribution and revocation schemes, versus be excluded
due to their absence of support of ldap, or the lack
of CAs offering ldap or X.500 DSP access. My practical
experiments summarized above are put forward as evidence
of this fact.

"
>End entities and CAs retrieve certificates and/or CRLs from the 
>repository using either the Lightweight Directory Access Protocol 
>(LDAP) profile defined in section 2 or the File Transfer Protocol 
>(FTP) profile defined in section 3 of this specification.
>
>Otherwise, entities validate the status of a certificate, by 
>communicating directly with a CA, using the Online Certificate 
>Status Protocol (OCSP) defined in section 4 of this specification.
"
-----=_=_ 235860191-6741220-12279392 _=_=---
Content-Type: application/x-pkcs7-signature; name="smime.p7s"
Content-Transfer-Encoding: base64
Content-Disposition: attachment; filename="smime.p7s"

-----=_=_ 235860191-6741220-12279392 _=_=-----

Comments: Authenticated sender is <[email-masked]>
From: Nick Pope <[email-masked]>
To: [email-masked]
Date: Mon, 24 Mar 1997 15:30:20 +0000
Subject: ipki2opp - encoding of certificates
Priority: normal

The recent Internet Draft PKI Part 2- Operational Protocols, decsribes 
use of LDAP RFC 1777 for retriving certificates.

No mention is made of the use of RFC 1778 definition of the character 
encoded userCertificate, which I understand doesn't work as the 
encoding of the distinguished name cannot be uniquely re-created to 
validate the signature.  Also, this doesn't support X.509 V3.

Do I presume that the Certificate is to be transferred as an DER 
encoded binary carried in the OCTET STRING?

Nick Pope

-------------------------------------

Security & Standards
Suite A
191 Moulsham St.
Chelmsford
Essex
CM2 0LG
U.K.

Tel: +44 1245 495018
Fax: +44 1245 494517

From: <[email-masked]>
X400-Originator: [email-masked]
X400-Recipients: [email-masked]
X400-MTS-Identifier: [/PRMD=BELL.ATLANTIC1/ADMD=TELEMAIL/C=US/;0031600005739800000002]
X400-Content-Type: P2-1988 (22)
To: "ietf-pkix(a)tandem.com" <[email-masked]>
Subject: unsubscribe
Date: Mon, 24 Mar 1997 08:04:02 -0500

     unsubscribe

Date: Mon, 24 Mar 1997 05:40:59 -0500
To: [email-masked], [email-masked], [email-masked]
From: Rodney Thayer <[email-masked]>
Subject: Digital Signature Mock Trial
Cc: [email-masked]

>>Date: Fri, 21 Mar 1997 18:37:16 -0500
>>From: Dan Greenwood <[email-masked]>
>>
>>Digital Signature Mock Trial
>>http://www.magnet.state.ma.us/itd/legal/mock1.htm
>>
>>The Commonwealth of Massachusetts Information Technology Division Legal
>>Department will sponsor a mock trial based on a dispute over a digitally
>>signed communication. This will be an online event, probably web-based.
>>There will also be a half-day "court room" mock trial to be held in
>>Boston in the spring. Anyone interested in helping to plan, or
>>participate in one or both of these mock trials should contact Dan
>>Greenwood at [email-masked]. 
>>
>>The purpose of this exercise will be to explore legal ramifications of
>>deploying digital signature technology as a business tool, including:
>>what grounds for a claim (consumer law, financial and banking law,
>>common law, other?); what issues arise relative to preserving certain
>>evidence for trial; the legal relationship between an "owner"
>>(subscriber) of a digital signature, a relying party and a certification
>>authority; what other evidentiary admissibility issues arise, how might
>>certain contract terms be interpreted (i.e.: what arguments might be
>>raised related to liability limitations, rights and duties under
>>contract); etc. The case
>>will be tried in a fictional jurisdiction and to fictional parties. 
>>
>>The specific factual pattern (i.e.: who are the parties and what
>>happened to them) will be developed so as to highlight areas of legal
>>uncertainty and maximize the instructional value of this exercise. It is
>>expected that this exercise will assist the
>>Commonwealth of Massachusetts and other interested parties to more
>>efficiently manage liability and to better anticipate legal issues as we
>>look to deploy public key based network solutions. 

Date: Sun, 23 Mar 1997 01:42:12 +0100
From: Jochen Keutel <[email-masked]>
Reply-To: [email-masked]
Organization: private
To: [email-masked], [email-masked]
Subject: decode a X.509 certificate with LDAP 3.3 routines?

Hello,
  has anybody ever tried to decode an ASN.1 encoded X.509 certificate
(V1, V3, ... - whatever) using the decoding functions of Umich=B4s LDAP
3.3 (ber_scanf() and friends)? Esp. an ASN.1 encoded distinguished name
(X.501)?

I did it today - it seems to work ... So - if anybody is interested in
the sample code (which just works - probably with some bugs) - just send
me an e-mail ... Or shall I post this to (one of) the mailing list(s)?

Bye,
		Jochen.

From: "Arsenault, Al W." <[email-masked]>
To: ietf-pkix <[email-masked]>
Subject: subscribe
Date: Fri, 21 Mar 97 15:06:00 EST
Encoding: 1 TEXT

Date: Fri, 21 Mar 1997 13:06:54 -0800
To: [email-masked] (David P. Kemp), [email-masked]
From: Peter Williams <[email-masked]>
Subject: Re: Trust in CAs: Progress?

-----=_=_ 248830565-6741220-12289680 _=_=---
Mime-Version: 1.0
Content-Type: text/plain; charset="us-ascii"

 >Yes, this implicit limit on the meaning of the word "certificate"
>is what we are talking about.

 Belts-and-suspenders (i.e. security in depth) is
>precisely what I believe in.

Subtle difference in declarative semantic models here are matters
of belief, and its obviously religious. Bits are no use
for conveying these matters. Its unlikely the PKIX entire world
will adopt a single religion.

There are those who believe in one good practice over another
as critical to some degree or other.

Here is what we do, I suggest:

Let CA operators assert the practices they follow via the certificate
policy id fields, and let consumers choose to rely, or not, based on
that explicit disclosure, and their trust in the CA for conforming
to the disclosed operating regulations.

If we agreed on this, then:

split the disclosure in two parts: 

A) certificate policy identifier OID for CA specific matters documented
in its CPS;

B) PKIX std qualifier  - required to be attached to any certificate
representing its issuer is wishing to claim technical conformance to
PKIX, be this to type X (1) or type Y (2) regime as signaled in
the qualifier value indicated.

A mainstream public-service CPS can be expected to enable the operator of a CA
to legally stand behind a type X/Y technical claim to users or relying
parties, and the presence of such disclosures is precisely the sort of
things used to distinguish between CA service offerings, based on
a party's analysis of that disclosure, or a positive recommendation
of a credible other.

 

-----=_=_ 248830565-6741220-12289680 _=_=---
Content-Type: application/x-pkcs7-signature; name="smime.p7s"
Content-Transfer-Encoding: base64
Content-Disposition: attachment; filename="smime.p7s"

-----=_=_ 248830565-6741220-12289680 _=_=-----

Date: Fri, 21 Mar 1997 12:44:54 -0800
To: [email-masked] (David P. Kemp), [email-masked]
From: Peter Williams <[email-masked]>
Subject: Re: Trust in CAs:  Progress?

-----=_=_ 247509778-6741220-12260880 _=_=---
Mime-Version: 1.0
Content-Type: text/plain; charset="us-ascii"

At 09:37 AM 3/21/97 -0500, David P. Kemp wrote:
[...]

>
>This is a non-sequitur.  If an attacker has a collection of
>certificates, either retrieved in bulk from a public directory or
>gleaned from one-on-one communications, he can examine the names and
>the public keys in those certificates. The CA's policy for issuing
>certificates with duplicate public keys has no bearing on whether those
>certificates are subsequently a) posted to a directory or b) treated as
>the equivalent of business cards.  There is no relationship between, or
>assumptions about any linkage between, the CA's issuing policy and the
>user's publication policy.
>
>(3) says *nothing* about what information a CA must collect from
>certificate requestors ("full knowledge of previous legal names") or
>disseminate to the public ("full disclosure").
>

I agree about the public key value; Ive already indicated my
intuition here was wrong. I don't agree about all certs are
inherently public; I wish for example I could have sent
this signed memo without providing the certificate; unfortunately that GUI
option seems to now have disappeared in my plugin...

Lets me use questioning form: I seem to be more effective
in communicating issues with this style:

Does (3) rule mean, for the alias conditions contained
in the rule, that a CA must maintain a list of all aliases
of a subscriber?

In concrete cases, for a type 1 assurance regime, does a
CA need to ask a subscriber to disclose the act of previous
subscription, or list previous legal names used, if their
name has ever changed?

Note: Id expect such matters to be disclosed in a CPS-based
authentication policy, but not mandated as a consequence of
merely conforming to a CA-independent assurance claim involving
POP or possibly not POP.

-----=_=_ 247509778-6741220-12260880 _=_=---
Content-Type: application/x-pkcs7-signature; name="smime.p7s"
Content-Transfer-Encoding: base64
Content-Disposition: attachment; filename="smime.p7s"

-----=_=_ 247509778-6741220-12260880 _=_=-----

Date: Fri, 21 Mar 1997 15:37:21 -0500
From: Chris Tzu <[email-masked]>
Reply-To: [email-masked]
Organization: AT&T
To: [email-masked]
Cc: [email-masked], [email-masked], [email-masked]
Subject: Re: Profiling CN usage

Peter,

Peter Gutmann wrote:
> 
> >This will become a problem as more and more protocols take advantage of
> >X.509 (or whatever the 'public key signed by someone else' standard will
> >be). For example, there is no standard for what should be in the CN for
> >LDAP, etc.
> 
> I suspect I've probably mentioned this here before, I've collected what
> information I could find on X.509 usage, including some comments on the use
> and format of DNs/CNs, in http://www.cs.auckland.ac.nz/~pgut001/x509guide.txt.
> This isn't any attempt at defining a standard profile, but merely "here's what
> others are doing, and some suggestions on what you should try to do" (along
> with traps to watch out for).
> 
> Peter.

This is a very interesting area which is currently being worked
in the IETF IDS Group. In particular, they are progressing toward
a naming plan which applies to user names and CA names in X.509 
certificates.

The proposed naming plan take advantage of the domain name which
everyone is already familiared with, and very scaleable.

See
ftp://ds.internic.net/internet-drafts/draft-ietf-ids-dirnaming-01.txt

BTW, the guide you produced was excellent reading.

Chris Tzu
AT&T
Directory and Security Services

Date: Fri, 21 Mar 1997 13:57:07 -0800
To: [email-masked] (David P. Kemp), [email-masked]
From: Warwick Ford <[email-masked]>
Subject: Re: comments on PKIX-1

David:

At 10:45 AM 3/20/97 -0500, David P. Kemp wrote:
>Just when we had a definitive, openly-published reference for OIW
>algorithm OIDs, we switch to some draft version of an X9.57 document
>that isn't available from ANSI. When the combined 55/57 document is
>published by ISO, it won't be freely available, and the algorithm OIDs
>will probably change to yet a 4th arc.

Unfortunately, the OIW definitions were faulty, and there was little
confidence in the OIW as an ongoing registration location.  ANSI X9 fixed
up the definitions and documented them in X9.57.  MISSI, the Federal
PKITWG, and the PKIX community all agreed to follow these definitions and
the IETF is republishing them in PKIX Part 1.

Draft X9.57 can be ordered from the ABA.  Order details are at www.x9.org;
you are seeking Catalog # X270718 Price: $60.00.  While X9.55 and X9.57
have been contributed to ISO TC68, I understand they will be available as
ANSI X9 standards at least until the final ISO standard is completed and
published, and possibly after that.

>I *implore* Blake Greenlee, Hoyt Kesterson, and Warwick Ford to make
>working drafts of the ISO version of X9.55/57 available to the IETF,
>and when it is published as a final ISO document, secure copyright
>releases from the ISO to republish the ASN.1 definitions in an IETF
>document.

X9.55, during its development, was made available to the PKIX community.
It is now of little interest to the PKIX group since it is technically
aligned with the ISO DAM on X.509.  X9.57 (which is copyrighted) can be
purchased but we are trying to make the PKIX documents sufficiently
self-contained that will generally not be necessary.  The outcome of the
ISO TC68 project is yet to be seen.  If TC68 is prepared to follow ISO/IEC
JTC1 precedents, it will waive copyright on the ASN.1 modules, and they
will be freely available to all.

Warwick

---------------------------------------------------------------------
Warwick Ford, VeriSign, Inc., One Alewife Center, Cambridge, MA 02140
   [email-masked]; Tel: (617)492 2816 x225; Fax: (617)661 0716
---------------------------------------------------------------------

Date: Fri, 21 Mar 1997 11:32:57 -0500 (EST)
From: Simon Spero <[email-masked]>
To: Stef Hoeben <[email-masked]>
cc: [email-masked]
Subject: Re: private PKIX-1 extensions

I thought that the main reason for us doing all these PKIX drafts was to 
create a lowest common denominator profile so we would have something to 
rely on for interoperability even after all these funky extensions start 
getting deployed...  being PKIX-1 compliant should mean that all 
certificates can be usable by all PKIX-1 applications.  Obviously this 
profile won't be general enough to cover all possible applications, which 
is why vendors and certificate issuers will be free to add their  own 
extensions; it's just that if these extensions are made critical, the 
certificate won't be PKIX-1 any more.  This is nothing to be ashamed of- 
it's the great tragedy of OSI: all OSI specs are so huge you have to 
define a subset for each profile.   these other profiles may be supersets 
of PKIX-1, but if they can't interoperate with fully  compliant PKIX-1  
implementations, they shouldn't be called PKIX-1

Simon

------
Now available - The Freddy Hayek Kayak            | "Pass me another elf
Paddle Your Own Canoe! Be Rowed To Surfdom!       | Sergeant- this one's
>From The Taco Institute for Dyslexic Libertarians | split"

To: IETF-Announce:;@tandem.com
cc: [email-masked]
From: [email-masked]
Reply-to: [email-masked]
Subject: I-D ACTION:draft-ietf-pkix-ipki2opp-00.txt
Date: Fri, 21 Mar 1997 09:53:05 -0500
Sender: [email-masked]

--NextPart

 A New Internet-Draft is available from the on-line Internet-Drafts 
 directories. This draft is a work item of the Public-Key Infrastructure 
 (X.509) Working Group of the IETF.                                        

       Title     : Internet Public Key Infrastructure 
                   Part 2: Operational Protocols                                               
       Author(s) : S. Boeyen, R. Housley, T. Howes, 
                   M. Myers, P. Richard
       Filename  : draft-ietf-pkix-ipki2opp-00.txt
       Pages     : 16
       Date      : 03/20/1997

This is the first draft of the Internet Public Key Infrastructure X.509 
Operational Protocols. This document identifies candidate protocols for 
retrieval of X.509 v3 certificates and v2 CRLs as well as a candidate 
protocol for online status checking of X.509 v3 certificates. It is 
proposed that this document serve as the basis for the PKIX Part 2 
standardization effort. Please send comments on this document to the 
[email-masked] mail list.                                            

Internet-Drafts are available by anonymous FTP.  Login with the username
"anonymous" and a password of your e-mail address.  After logging in,
type "cd internet-drafts" and then
     "get draft-ietf-pkix-ipki2opp-00.txt".
A URL for the Internet-Draft is:
ftp://ds.internic.net/internet-drafts/draft-ietf-pkix-ipki2opp-00.txt
 
Internet-Drafts directories are located at:	
	                                                
     o  Africa:  ftp.is.co.za                    
	                                                
     o  Europe:  ftp.nordu.net            	
                 ftp.nis.garr.it                 
	                                                
     o  Pacific Rim: munnari.oz.au               
	                                                
     o  US East Coast: ds.internic.net           
	                                                
     o  US West Coast: ftp.isi.edu               
	                                                
Internet-Drafts are also available by mail.	
	                                                
Send a message to:  [email-masked]. In the body type: 
     "FILE /internet-drafts/draft-ietf-pkix-ipki2opp-00.txt".
							
NOTE: The mail server at ds.internic.net can return the document in
      MIME-encoded form by using the "mpack" utility.  To use this
      feature, insert the command "ENCODING mime" before the "FILE"
      command.  To decode the response(s), you will need "munpack" or
      a MIME-compliant mail reader.  Different MIME-compliant mail readers
      exhibit different behavior, especially when dealing with
      "multipart" MIME messages (i.e., documents which have been split
      up into multiple messages), so check your local documentation on
      how to manipulate these messages.

Below is the data which will enable a MIME compliant mail reader 
implementation to automatically retrieve the ASCII version
of the Internet-Draft.

--NextPart
Content-Type: Multipart/Alternative; Boundary="OtherAccess"

--OtherAccess
Content-Type:  Message/External-body;
        access-type="mail-server";
        server="[email-masked]"

Content-Type: text/plain
Content-ID: <[email-masked]>

ENCODING mime
FILE /internet-drafts/draft-ietf-pkix-ipki2opp-00.txt

--OtherAccess
Content-Type:   Message/External-body;
        name="draft-ietf-pkix-ipki2opp-00.txt";
        site="ds.internic.net";
        access-type="anon-ftp";
        directory="internet-drafts"

Content-Type: text/plain
Content-ID: <[email-masked]>

--OtherAccess--

--NextPart--

Date: Fri, 21 Mar 1997 10:05:39 -0500
From: [email-masked] (David P. Kemp)
To: [email-masked]
Subject: Re: Trust in CAs: Progress?

> From: "Frank O'Dwyer" <[email-masked]>
>
> > what *harm* is there in also requiring the CA/RA to do POP?
> 
> You cannot request certificates without the keyholder's 
> co-operation, unless there is an option somewhere 
> not to involve them(***) in POP.  Otherwise, requiring POP 
> creates an implicit limit on the type of certificate content 
> that can be requested (i.e. only content that keyholders like, 
> unless you're advocating beating keyholders with rubber hoses
> as part of the PKIX-3 protocol). 

Yes, this implicit limit on the meaning of the word "certificate"
is what we are talking about.

Some people (including me) feel that a certificate is something
requested by a keyholder to enable the keyholder to prove something
to someone else.  We believe that the statement "Fred is a bad
credit risk" is a "signed message", not a "certificate".

A certificate issued to BigBank would enable someone to verify
BigBank's assertion that Fred defaulted on a loan.  But BigBank
does not become a CA just because it wants to sign unflattering
descriptions of it's deadbeat customers.

> > I am not persuaded by Denis' arguments that the benefits of making POP
> > optional outweigh the risks. 
> 
> _What_ risks? Even failing ever to do POP isn't that risky,
> never mind "making POP optional". POP is clearly a belt-and-
> braces measure, since doing POP alone to a CA is worthless.

Agree completely.  Belts-and-suspenders (i.e. security in depth) is
precisely what I believe in.

> It's like vandalising 
> someone's car by scratching your name and address on the 
> paintwork, pasting a photo of yourself on the windscreen, 
> and leaving a note.

Well, yes. Good analogy!  But there *are* some stupid criminals out
there, as well as vandals out to enhance their reputations, and people
who will smash and grab - making the audit trail worthless by the time
it's followed up on.

Date: Fri, 21 Mar 1997 09:49:56 -0500
From: Tim Polk <[email-masked]>
To: [email-masked], [email-masked]
Subject: Re: private PKIX-1 extensions
Content-Length: 2408

Stefan,

> > 
> > Criticality vs. non-criticality isn't an implementation breakpoint. It
> > is not more difficult to issue certs if the extensions are marked
> > critical. However, it may be an interoperability nightmare.  That's
> > why we should reduce the critical/optionally critical set to the
> > bare minimum.
> > 
> > Tim
> > 

> Mmm...

> Isn't it so that most certificates will be used in a limited
> group and with a limited purpose? For example a bank acting
> as a CA, making certs only for its clients. Or a network admin 
> as a CA, making only certs to allow networks acces.

> So in most cases, interoperability won't be important, nobody
> is troubled if she can't read the cert of the network admin
> is she isn't allowed on the network.

I think many people will want to use one certificate for many purposes.
In my opinion, the overhead for a PKI is too high to build another for
each application. Of course, SET is a perfect example of certificates
with a limited use where interoperability is not a concern. Whether
SET is the exception or the rule, I haven't a clue.

> In those cases, isn't the only reason to use X.509 that the
> cert of the CA can be verified, by the users (of the certs of
> that CA), all the way up to Verisign?

In those cases, you may wish to use X.509 so the same certificate
management software can parse the different certificates used in
the different applications, and to leverage COTS products.

> So my point is: isn't it better to give CA's enough freedom
> (by means of private extensions) and thus reduce interopera-
> biltiy?

PKIX-1 explicitly permits use of private extensions, and they *may*
be critical.  If they aren't critical, interoperability isn't really
harmed. Usually, it isn't necessary to make them critical. An application
can always require specific values of private extensions to accept a
certificate, regardless of criticality.

My position is, use all the private extensions you want. Think long
and hard before marking them as critical though; don't sacrifice
interoperability needlessly.

> 			Greetings, Stef

> PS: I don't want to be mean, but I don't think X.509 can
> be used for all purposes: like in the SPKI draft they advertised
> yesterday, identity certs won't play a mayor role, while X.509
> is based on it.

I don't think PKIX or SPKI will serve all purposes.  I expect the two
to co-exist nicely.

Thanks, Tim

Date: Fri, 21 Mar 1997 09:37:46 -0500
From: [email-masked] (David P. Kemp)
To: [email-masked]
Subject: Re: Trust in CAs:  Progress?

> From [email-masked] Thu Mar 20 17:02:50 1997
> X-Sender: peter@mail
> Date: Thu, 20 Mar 1997 14:04:59 -0800
> To: [email-masked] (David P. Kemp), [email-masked]
> From: Peter Williams <[email-masked]>
> Subject: Re: Trust in CAs:  Progress?
> 
> At 08:54 AM 3/20/97 -0500, David P. Kemp wrote:
> >From: Peter Williams <[email-masked]>
> >
> >> >In addition, it is recommended that Type 1 CAs would also perform the
> >> >following check:
> >> >
> >> >3) to verify that the public key that is presented has not already been
> >> >issued by that CA for another entity that is not an alias for the same
> >> >entity.
> >> 
> >> This is not reasonable; it divulges distinct personas may be the same party
> >> by means of public key matching attack. it would require a CA to ensure
> >> it had full knowledge of previous legal names of parties, and ensure
> >> full disclosure.
> >
> >What is a "public key matching attack"?  Certificates are public
> >objects.  If you want to correlate public keys against
> >names/identifiers, you can do so regardless of what checks the CA does
> >or does not perform.
> 
> David,
> 
> I have to admit I tried to read (3) several times trying
> to understand it, and the consequences. So I use the normal tactic of voicing
> an interpretation and having that contradicted with a explanation which I can
> understand. All I can do is try...
> 
> The technique also often highlights assumptions: I dont expect all PKIX
> certificates to be publicly available for browsing. They will be private,
> in many intranet and extranet cases. If obtained by an attacker (given the
> X.509 security model), then there are legal means of restricting the
> *authorised* purposes for which the cert is used, which rely upon reasonable 
> behavior of the recipient. At least one may be able
> to obtain recompense after that fact, and surely such properties
> of accountability due to authentication are desired.
> 
> Many companies do not list their telephone directories publicly, as it
> releases too much internal information to competitors. However, they
> will give you a sensitive business card, peer to peer.
> 
> Many PKIX certificates can be expected to handled according to similar
> real world security conditions. There is a lot of sensitive information
> which can be gleaned from certificates and the dynamics and scope of
> issuing and management!

This is a non-sequitur.  If an attacker has a collection of
certificates, either retrieved in bulk from a public directory or
gleaned from one-on-one communications, he can examine the names and
the public keys in those certificates. The CA's policy for issuing
certificates with duplicate public keys has no bearing on whether those
certificates are subsequently a) posted to a directory or b) treated as
the equivalent of business cards.  There is no relationship between, or
assumptions about any linkage between, the CA's issuing policy and the
user's publication policy.

(3) says *nothing* about what information a CA must collect from
certificate requestors ("full knowledge of previous legal names") or
disseminate to the public ("full disclosure").

Organization: ESAT, K.U.Leuven, Belgium
Date: Fri, 21 Mar 1997 11:03:03 +0100 (MET)
From: Stef Hoeben <[email-masked]>
To: [email-masked]
Subject: Re: private PKIX-1 extensions

> 
> Criticality vs. non-criticality isn't an implementation breakpoint. It
> is not more difficult to issue certs if the extensions are marked
> critical. However, it may be an interoperability nightmare.  That's
> why we should reduce the critical/optionally critical set to the
> bare minimum.
> 
> Tim
> 

Mmm...

Isn't it so that most certificates will be used in a limited
group and with a limited purpose? For example a bank acting
as a CA, making certs only for its clients. Or a network admin 
as a CA, making only certs to allow networks acces.

So in most cases, interoperability won't be important, nobody
is troubled if she can't read the cert of the network admin
is she isn't allowed on the network.

In those cases, isn't the only reason to use X.509 that the
cert of the CA can be verified, by the users (of the certs of
that CA), all the way up to Verisign?

So my point is: isn't it better to give CA's enough freedom
(by means of private extensions) and thus reduce interopera-
biltiy?

			Greetings, Stef

PS: I don't want to be mean, but I don't think X.509 can
be used for all purposes: like in the SPKI draft they advertised
yesterday, identity certs won't play a mayor role, while X.509
is based on it.

From: <[email-masked]>
X400-Received: by mta bath.mail.pipex.net in /PRMD=pipex/ADMD=pipex/C=gb/; Relayed; Fri, 21 Mar 1997 09:53:50 +0000
X400-Received: by mta fel01m2 in /PRMD=pipex/ADMD=pipex/C=gb/; Relayed; Fri, 21 Mar 1997 09:43:47 +0000
X400-Received: by mta bra01c1 in /PRMD=pipex/ADMD=pipex/C=gb/; Relayed; Fri, 21 Mar 1997 09:52:19 +0000
X400-Received: by /PRMD=icl/ADMD=gold 400/C=GB/; converted (ia5-text); Relayed; Fri, 21 Mar 1997 09:53:18 +0000
Date: Fri, 21 Mar 1997 09:53:18 +0000
X400-Originator: [email-masked]
X400-Recipients: non-disclosure:;
X400-MTS-Identifier: [/PRMD=icl/ADMD=gold 400/C=GB/;win0199 0000008800011944]
X400-Content-Type: P2-1984 (2)
Content-Identifier: 11944
Alternate-Recipient: Allowed
To: [email-masked]
Subject: RE: Trust in CAs: Progress?

         I've been listening to the exchanges on the CA POP issue with 
         interest. Here is some further grist to the mill:
         
         A certificate can be viewed as an assertion, and an acceptance of
         some form of accountability for that assertion, by the CA that 
         signed it.
         
         A Type-1 CA (one that does POP) is asserting that it believes that 
         the principal named in the certificate knows the private key 
         associated with the public key in the certificate.
         
         There may be any number of ways in which a CA could be persuaded 
         to assert this (for money of course :-): it may trust another CA 
         that has also asserted it to have asked for POP; it may have asked 
         for POP itself through the PKIX protocol; it may have supplied the 
         private key to the principal itself; it may trust a registration 
         authority (RA) to have done it. So it seems to me that even if 
         PKIX does require that a CA does POP, there are many reasonable 
         ways of doing it, and PKIX shouldn't prescribe a particular 
         protocol as being mandatory.
         
         A Type-2 CA (one that just authenticates the principal) is 
         asserting that the principal named in the certificate is 
         *claiming* to know the private key associated with the public key 
         in the certificate.  However the CA is not endorsing this claim in 
         any way.
         
         If we are to have this distinction it's obviously important that 
         protocol designers know the difference. An application needs to do 
         POP in the second case, but not in the first. Since there seems to 
         be little consensus on these meanings I guess it'll be a while 
         before I start depending on applications using PKI.
         
         In general the principal named in a certificate need have no say 
         in what has been asserted. A CA doesn't need a principal's 
         permission to issue a certificate saying "I believe that Alice is 
         a credit risk", or even "I believe that Alice knows private key 
         corresponding to public key X". Maybe in the first example the 
         principal might sue for libel when in the far distant future the 
         legal infrastructure has caught up with the technology, but that's 
         another thread altogether.  I don't see any reason why Frank 
         O'Dwyer's local security authority shouldn't generate a 
         certificate of its own for a principal using beliefs it has gained 
         from an external certificate. It's up to the principal concerned 
         whether it wants to use it. However Frank's authority wouldn't 
         normally be able to cause the global CA to produce such a 
         certificate since that CA is in no position to assert anything 
         extra - it's unlikely that a global CA would be in a position to 
         trust (and be accountable for) assertions by local CAs that it's 
         probably never heard of.
         
         Some people doubted whether there was a serious attack possible by 
         someone who managed to get a certificate with their name in it but 
         with someone else's public key. I thought that this thread started 
         with one proposed by Denis, and this does seem to work in the real 
         world where time to get through the legal system is a factor. I 
         don't know whether it's considered serious in the Internet 
         community :-) but the X-509 "strong" one way authentication 
         protocol seems to depend on the certificate guaranteeing that the 
         principal in it knows the private key (and is the only person that 
         knows it - something a CA can never assert by the way!).
         
         -----------------------------------------------------------------
         21st March 1997
         
         Tom Parker
         The Solution Centre  
         ICL
         UK
         
         email:    t.a.parker(a)win0199.wins.icl.co.uk
         -----------------------------------------------------------------

Date: Fri, 21 Mar 1997 11:19:10 +1100
From: Michael Warner <[email-masked]>
To: [email-masked]
Subject: Re: Trust in CAs:  Progress?
Cc: [email-masked]

Denis wrote:

> > I still think the proof of possession of the private key HAS to happen
> > in the application protocols - otherwise these protocols are seriously
> > flawed.
> 
> Michael,
> 
> I fully support your statement above which was my original position.
> 
> However, Carlisle pointed out that this would ruled out most of the 
> current protocols, that would need to be redesigned to correct that
> flaw.
> 

I don't know which specific protocols are flawed in this regard.   You
must also consider the threats against which the protocols in question 
are designed to protect - and the way they are used by an application.   

Very few applications would consider as a threat an attacker claiming 
that a message, the contents of which he could not decipher, actually 
came from him.   The only example I remember from Carlisle were E-mail
protocols.   These are designed to prove somebody said something, not
to show they were the only person to say something.   To do the latter
you have to include your identity and encrypt the contents before
signing.   (This is the sort of thing the original example of the
patent office should have done).

But if protocols ARE flawed, then they SHOULD be redesigned.   And NOW is 
a better time than in the future when they would only be more widely 
deployed.

(This said, the only protocol I have seen which really is subject to 
attack without the POP is one we designed !   That was for "emergency
key recovery" in cases where the user has lost his smart card, and
hence his private key.   It was also constrained by the format of the
encrypted messages, and the desire to maintain the confidentiality of
the messages.    And yes I do think we will have another look at it.)

Cheers,

Michael Warner
Telstra Research Laboratories

To: "David P. Kemp" <[email-masked]>, [email-masked]
Subject: Re: Trust in CAs: Progress? 
Date: Thu, 20 Mar 1997 22:06:05 +0000
From: "Frank O'Dwyer" <[email-masked]>

[..]
> what *harm* is there in also requiring the CA/RA to do POP?

You cannot request certificates without the keyholder's 
co-operation, unless there is an option somewhere 
not to involve them(***) in POP.  Otherwise, requiring POP 
creates an implicit limit on the type of certificate content 
that can be requested (i.e. only content that keyholders like, 
unless you're advocating beating keyholders with rubber hoses
as part of the PKIX-3 protocol). 

[...]
> I am not persuaded by Denis' arguments that the benefits of making POP
> optional outweigh the risks. 

_What_ risks? Even failing ever to do POP isn't that risky,
never mind "making POP optional". POP is clearly a belt-and-
braces measure, since doing POP alone to a CA is worthless.  
All you are open to without POP is that an attacker may persuade
the CA to put the attacker's name (and/or authorizations) on someone 
else's key instead of the attacker's key. The attacker still has 
to satisfy the CA in order to get the cert, which means either
circumventing all the CAs checks (i.e. the CA is crap anyhow), 
or leaving an extensive audit trail.  It's like vandalising 
someone's car by scratching your name and address on the 
paintwork, pasting a photo of yourself on the windscreen, 
and leaving a note.

Cheers,
Frank O'Dwyer.

*** I can think of some indirect ways to do POP 
which don't involve the active online participation of the 
keyholder. However they involve third party certificates 
and it gets complex considering the minor risks from not 
doing POP at all.

Still, FWIW: I could request a certificate for you and 
present a 3rd party certificate (e.g. your Verisign 
certificate) in the request. Assuming Verisign did an 
online POP protocol with you, and my CA trusts Verisign 
for this, then you don't have to be involved in (or even 
aware of) the request that I make. Yet, still my CA has 
obtained a reasonable "proof of possession", albeit indirect,
and could issue the certificate.  This would mean that
the PKIX-3 protocol would need to accomodate a certificate
set as one way of doing POP (dunno if it does, but it
could).  

To: "David P. Kemp" <[email-masked]>
cc: [email-masked]
Subject: Re: Trust in CAs: Progress? 
Date: Thu, 20 Mar 1997 22:26:25 +0000
From: "Frank O'Dwyer" <[email-masked]>

> * But if I see that Joe has public key X, and I request a certificate
>   for public key X, then I may be trying to impersonate Joe by exploiting
>   an incompetent application protocol.

Can you give a concrete example of this?  It sounds like 
such an application would have to blindly accept a certificate
without doing any checks whatsoever. It's difficult
to come up with an example of this that doesn't have worse
problems.  If the app is so broken that it doesn't care 
about the private key, why would it care about the public 
key, or the CA name for that matter?  Couldn't I just make 
up any old certificate for this app? Or why not send in Joe's 
actual certificate in order to impersonate Joe?

After all, it's not like I need Joe's key or anything :-)

Cheers,
Frank O'Dwyer

Date: Thu, 20 Mar 1997 14:04:59 -0800
To: [email-masked] (David P. Kemp), [email-masked]
From: Peter Williams <[email-masked]>
Subject: Re: Trust in CAs:  Progress?

At 08:54 AM 3/20/97 -0500, David P. Kemp wrote:
>From: Peter Williams <[email-masked]>
>
>> >In addition, it is recommended that Type 1 CAs would also perform the
>> >following check:
>> >
>> >3) to verify that the public key that is presented has not already been
>> >issued by that CA for another entity that is not an alias for the same
>> >entity.
>> 
>> This is not reasonable; it divulges distinct personas may be the same party
>> by means of public key matching attack. it would require a CA to ensure
>> it had full knowledge of previous legal names of parties, and ensure
>> full disclosure.
>
>What is a "public key matching attack"?  Certificates are public
>objects.  If you want to correlate public keys against
>names/identifiers, you can do so regardless of what checks the CA does
>or does not perform.

David,

I have to admit I tried to read (3) several times trying
to understand it, and the consequences. So I use the normal tactic of voicing
an interpretation and having that contradicted with a explanation which I can
understand. All I can do is try...

The technique also often highlights assumptions: I dont expect all PKIX
certificates to be publicly available for browsing. They will be private,
in many intranet and extranet cases. If obtained by an attacker (given the
X.509 security model), then there are legal means of restricting the
*authorised* purposes for which the cert is used, which rely upon reasonable 
behavior of the recipient. At least one may be able
to obtain recompense after that fact, and surely such properties
of accountability due to authentication are desired.

Many companies do not list their telephone directories publicly, as it
releases too much internal information to competitors. However, they
will give you a sensitive business card, peer to peer.

Many PKIX certificates can be expected to handled according to similar
real world security conditions. There is a lot of sensitive information
which can be gleaned from certificates and the dynamics and scope of
issuing and management!

----------

>
>
>> This is far to stringent for the IETF id world to be even strongly
>> recommended.  This is the stuff a given CA policy should be asserting.
>
>I don't understand this objection.
>

I give you my thinking. (No doubt, Ill be shouted at, locally.)

NB (i)

>* If I am a person, and want two (unlinkable) personas, I request two
>  certificates with two different public keys.
>

NB (ii)

>* But if I see that Joe has public key X, and I request a certificate
>  for public key X, then I may be trying to impersonate Joe by exploiting
>  an incompetent application protocol.
>
>It is the second scenario that recommendation 3 addresses, not the first.

I see (ii) impacting both, which is the source of concern, and some
comment on the way of thinking about PKIX CA obligations.

I just don't see PKIX CAs necessarily becoming responsible (legally
or by association) for all these conditions or expectations which
people are placed upon them: its not a CA's duty to protect against
bad design. A CA just does reliable authentication management during
cert issuing and management. The quality of that management is expressed
by its policy id, and substantiated by its CPS or equivalent.

If a CA wants to do more than this (e.g. enable assurance due to
correct and validated design and implementation of a system) then it can
opt to do so, by expressing this in its policy statement. It can then
say in such operating regulations, though shalt be PKIX-3 compliant,
and use software from the following evaluated parties... If you do this,
I offer warranties of value foo, in case I or others screwed up.

In the classified world, this is exactly what NSA/NCSC does (without
the warranties!) but at huge cost. My $6 per basic certificate will
not cover this cost basis, yet its enormously useful.

---------

Now to the lower-end of the X.509 authentication spectrum where we 
consider for persona-based privacy, versus trusted-systems based 
confidentiality.

Persona certs require that the CA know a real id of the party, 
and clearly the notion can, but need not, view one real id mapping
onto several persona certs/names as aliases. (3) seemed
to suggest that formal alias lists would be required to be checked
prior to cert issuance so as to substantiate condition (ii).

There is, because of (3), strong proof that the CA now knows that personas
fred and freda are the same party, and is forced to (legally) know this
fact in order to help protect against (ii). (I agree my intuition
that the public key value matters was wrong.)

The semantics of persona require a CA to vouch that persona "fred"
is a known party, to the same degree as yesterday. Persona CAs did not
previously have to know that fred and freda are the same party; now,
with condition (3) and with the aim of impact (ii) they now *must* know.

If FBI issues a secret warrant to the CA, the CA is now in a position
to divulge all aliases given one, which it must have by virtue
of conformance to the rule. Similarly, if the CA database operators
are bribed.

This is a condition similar to the Scandinavian guy who recently
shut down his PGP anonymous remailer, in order not to compromise
the bindings which were the basis of privacy, where the persona
name was the public key value.

(3) seems to making it harder for the CA persona aims and situation to
fly, in order to protect those in your case (ii). It makes
it easier to track aliases, when the fact of aliasing
is precisely the security/privacy mechanism being sought
by the subscriber.

Perhaps persona CA are out of scope of PKIX?

--------

Finally, a general PKIX model comment: CAs seems to be getting landed
with yet another mandatory obligation as a mere result of existing.

Now, Am I totally stupid or is an X.509 CA not simply responsible
for reliably binding a name and a key (-pair) together to enable
authentication? Not really much different to setting up
a Kerberos or password account, as far as I can tell.

I understand that trusted third parties (TTP) (who perform CA functions)
can do a lot more along the lines of assurance we are mentioning
above. VISA, Mastercard and banks come to mind, here as obvious
candidates for TTPs; perhaps the large phone companies, also.

If PKIX is about establishing a TTP infrastructure for
the internet, lets use that term with its proper meaning then!
This can then include key escrow and anything else one wants,
to do with assurances.
 
Ill need to drum up banking and insurance participation in the
list, not ssl and CA technology vendors, if its the case!

From: [email-masked] (Peter Gutmann)
To: [email-masked]
Subject: Re: Profiling CN usage
Sender: [email-masked]
Reply-To: [email-masked]
Date: Fri, 21 Mar 1997 08:58:53 (NZST)

>This will become a problem as more and more protocols take advantage of 
>X.509 (or whatever the 'public key signed by someone else' standard will 
>be). For example, there is no standard for what should be in the CN for
>LDAP, etc.
                                                    
I suspect I've probably mentioned this here before, I've collected what 
information I could find on X.509 usage, including some comments on the use 
and format of DNs/CNs, in http://www.cs.auckland.ac.nz/~pgut001/x509guide.txt.
This isn't any attempt at defining a standard profile, but merely "here's what 
others are doing, and some suggestions on what you should try to do" (along 
with traps to watch out for).
 
Peter.

Date: Thu, 20 Mar 1997 12:39:48 -0800
To: Carlisle Adams <[email-masked]>, "[email-masked]'" <[email-masked]>
From: Peter Williams <[email-masked]>
Subject: RE: comments on PKIX-1

Carlisle,

I'm very careful to know my place in the IETF - I'm a mailing
list member supplying individual comments; this is all
Im allowed by the rules to do. Ive been through the process
of arguing for or observing consensus directions (PKCS#10 and
PKCS#7), and obtained or seen straw poll agreement from the
meetings, and then its just ignored. Perhaps address this
procedural issue, while I check my spelling; Ill make you a
swap!

Remember as David said, I don't count. So don't worry too
much about my comments. One needs to concentrate on obtaining
buyin from the vendor community by ensuring PKIX is not
too far off of what they are already doing, and is available
with an incremental change or two, and a path forward
for generational improvement.

Reusing what is already there, and allowing full autonomy
of practices, whilst enabling using parties to decide what 
certificates are valuable and which are rubbish, are key to
getting PKIX agreements into conformant, voluntary use, versus
sitting in unused PKIX IDs adopting correct models.

>
>By the way (and I ask this on behalf of quite a number of people),
>"Peter, would you PLEASE get your hands on a spell-checker?"  I
>understand they're available on many different platforms now  :-)

I know. Its pathetic of me. Now that VeriSign has professionals
to do this interfacing and contributing job, I can soon get out of
the way. I honestly believe Ive helped get the best technical people
available, with real assigned resources, to now have
VeriSign contribute to PKIX with more than passing comments
over email! So expect some hopefully valuable stuff soon....

Date: Thu, 20 Mar 1997 12:35:43 -0800 (PST)
From: Patrick Richard <[email-masked]>
To: [email-masked]
Subject: Profiling CN usage

Some people thought that this might be relevant to the PKIX mailing list.

-Pat

[email-masked]

(forwarded from ssl-talk)

>> 
>> My understanding is that Verisign has abandoned using wildcard names for
>> certificates. But other CA's might, use wild cards. Could folks from
>> Thawte and Xcert comment on this please.
>> 
>
> ..[blatant Xcert-is-not-a-CA spam removed]..
>
>
>For example, if you go to http://www.x509.com, our demo site employs 
>essentially "no vetting policy" (beacuse it's a demo site). So you can 
>sign server certs for yourself that have any CN that you want.
>
>It should be noted that there is no RFC standard  profile (that I am
>aware of) that defines semantics with respect to what should actually be in
>the X.509 when using the HTTP protocol (I might be wrong here). It 
>seems to be a de-facto standard driven by whatever is supported in 
>the latest browser(s).
>
>This will become a problem as more and more protocols take advantage of 
>X.509 (or whatever the 'public key signed by someone else' standard will 
>be). For example, there is no standard for what should be in the CN for
>LDAP, etc.
>
>Hopefully, the IETF will profile the semantics for all the protocols 
>necessary, as part of a TLS or PKIX working group, rather than expect it 
>to come from the application working groups (who have a somewhat more 
>'limited' view of security).
>
>I know that last comment will draw some mail.
>
>Later
>
>-Pat
>
> 

Date: Thu, 20 Mar 1997 13:56:23 -0500
From: Tim Polk <[email-masked]>
To: [email-masked], [email-masked], [email-masked]
Subject: Re: private PKIX-1 extensions
Content-Length: 2190

Michael,

>>>Must a PKIX conformant CA confirm all data, or may it give notice
>>>that private extensions values {x, y, z} are unverified.
>>
>>PKIX-1 is silent here. I *believe* that is a policy issue, and could
>>be addressed with the PKIX-1 policy qualifiers.  Carlisle, does PKIX-3
>>address this issue?

>The extent to which the CA must give notice in some legal sense is a
>question perhaps better dealt with in a different forum.  Also, this seems
>topic better suited for PKIX-2.  PKIX-2 is intended to address sustaining
>operations, such as queries regarding CA policy.

As you noted, this question ultimately falls to the lawyers and jurists.
The short term solution is publication of explicit policy statements in
"obvious" places to limit liability.

>We need to also consider the definition of a PKIX-1 conformant CA.

>This issue always reduces to a very simple question:  What do I have to
>implement, given finite budgets, schedules, etc.?  If PKIX-1 conformance
>means "shall not be required to produce (for CAs) or enforce (for UAs) any
>of the non-critical extensions", then I have serious doubts about such code
>ever seeing the light of day, at least on a broad basis.

>In my personal view, criticality vs. non-criticality should be a policy
>issue, subject to review at deployment time, not implementation time.  It
>should not be an implementation breakpoint.

In my opinion (which may be worth precisely what it cost you):

Conformance of a CA to PKIX-1 is a curious animal.  A conforming CA
issues conforming certificates. *If* it issues CRLs, a conforming CA
issues conforming CRLs as well.

Inclusion/support of non-critical extensions isn't required to conform,
but I think many CA products will support them.  Some are performance
enhancements (e.g., authorityKeyIdentifier) while others add real
functionality (e.g., policyMappings).  Think market differentiation.

Criticality vs. non-criticality isn't an implementation breakpoint. It
is not more difficult to issue certs if the extensions are marked
critical. However, it may be an interoperability nightmare.  That's
why we should reduce the critical/optionally critical set to the
bare minimum.

Tim

Date: Thu, 20 Mar 1997 13:37:34 -0500
From: Tim Polk <[email-masked]>
To: [email-masked], [email-masked]
Subject: Re: comments on PKIX-1
Content-Length: 225

Peter,

This kind of detailed commenting is very useful. I am preparing a
new draft for March 26(!) so the timing is excellent.

If you get a chance to review additional sections I would greatly
appreciate it.

Thanks,

Tim

Date: Thu, 20 Mar 1997 12:09 -0500
From: "Simonetti David" <[email-masked]>
To: [email-masked], [email-masked]
Subject: Re: comments on PKIX-1

David,

I'm not sure what you're implying with the MISSI reference below.  MISSI 
recognizes the OIDs of X9.57; the only algorithm of interest registered 
under the INFOSEC arc is for KEA.

David Simonetti
Booz-Allen & Hamilton Inc.
900 Elkridge Landing Road
Linthicum, MD 21090
 ----------
From: David P. Kemp
To: ietf-pkix
Subject: Re: comments on PKIX-1
Date: Thursday, March 20, 1997 11:44AM

> "ISO/IEC and ANSI X9 have also developed a set of standard extensions
>   for use in the v3 extensions field [X.509-AM][X9.55]."
>
> What version of ISO material is X9.55 aligned with? Could we
> drop the double reference is nothing new is added.

I believe that both references are needed.  However, the X9.55 reference
will soon be obsolete.

I understand that ANSI X9 will be dropping both X9.55 and X9.57, making
significant revisions (to 57 at least), and merging them to become a single
(as yet unspecified) document under ISO/IEC JTC1/SC21.

 -------

MISSI's efforts to be compliant with International Standards means that
we are now on our third set of OIDs:

1: the private arc
    joint(2) country(16) us(840) organization(1) gov(101) dod(2) infosec(1)

2: the NIST OSE Implementors Workshop (IOW) arc
    iso(1) identified-organization(3) oiw(14)

3: the arc under the current X9.57, which I don't yet have a copy of
    iso(1) member-body(2) us(840) ???(10040)

Just when we had a definitive, openly-published reference for OIW
algorithm OIDs, we switch to some draft version of an X9.57 document
that isn't available from ANSI. When the combined 55/57 document is
published by ISO, it won't be freely available, and the algorithm OIDs
will probably change to yet a 4th arc.

I *implore* Blake Greenlee, Hoyt Kesterson, and Warwick Ford to make
working drafts of the ISO version of X9.55/57 available to the IETF,
and when it is published as a final ISO document, secure copyright
releases from the ISO to republish the ASN.1 definitions in an IETF
document.

Being compliant with International Standards is nice, but contributing
volunteer labor to develop International Standards which then cannot
be redistributed is galling.

Date: Thu, 20 Mar 1997 10:45:19 -0500
From: [email-masked] (David P. Kemp)
To: [email-masked]
Subject: Re: comments on PKIX-1

> "ISO/IEC and ANSI X9 have also developed a set of standard extensions
>   for use in the v3 extensions field [X.509-AM][X9.55]."
>
> What version of ISO material is X9.55 aligned with? Could we 
> drop the double reference is nothing new is added.

I believe that both references are needed.  However, the X9.55 reference
will soon be obsolete.

I understand that ANSI X9 will be dropping both X9.55 and X9.57, making
significant revisions (to 57 at least), and merging them to become a single
(as yet unspecified) document under ISO/IEC JTC1/SC21.

-------

MISSI's efforts to be compliant with International Standards means that
we are now on our third set of OIDs:

1: the private arc
    joint(2) country(16) us(840) organization(1) gov(101) dod(2) infosec(1)

2: the NIST OSE Implementors Workshop (IOW) arc
    iso(1) identified-organization(3) oiw(14)

3: the arc under the current X9.57, which I don't yet have a copy of
    iso(1) member-body(2) us(840) ???(10040)

Just when we had a definitive, openly-published reference for OIW
algorithm OIDs, we switch to some draft version of an X9.57 document
that isn't available from ANSI. When the combined 55/57 document is
published by ISO, it won't be freely available, and the algorithm OIDs
will probably change to yet a 4th arc.

I *implore* Blake Greenlee, Hoyt Kesterson, and Warwick Ford to make
working drafts of the ISO version of X9.55/57 available to the IETF,
and when it is published as a final ISO document, secure copyright
releases from the ISO to republish the ASN.1 definitions in an IETF
document.

Being compliant with International Standards is nice, but contributing
volunteer labor to develop International Standards which then cannot
be redistributed is galling.

From: Carlisle Adams <[email-masked]>
To: "[email-masked]'" <[email-masked]>, "[email-masked]'" <[email-masked]>
Subject: RE: comments on PKIX-1
Date: Thu, 20 Mar 1997 10:04:40 -0500
Encoding: 70 TEXT

Peter,

>----------
>From: 	[email-masked][SMTP:[email-masked]]
>Sent: 	Wednesday, March 19, 1997 6:29 PM
>To: 	[email-masked]
>Subject: 	comments on PKIX-1
>
>Tim,
>
>here are some comments on PKIX-1 id 03.
>
>
>" This confidence is obtained
>   through the use of public key certificates, which are data structures
>   that bind public key values to subject identities."
>
>This explanation contradicts the mails of Entrust folk on the list.

You know very well that I have said that a certificate *explicitly*
(i.e., syntactically) binds an identity to a public key and *implicitly*
(i.e., semantically) binds that identity to the corresponding private
key.  It is fine to make either statement as long as it is understood
that both must be in force for a certificate to be meaningful.  I have
been stressing the latter statement on this list because some people
seem to have missed this point.

There is no contradiction in the above quote (particularly because it is
talking about data structures -- syntax).

>3.4  Operational Protocols
>
>The term "oeprational protocol" is being used precisly here, in a manner
>different to that now in use by Denny and Carlise on the list.

Peeter, our names are "Denis" and "Carlisle".  Just in case we meet in
Memphis, it might be helpful if we all have our names straight...

>  Part 3 of the PKIX series of specifications defines a set of standard
>   message formats supporting the above functions.  The protocols for
>   conveying these messages in different environments (on-line, e-mail,
>   and WWW) are also specified.
>
>where are they specified?

If we can ever settle the other issues that have taken up so much of
everyone's bandwidth (namely PKCS #7 and POP), perhaps there will be
time to start addressing some of these other things...

By the way (and I ask this on behalf of quite a number of people),
"Peter, would you PLEASE get your hands on a spell-checker?"  I
understand they're available on many different platforms now  :-)

If you can't seem to find one no matter how hard you look, you might
consider reading/correcting what you've written before sending it out on
public mailing lists.  Correct spelling, and maybe even some proper
punctuation, would really make it easier for people to understand what
you're trying to say...

--------------------------------------
Carlisle Adams
Entrust Technologies
[email-masked]
---------------------------------------

Date: Thu, 20 Mar 1997 10:03:27 -0500
From: Tim Polk <[email-masked]>
To: [email-masked], [email-masked]
Subject: Re: private PKIX-1 extensions
Content-Length: 1074

Peter,

> Is a UA receiving a certificate with a keyusage extension
> indicating multiple uses of the keying material required
> to support multiple uses of the single key?

> Or can a PKIX conforming UA correctly reject its
> version of PKIX interworking on such grounds for such
> reason as "unsupported option"?

This one isn't as simple!  Here goes...

A PKIX-1 conforming UA will recognize and process the extension.
The UA is not required to support all of the uses of the key to
accept the certificate.  For example, a UA that only supports
signatures may accept a multi-use RSA certificate for signature
even though it does not implement key exchange.

The UA could also reject the certificate for policy reasons. For
example, if my security policy required separate keys for signature
and key exchange, my UA could reject that certificate.  (Perhaps this
is a ridiculous scenario, since the user could just obtain two
certificates with the same key and different key usage bits.  Still,
PKIX-1 would certainly permit this.)

Did I answer the question?

Tim Polk

Date: Thu, 20 Mar 1997 08:54:12 -0500
From: [email-masked] (David P. Kemp)
To: [email-masked]
Subject: Re: Trust in CAs:  Progress?

From: Peter Williams <[email-masked]>

> >In addition, it is recommended that Type 1 CAs would also perform the
> >following check:
> >
> >3) to verify that the public key that is presented has not already been
> >issued by that CA for another entity that is not an alias for the same
> >entity.
> 
> This is not reasonable; it divulges distinct personas may be the same party
> by means of public key matching attack. it would require a CA to ensure
> it had full knowledge of previous legal names of parties, and ensure
> full disclosure.

What is a "public key matching attack"?  Certificates are public
objects.  If you want to correlate public keys against
names/identifiers, you can do so regardless of what checks the CA does
or does not perform.

> This is far to stringent for the IETF id world to be even strongly
> recommended.  This is the stuff a given CA policy should be asserting.

I don't understand this objection.

* If I am a person, and want two (unlinkable) personas, I request two
  certificates with two different public keys.

* But if I see that Joe has public key X, and I request a certificate
  for public key X, then I may be trying to impersonate Joe by exploiting
  an incompetent application protocol.

It is the second scenario that recommendation 3 addresses, not the first.

Date: Thu, 20 Mar 1997 09:55:10 -0800
From: Denis Pinkas <[email-masked]>
Reply-To: [email-masked]
Organization: Bull
To: Michael Warner <[email-masked]>
Cc: [email-masked]
Subject: Re: Trust in CAs:  Progress?

> I still think the proof of possession of the private key HAS to happen
> in the application protocols - otherwise these protocols are seriously
> flawed.

Michael,

I fully support your statement above which was my original position.

However, Carlisle pointed out that this would ruled out most of the 
current protocols, that would need to be redesigned to correct that
flaw.
 
In the mean time, the lack of POP in the application protocol can be
compensated if the application places the addition trust condition 
(i.e. POP made by the CA) on the CA. This means the flaw is compensated
by procedural rules that are assumed to be followed by the CA without
any proof for the user - at the time he is making a verification.
"Proof" is then replaced by "trust".

I believe that there is a possibility for applications using a flawed
protocol and trusting CAs to be of type 1 to work fine when a single CA 
is involved. When a single CA is used (e.g. a company CA) it is possible 
to trust it to do POP effectively.

I do not believe that these applications can work correctly with CAs of
type 1, when more than one CA is involved because these CAs would have
to 
make sure that they do not issue a certificate which contains the same 
public key value that is already contained in a certificate already 
issued by another CA ... and this is impractical.

Now, in order to reach a compromise we ended up with these two classes 
of CAs (that we called type 1 and type 2). As you know, a compromise 
is not always that beautiful.

Of course, if the conclusion from the group was to consider only CAs 
of type 2 (hence making these types irrelevant), that would be OK 
with me.      :-)

Finally, Michael Myers is right when he says that this relates to 
PKIX Part 4, ... as long as we say in part 3 that the POP protocol is
optional (that was the start of the discussion).

Denis

-- 

      Denis Pinkas     Bull S.A.         E-mail : [email-masked]
      Rue Jean Jaures  B.P. 68            Phone : 33 - 1 30 80 34 87
      78340 Les Clayes sous Bois. FRANCE   Fax  : 33 - 1 30 80 33 21

From: <[email-masked]>
Date: Thu, 20 Mar 97 09:36:50 +0800
To: [email-masked]

Item Subject: cc:Mail Text
     unsubscribe [email-masked] ietf-pkix

Date: Wed, 19 Mar 1997 16:45:09 -0700
To: [email-masked]
From: michael myers <[email-masked]>
Subject: ABA Information Security Committee

All--

Since we're on the subject of certificate policies in general, it seems
reasonable to let folks know of a forum where they can participate in its
continued evolution.

--Mike

=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=
=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=
=3D=3D=3D=3D=3D=3D=3D=3D=20
                  MEETING NOTICE=20
=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=
=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=
=3D=3D=3D=3D=3D=3D=3D=3D=20

Please correspond with:=20
  Michael S. Baum, Esq.=20
  One Alewife Center Suite 350=20
  Cambridge, MA 02140 USA=20
  V: +1 617.661.1234=20
  F: +1 617.661.0716=20
  E: [email-masked]=20

Subject: INFORMATION SECURITY COMMITTEE MEETING NOTICE - MAY 4-6, 1997

Dear Committee Member and Prospective Members:=20

You are cordially invited to participate in a meeting of the Information
Security Committee, Section of Science & Technology, American Bar
Association, on Sunday-Tuesday, May 4-6, 1997, at the Academy of the Patent
Trademark Office, in Arlington, Virginia.  The Committee will continue its
advancement of public key infrastructure legal and control issues, as
outlined below. This meeting will include further work on commercial key
escrow guidelines, PKI evidentiary issues, digital signature legislative
initiatives, CA and user liability, and PKI accreditation, among other
matters.=20

Consistent with Section policy, ISC meeting participants MUST be members of
both the ABA and the ABA Section of Science and Technology. Please contact
Ann Kowalsky, Manager Section of Science & Technology, at ABA offices in
Chicago by phone: +1 (312)988.5599, fax: +1 (312)988.5628, or email:
[email-masked] for membership information. It is possible to
become a paid member of the ABA and the ISC at the meeting -- and affiliate
ABA membership is also available for non-lawyers.=20

Meeting details appear below. I look forward to seeing you in Arlington.

Sincerely,=20

Michael S. Baum=20
Chair, Information Security Committee=20
Section of Science & Technology, ABA=20

=20
---------------=20

INFORMATION SECURITY COMMITTEE=20
Section of Science & Technology, ABA=20
May 4-6, 1997=20

Tentative Agenda=20
(see "Meeting Details," next page)=20
(In extended sessions, breaks will be taken as needed.)=20

May 4, 1997 Sunday (Casual Dress)
 9:30-10:00 Greetings, breakfast, administrative matters=20
10:00-10:30 Introductions, meeting logistics, general announcements=20
10:30-12:00 Updates =96 Work Groups and non-ISC developments of interest
12:00-17:00 WG breakouts, including a working lunch (pizza takeout on-site)
17:00-??:?? Watering hole discussions; possible continuation of WG meetings

May 5, Monday (Business dress)
 8:30-09:00 Breakfast, et cetera
 9:00-12:00 Breakout sessions; legislative WG conference call
12:00-13:00 Lunch speaker/Discussion: Art Purcell, Esq., PTO
13:00-17:00 Breakout sessions

May 6, Tuesday (Business dress)
 8:30-09:00 Breakfast, et cetera.=20
 9:00-12:00 Breakout sessions;
12:00-13:00 Lunch speaker/Discussion: TBA
13:00-14:00 WG wrap-ups
14:00-16:00 WG Presentations
16:00-16:30 Path forward; wrap-up=20

            Information Security Committee=20
             Arlington, VA MEETING DETAILS=20
                       May 4-6, 1997=20

Members are urged to participate in one of the work groups that will be
presenting/meeting during the ISC's meeting. Please contact Ruven Schwartz,
Esq. ([email-masked]) for further information.=20

**Accreditation Work Group=20
Contacts: 	Chas Merrill, Esq. ([email-masked])
		Lynn McNulty ([email-masked])=20
		Rick Hornbeck ([email-masked])

The accreditation work group has recognized two main functional groups: an
"Accreditation Process Group" (APG) and a "Combined Standards Group" (CSG)
made up of technical, legal, and possibly business standards groups.  The
CSG will eventually create an "attribute table" covering attributes of all
of the available certificates from various CAs. The APG will focus on the
who and how of the accreditation process.  The Accreditation/Standards
Subcommittee will consider the legal implications of standards, and do a
theoretical walk through of some of the standards.

**"Addendum" Work Group=20
Contact: 	Joseph Alhadeff, Esq. ([email-masked])
		Tom Smedinghoff, Esq. ([email-masked])=20
		Joe Wackerman, Esq. ([email-masked])=20

The Addendum Work Group will continue drafting a digital signature trading
partner agreement -- integrating the principles of the Digital Signature
Guidelines, and developing additional practical commentary for this model
form of electronic commerce agreement.=20

**Evidentiary Work Group=20
Contact: 	Gary Fresen, Esq. ([email-masked])
		Stan Kurzban, Esq. ([email-masked]) or=20
		Serge Parisien, Esq. ([email-masked])=20

The Evidentiary Work Group will continue working on the document it is
preparing to acquaint jurists, practitioners, and those participating in
electronic commerce with evidentiary implications of digitally signed
documents.=20

**Key Escrow Work Group (KEWG)=20
Contacts: 	Emily Frye ([email-masked]) or
		Dwight Olson, Esq. ([email-masked])=20

The Key Escrow Working Group will meet and discuss the related projects
that it has undertaken. The first project was to draft guidelines for
voluntary key escrow services.  The second project was to examine the legal
authorities under which government is currently entitled to gain access to
encryption keys or "So you want to run a Key Recovery Facility" Tutorial.
The group will share information and hand out assignments to move these
projects ahead.  The group will also focus on its BXA response letter and
the efforts underway in the "IBM" Key Recovery Alliance.

**Liability Work Group=20
Contact: 	Maureen Adamache, Esq. ([email-masked])=20

The Liability Subcommittee will continue plugging existing legislation into
the various liability models in the liability analysis previously developed
by the WG. In addition, it will consider two new issues: the liability of
the application software provider, and the allocation of liability as
between all parties other than the end user. Finally, it will liaise with
the Accreditation/Standards Subcommittee as required.  A third new issue
will be liability derived from consumer protection law.

**State Government Digital Signatures Laws & Regulations=20
Contacts: 	Kenneth Allen, Esq. ([email-masked])
		Dan Greenwood, Esq. ([email-masked])
		Dale Juffernbruch, Esq. ([email-masked])

The Work Group will hold the third conference call of jurisdictions with
electronic or digital signature legislation that has been enacted or is
pending.  The call will provide an opportunity for updates on legislative
and regulatory developments and discussion of topics related to the
drafting and interpretations of such legislation.  The Work Group will also
continue to draft several papers on the following issues as they relate to
legislation or regulation: consumer protection and consumer education;
liability limitations; accreditation of certification authorities; the
appropriate level of detail and scope of regulation; the definition of
"signature" and "writing" or "record"; evidentiary clauses; and other
topics.  Persons interested in contributing to one or more topic paper
should contact one of the aforementioned people.

Attire for the meeting will be casual on Sunday, and business on Monday and
Tuesday

First-time participants planning to attend the May 4-6 meeting must contact
Ruven Schwartz, ISC ViceChair, at 612-687-8095 or [email-masked], to
coordinate work-product contributions for the upcoming meeting.=20

Meeting Location:=20
Patent and Trademark Academy
Crystal Square Building 4
1745 Jefferson Davis Highway
Arlington, VA 22202

Meals: TBA=20

Lodging:  There are three hotels within a block of the Patent and Trademark
Academy.  The Sheraton is offering rooms for  $128/night if you include a
Saturday night stay.  For only Sunday and Monday, the price is $142/night.
Make sure you mention the ABA Information Security Committee.  Reservations
must be made two weeks prior to the meeting (1-800-862-7666).  The Crystal
Gateway Marriott is offering a rate of $94/night (mention the SuperSaver)
or a double occupancy for $99/night (mention the ISC).  These prices are
not guaranteed so make reservations as soon as possible (703-413-5500).
Unfortunately, the other near by Marriott is sold out for Monday night.

RSVP: Please confirm your intention to participate to Ann Kowalsky, Section
Manager, Section of Science and Technology ([email-masked]) as
soon as possible.=20

See you in Arlington at the PTO facilities.

=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=
=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=
=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D

Date: Wed, 19 Mar 1997 15:29:08 -0800
To: [email-masked]
From: Peter Williams <[email-masked]>
Subject: comments on PKIX-1

Tim,

here are some comments on PKIX-1 id 03.
Peter.

2  Requirements and Assumptions

...
"Some communities will need to supplement, or possibly replace, this
   profile in order to meet the requirements of specialized application
   domains or environments with additional authorization, assurance, or
   operational requirements."

one should note that non-conformance is a therefore not a condition following
on from going beyond the profile to address increased requirements.

"...and interoperability determined by policy"

One might amend this to say "explicit PKIX-1" policy indications

"This manifests itself in minimal user configuration responsibility
   (e.g., root keys, rules), explicit platform usage constraints within
   the certificate"

This would seem to imply that platforms such as Microsofts
netscape/https-compatible browser, or the authenticode of object signing
platforms, cannot and can never be PKIX-1 conformant, where usage
constraints are hardly minimal controls.

3  Overview of Approach

The Definition of "repository" should perhaps be noted as being
something rather different to that defined by the ABA Digital Signature
guidelines which has relevance to certification semantics, versus a
database for storage. Id even suggest returning to DIB as the term,
to avoid confusion.

"end entity:  user of PKI certificates and/or end user system that
                the PKI certifies;"

A PKI does not certify anything. Only CAs certify anything, and they
certify keys (aka issue and manage certificates)
3.1  X.509 Version 3 Certificate

>
>   Application of public key technology requires the user of a public
>   key to be confident that the public key belongs to the correct remote
>   subject (person or system) with which an encryption or digital
>   signature mechanism will be used.:

replace final or with "and/or"

" This confidence is obtained
   through the use of public key certificates, which are data structures
   that bind public key values to subject identities."

This explanation contradicts the mails of Entrust folk on the list.

 "because a certificate's
   signature and timeliness can be independently..."

define timeliness. Does it mean validity? Independent of what? The issuing
CA? This would seem to upset Novell/CertCo/Zions model of PKIs whch
demand that some assurnace reuqire dependent access to a CA's (ABA)
repository.

"ISO/IEC and ANSI X9 have also developed a set of standard extensions
   for use in the v3 extensions field [X.509-AM][X9.55]."

What version of ISO material is X9.55 aligned with? Could we 
drop the double reference is nothing new is added.

"> In order to develop interoperable
>   implementations of X.509 v3 systems for Internet use,"

add the word "standard" prioir to Internet. There is already a 50 vendor
interoperable X.509 user community out there...based around Netscape
X.509!

 " Environments with additional requirements may build on this profile
   or may replace it."

this makes it clear that PKIX-1 is not a mandatory component of
a PKIX conformant system. If PKIX-3 depends upon PKIX-1 for
its assurnace properties, this is a problem!

3.2  Certification Paths and Trust

"If the public-key user does not already hold an
   assured copy"

define "assured copy".

"Such chains, called certification paths, are
   required because a public key user is only initialized with a limited
   number (often one) of assured CA public keys."

The "often one" is probably not true. 60 million browsers have
many "assured keys". I dont know of an internet community even a tength of
that size which has single key designs.

3.2  Certification Paths and Trust

I find the whole anti PEM rant is not useful. This looks
like old Entrust marketing material. One might reduce a page to the statement
that PCA can be identified by policy signals, and conformant use
of critical usage constraints, implemented by trusted software, can
lead to the same intended effect as the PEM name subordination rule.

The standard does not benefit from this rendition of history.

3.3  Revocation

 "Such circumstances might include change of name, change of
   association between subject and CA (e.g., an employee terminates
   employment with an organization), "

the example change of association is merely a change of right to
use a name. An example of change of association with a CA would be 
'user fails to maintain agreed upon obligation to, say, adopt a
pledge or fulfill other promise undertaken as a condition
of issuing.'

">(e.g., an employee terminates
>   employment with an organization), and compromise or suspected
>   compromise of the corresponding private key.  Under such
>   circumstances, the CA needs to revoke the certificate."

One might distinguish between revoke the cert, and suspsend the
cert, when revocation status can be withdrawn upon inquiry.

>A CRL is a time stamped list
>   identifying revoked certificates which is signed by a CA and made
>   freely available in a public repository."

One shoudl limit which CAs are allowed to emit the CRL. "a" CA is
a little vague.

"public repostory" should be amended. Not all CAs will be publicly
available.

"and policy may specify that
   the latter CRL be updated and issued more frequently than the former."

I assume this information can be derived from a PKIX-1 signal,
nominally the policy identifier. This seems to against the grain
for having just a few std policy identifiers a la Federal govt
regimes. A great deal more granulaity is required. Also,
significant configuration will be required at using systems
to cater for many more error cases on the availability expectations
for each discrete class of critical revocation reason.

" It is one goal of this
   document to specify such profiles."

Perhaps we should just specify a single profile to engender
interoperablity.

"   Furthermore, it is recognized that on-line methods of revocation
   notification may be applicable in some environments as an alternative
   to the X.509 CRL.  On-line revocation checking eliminates the latency
   between a revocation report and CRL the next issue.  Once the
   revocation is reported, any query to the on-line service will
   correctly reflect the certificate validation impacts of the
   revocation.  Therefore, this profile will also consider standard
   approaches to on-line revocation notification."

One should not that this "standard" approach is not derived from
X.509s security threat model. The basis for believing the claim above is
not stated - why should a user believe a CA's/other's query response is
timely, and uptodate?

3.4  Operational Protocols

The term "oeprational protocol" is being used precisly here, in a manner
different to that now in use by Denny and Carlise on the list.

With respect to MIME types, it would be nice if the IETF adopted
the Netscape MIME types currently used by most Internet certificate
using systems in the world.

3.5  Management Protocols

   "Management protocols are required to support on-line interactions
   between Public Key Infrastructure (PKI) components."

offline management protocols are also required.

"(a)  registration:  This is the process whereby a user first makes
   itself known to a CA, prior to that CA "

substitute first "CA" with CA/LRA, and second "that CA" with "an associated
CA"

I'd quibble alot with this explanation if it was a definition ; making
oneself known is so vague.

" (c)  certification:  This  is the process in which a CA issues a
   certificate for a user's public key, and returns that certificate to
   the user's client system and/or posts that certificate in a public
   repository."

A CA need not perform the last posting of a certificate to a public
DIB. Not all users wish to be listed, if you ask them.

"   (d)  key pair recovery:  As an option, user client key materials
   (e.g., a user's private key used for encryption purposes) may be
   backed up by a CA or a key backup system associated with a CA.  "

Or, the key backup may occur with a key recovery center wholly
unrelated to the CA.(under the latest OECD rules...!)

The text now says that indeed offline protocosl are permitted. Good.

  Part 3 of the PKIX series of specifications defines a set of standard
   message formats supporting the above functions.  The protocols for
   conveying these messages in different environments (on-line, e-mail,
   and WWW) are also specified.

where are they specified?

Are propetiary transport protocols allowed to claim conformance to
PKIX;

must all transport protocols be supproted by conformant PKIX systems? at
least one?

------

Tim,

if this kind of detailed commenting is useful, Ill continue with
section 4 later. Let me know.

Date: Wed, 19 Mar 1997 16:17:55 -0700
To: Carlisle Adams <[email-masked]>, "[email-masked]'" <[email-masked]>
From: michael myers <[email-masked]>
Subject: Re: Trust in CAs:  Progress?

At 01:01 PM 3/19/97 -0500, Carlisle Adams wrote:
> . . .
>
>Comments?
>
>
>--------------------------------------
>Carlisle Adams
>Entrust Technologies
>[email-masked]
>---------------------------------------

It is perhaps more appropriate to say there exists at least two classes of
certification practices (denoting a "CA" as a organizational entity vs. a
specific signing key), not necessarily two different CAs.  The latter
conjures up the notion that I must go to Entity A if I want a certain
class, but must go to Entity B if I want the other class.  This is simply
not the case.  It is well within the technical, legal and business
capabilities of today's public CAs to do host multiple signing keys, each
associated with a well-defined certificate policy.  Such public entities
may or may not be relevant to a given operational environment, but they do
at least provide an irrefutable existence proof.

Actually, the Type 1 and Type 2 categories appear to be subsets of a larger
problem.  Would you agree that there exists many more of these categories,
each discriminated by the degree of diligence required by various elements
of the registration process?  A CA's CPS should spell out the exact details
of its certification policies.

Thirdly, how do we go about making this notion operational?  It should not
be assumed, for example, that every CA will have a Country AVA in its DN.
Some CAs today operate across multiple national jurisdictions.  Use of the
certificate policies extension and qualifiers was the intended direction.

Lastly, I understand that PKIX Part 4 will address the policies issues.
Could we at a minimum resolve to capture the results of our deliberations
into that work product?

--Mike

Michael Myers
Principal Engineer
Verisign, Inc.
<[email-masked], [email-masked]>

From: Carlisle Adams <[email-masked]>
To: "[email-masked]'" <[email-masked]>
Cc: "[email-masked]'" <[email-masked]>
Subject: RE: Trust in CAs: Progress?
Date: Wed, 19 Mar 1997 17:34:20 -0500
Encoding: 50 TEXT

Hi Gene,

>----------
>From: 	[email-masked][SMTP:[email-masked]]
>Sent: 	Wednesday, March 19, 1997 4:18 PM
>To: 	Carlisle Adams
>Cc: 	[email-masked]
>Subject: 	Trust in CAs: Progress?
>
>Carlisle:
>
>You said that:
>
>"This means that the support of the POP aspect of the certification
>request/response protocol would need to be mandatory if all the
>following conditions are met:
>
>1) the CA is claiming conformance to Type 1;
>2) the user (i.e., end entity) generates the key pair;
>3) an RA is not involved.
>
>For other cases (e.g., the CA is of Type 2, the CA generates the key
>pair, an RA is involved, etc.) support of POP is optional for the CA."
>
>I do not understand what the a CA's ability to claim it does a POP has
>to do with who generates the key pair (2), or if an RA is involved (3)
>in verification or issuance of a certificate.
>
>Are these not independent issues of policy
>and implementation mechanism?

If the CA generates the key pair and gives it to the end entity, there's
no need for the end entity to prove possession of the private key to the
CA (since the CA already knows this!).  Also, if an RA is involved, it
may be the case that it is the RA's responsibility to do POP with the
end entity (i.e., the CA needn't do it).

>Gene Hilborn
>[email-masked]
>

>
>--------------------------------------
>Carlisle Adams
>Entrust Technologies
>[email-masked]
>---------------------------------------
>
>
>

Date: Thu, 20 Mar 1997 09:41:48 +1100
From: Michael Warner <[email-masked]>
To: [email-masked], [email-masked]
Subject: Re: Trust in CAs:  Progress?

Carlisle Adams wrote:
> 
> Denis and I had a long phone conversation yesterday about "Trust in
> CAs".  Of course nothing is definitive yet (comments from the list would
> be helpful) but we need to make some progress on this issue since the
> submission deadline for Memphis is fast approaching...
> 
> Denis proposed the existence of two types of CAs that will be recognized
> in the PKIX-3 profiling section (with possible further discussion in the
> forthcoming part 4):  PKIX-3-compliant Type 1 CAs and PKIX-3-compliant
> Type 2 CAs.
>
> ...
> 
> Comments?
> 

Although my position is that there is no benefit in the CA (or RA or whatever)
verifying that the subject does indeed possess the private key, I must say the
prospect of having different classes of CA based on this attribute is even less
desirable !   All it does is add extra complexity...

I still think the proof of possession of the private key HAS to happen in the
application protocols - otherwise these protocols are seriously flawed.   

In which case, why bother doing them in the certification stage ?

I know Carlisle doesn't agree with this (and I think I'm resigned to that fact).

Cheers,

Michael Warner
Telstra Research Laboratories

Date: Wed, 19 Mar 1997 15:24:47 -0700
To: Tim Polk <[email-masked]>, [email-masked], [email-masked]
From: michael myers <[email-masked]>
Subject: Re: private PKIX-1 extensions

My views . . .

At 10:43 AM 3/19/97 -0500, Tim Polk wrote:
>>Simple questions, simple answers:
>
>>Can a PKIX (PKIX-1) conformant certificate contain private extensions
>
>Yes.

Agree.

>
>>Can a PKIX (PKIX-1) conformant certificate contain private extensions which
>>are critical?
>
>Yes, but it is gently discouraged. ("... certificate issuers are cautioned
>that marking such extensions as critical may inhibit interoperability.")
>

Agree.

>>Must a PKIX conformant CA confirm all data, or may it give notice
>>that private extensions values {x, y, z} are unverified.
>
>PKIX-1 is silent here. I *believe* that is a policy issue, and could
>be addressed with the PKIX-1 policy qualifiers.  Carlisle, does PKIX-3
>address this issue?

The extent to which the CA must give notice in some legal sense is a
question perhaps better dealt with in a different forum.  Also, this seems
topic better suited for PKIX-2.  PKIX-2 is intended to address sustaining
operations, such as queries regarding CA policy.

>
>>Is a UA which enforces a subset of the PKIX-1 profiled extensions
>>conformant to PKIX?
>
>A UA must enforce the extensions that are or may be critical to be
>PKIX-1 conformant.  It need not enforce any of the non-critical extensions.

We need to also consider the definition of a PKIX-1 conformant CA.

This issue always reduces to a very simple question:  What do I have to
implement, given finite budgets, schedules, etc.?  If PKIX-1 conformance
means "shall not be required to produce (for CAs) or enforce (for UAs) any
of the non-critical extensions", then I have serious doubts about such code
ever seeing the light of day, at least on a broad basis.

In my personal view, criticality vs. non-criticality should be a policy
issue, subject to review at deployment time, not implementation time.  It
should not be an implementation breakpoint.

>
>
>Hope this helps.
>
>Tim Polk

Michael Myers
Principal Engineer
Verisign, Inc.
<[email-masked], [email-masked]>

From: <[email-masked]>
To: [email-masked]
cc: [email-masked]
Date: Wed, 19 Mar 1997 17:18:20 -0400
Subject: Trust in CAs: Progress?

Gene Hilborn/SED/CSC
03/19/97 05:18 PM

Carlisle:

You said that:

"This means that the support of the POP aspect of the certification
request/response protocol would need to be mandatory if all the
following conditions are met:

1) the CA is claiming conformance to Type 1;
2) the user (i.e., end entity) generates the key pair;
3) an RA is not involved.

For other cases (e.g., the CA is of Type 2, the CA generates the key
pair, an RA is involved, etc.) support of POP is optional for the CA."

I do not understand what the a CA's ability to claim it does a POP has
to do with who generates the key pair (2), or if an RA is involved (3)
in verification or issuance of a certificate.

Are these not independent issues of policy
and implementation mechanism?

Gene Hilborn
[email-masked]

Date: Wed, 19 Mar 1997 13:59:00 -0800
To: Tim Polk <[email-masked]>, [email-masked]
From: Peter Williams <[email-masked]>
Subject: Re: private PKIX-1 extensions

Tim,

I can understand these answers.

Here is a follow on question, and counter-question.

Is a UA receiving a certificate with a keyusage extension
indicating multiple uses of the keying material required
to support multiple uses of the single key?

Or can a PKIX conforming UA correctly reject its
version of PKIX interworking on such grounds for such
reason as "unsupported option"?

At 10:43 AM 3/19/97 -0500, Tim Polk wrote:
>>Simple questions, simple answers:
>
>>Can a PKIX (PKIX-1) conformant certificate contain private extensions
>
>Yes.
>
>>Can a PKIX (PKIX-1) conformant certificate contain private extensions which
>>are critical?
>
>Yes, but it is gently discouraged. ("... certificate issuers are cautioned
>that marking such extensions as critical may inhibit interoperability.")
>
>>Must a PKIX conformant CA confirm all data, or may it give notice
>>that private extensions values {x, y, z} are unverified.
>
>PKIX-1 is silent here. I *believe* that is a policy issue, and could
>be addressed with the PKIX-1 policy qualifiers.  Carlisle, does PKIX-3
>address this issue?
>
>>Is a UA which enforces a subset of the PKIX-1 profiled extensions
>>conformant to PKIX?
>
>A UA must enforce the extensions that are or may be critical to be
>PKIX-1 conformant.  It need not enforce any of the non-critical extensions.
>
>
>Hope this helps.
>
>Tim Polk
>
>
>

Date: Wed, 19 Mar 1997 15:39:38 -0500
To: [email-masked]
From: "Kevin L. Hawkins" <[email-masked]>

unsubscribe [email-masked] ietf-pkix

Kevin L. Hawkins, Manager
FedWorld System Office

Phone: 703.321.0024		
Fax:   703.321.0081
email: [email-masked]

Date: Wed, 19 Mar 1997 12:22:20 -0800
To: Carlisle Adams <[email-masked]>, "[email-masked]'" <[email-masked]>
From: Peter Williams <[email-masked]>
Subject: Re: Trust in CAs:  Progress?

At 01:01 PM 3/19/97 -0500, Carlisle Adams wrote:
>Hi,
>
>Denis and I had a long phone conversation yesterday about "Trust in
>CAs".  Of course nothing is definitive yet (comments from the list would
>be helpful) but we need to make some progress on this issue since the
>submission deadline for Memphis is fast approaching...

>
>Denis proposed the existence of two types of CAs that will be recognized
>in the PKIX-3 profiling section (with possible further discussion in the
>forthcoming part 4):  PKIX-3-compliant Type 1 CAs and PKIX-3-compliant
>Type 2 CAs.

It sould seem sensible to require an issuer of PKIX-1 certs which
claims conformance to on such profile to be require to uniformly
apply the rule to all certs issued, to gain the intended effect.

Im not sure how reasonable this is, however. A PKIX-1 cert issuing
CA can have PKIX-3 access methods, and the industry standard
protocol also, and the MISSI access method, and the EDIFACT procedures,
etc.

One could imagine PKIX-1 certs which are issued according
to one of the "IETF" rule sets of PKIX-3 to be required to make such
an assertion, as a std policy qualifier value.

PKIX-3 protocol supported access methods used with proprietary rule
sets partially including a PKIX-3 rule set can then be
discriminated against by UAs and directories, effectively.

>
>
>A CA of Type 1 would be trusted by any software to perform  the
>following checks.
>
>1) To only issue a certificate after verification of the identity of the
>requester.

Does this allow persona issuing rules: where the CA knows the id, but
place a pseudonym in the "name" field. This is a requirement of
the WG scope, remember.

>
>2) To only issue a certificate after POP (Proof Of Possession of the
>private key), whatever means is used to provide that proof.
>
>In addition, it is recommended that Type 1 CAs would also perform the
>following check:
>
>3) to verify that the public key that is presented has not already been
>issued by that CA for another entity that is not an alias for the same
>entity.
>

This is not reasonable; it divulges distinct personas may be the same party
by means of public key matching attack. it would require a CA to ensure
it had full knowledge of previous legal names of parties, and ensure
full disclosure.

This is far to stringent for the IETF id world to be even strongly
recommended.  This is the stuff a given CA policy should be asserting.

>
>A CA of Type 2 would be trusted by any software to perform only the
>following check.

This phrase "trusted by software" is bizarre. Ca are trusted by
people, not software. delegated trust can be represemted to
software for automatic processing, but accountability for
the reliance decision still pertains to the accrediting
legal person.

>
>1) To only issue a certificate after verification of the identity of the
>requester.
>
>
>Of course, in both cases other minor checks need to be done (such as
>verification of the validity date) but we focus here only on the main
>items.
>

>A CA may claim to be of Type 1 or Type 2.

I sugegsted above a std means of making a std conformance claim
for such generic elements of policy.

 Whatever the CA is claiming to
>be conformant to, the software making use of a certificate may have its
>own belief which depends on the claim from the CA, but may also depend
>upon some other parameters (such as the country in which the CA
>operates, or the government of that country, and so on). 

PKIX should not standardise reliance model. Signing keys may
be duplicated across many boxes, and a CMS may be distributed
trans-nationally. "Where is the CA 'located'?"

 In any case,
>it is up to the software to consider if a CA claiming to be a Type 1 CA
>can be trusted for that claim, or be considered to be a Type 2 CA (which
>involves less trust in the CA).

Id invert the naming of cert classes. Its inevitable we will
want to invent a more stringent class than Type 1....

>
>
>This means that the support of the POP aspect of the certification
>request/response protocol would need to be mandatory if all the
>following conditions are met:
>
>1) the CA is claiming conformance to Type 1;
>2) the user (i.e., end entity) generates the key pair;
>3) an RA is not involved.

Whilst this sound logically, your usual fascist-style policy making
will just make people invent 1.1 rule sets to get the freedom they
desire to run their internet domains according to local needs. not
all PKIX-1 certs will be publicly used, being used only for
extranet, or intranet purposes.

>
>For other cases (e.g., the CA is of Type 2, the CA generates the key
>pair, an RA is involved, etc.) support of POP is optional for the CA.

this model is just to rigid, though I dont disagree with the basic
intent of what is being specified and distinguished here. We will need more
flexibility, if a rigid PKIX is not to be sidelined by industry standards
which have the flexibility to move in sync with markets
and community needs.

>
>
>Uses of CA Type 1 and CA Type 2
>===============================
>
>In many current applications and protocols (popular e-mail protocols are
>one example), the signature is only on the message and does not include
>the certificate (or a part of it, or a hash of it).  These
>applications/protocols can only use CAs of Type 1 (particularly in
>support of non-repudiation) and the software must be able to trust that
>they can really be considered to be Type 1 CAs.

This is not reasonable. Double signing applications and notarization
appcliations remove Denis concerns, currently. Outlawing these
or forcing a type 1 model is not reasonable. There is no reason.

>
>New applications/protocols using a scheme where the certificate (or a
>part of it, or a hash of it) is part of the signed structure may work
>with CAs of Type 2.
>
>This split gives us PKIX-3 protocols which will work in today's
>environment and also gives us an evolution path to the future scenario
>in which all operational protocols are designed correctly (i.e., with
>considerations for non-repudiation built-in) and POP is totally
>optional.
>
>Comments?

having policy-based statement of conformance is excellent. Rigging
the world to a limited number of generic policies is not.

What has happended here is similar to what happened to PEM 1422
in respect of its moving from its previous version of a single assurance
notion, to one supporting multiple notions.

I just saying, in accordance with the WG scope, go the rest of the
way 1422 went, and allow domain operators to define more classes/types.

Unlike 1422/X5090v1 we dont need to use hierarchies to represent the
type/class; when we have v3 policy extensions and std qualifiers
instead.

Definite progress towards an Internet style PKI embracing
lots of ways of thinking, and autonomous policy domains.

>--------------------------------------
>Carlisle Adams
>Entrust Technologies
>[email-masked]
>---------------------------------------
>
>
>
>

Date: Wed, 19 Mar 1997 15:22:17 -0500 (EST)
From: Marc Branchaud <[email-masked]>
To: "[email-masked]'" <[email-masked]>
Subject: Re: Trust in CAs:  Progress?

-----BEGIN PGP SIGNED MESSAGE-----

If I'm reading this right, what's at issue here is POP.  I can see how a
Type-1 CA would be needed in cases where POP is not presented by some
other means (e.g. as a part of the protocol).

What I'm a bit unclear on is how signing a (part of / hash of) a cert
constitutes POP.  Isn't the fact that the signature verifies (no matter
what was signed) enough?  What extra information can be gleaned from the
signed cert?

		Marc

On Wed, 19 Mar 1997, Carlisle Adams wrote:
> 
> [ ... ]
> 
> Uses of CA Type 1 and CA Type 2
> ===============================
> 
> In many current applications and protocols (popular e-mail protocols are
> one example), the signature is only on the message and does not include
> the certificate (or a part of it, or a hash of it).  These
> applications/protocols can only use CAs of Type 1 (particularly in
> support of non-repudiation) and the software must be able to trust that
> they can really be considered to be Type 1 CAs.
> 
> New applications/protocols using a scheme where the certificate (or a
> part of it, or a hash of it) is part of the signed structure may work
> with CAs of Type 2.
> 
> This split gives us PKIX-3 protocols which will work in today's
> environment and also gives us an evolution path to the future scenario
> in which all operational protocols are designed correctly (i.e., with
> considerations for non-repudiation built-in) and POP is totally
> optional.
> 
> Comments?
> 
> 
> --------------------------------------
> Carlisle Adams
> Entrust Technologies
> [email-masked]
> ---------------------------------------
> 
> 

==============================	------ I'M LOOKING FOR A JOB! -----
        Marc Branchaud        	I'm looking for a full-time career,
       [email-masked]       	and I'm willing to move almost any-
    www.zoo.net/~marcnarc/    	where.  You can see my CV online at
==============================	www.zoo.net/~marcnarc/Marc-CV.htm

Date: Wed, 19 Mar 1997 11:31:55 -0800
To: Simon Spero <[email-masked]>
From: Peter Williams <[email-masked]>
Subject: Re: private PKIX-1 extensions
Cc: [email-masked]

Simon,

---

Soap:

I hereby claim "first (recently) talked-about honours" of the executable
X.509 certs (contents)  notion, about 9 months ago on ssl-talk. Furthermore
I reduced it to practice which helps my claim; I had no US govt funding. 

I donated the thought to the ssl-talk list for further study (CCITT-speak
for i didn't know what else to do), mainly as its only a refinement of p-code 
executable multi-part signed IS8613 telematic documents, which ICL and Siemans
"invented" 11 years ago within the OSI framework. Russ Housley can probably
tell us how ICL ripped it off of Xerox demonstrators...produced 5 years
earlier.

Signed parts of HTML in the real, new, year 2000, ultra-cool HTML/java object
signing framework isnt that new! I was a mere 22 years old when
we did this with the technology of yesteryear (known as SGML and p-codes)
and that was based on ECMA draft standards which were at least 1 year old
creating the ODA (office document archictecture) committe's work, 
which was itself based on a shipping IBM product. We used UCL-CS's and BBN's
"Component technology" (another "new" buzz term) to experiment effectively
with security integration. Fun to note that Microsoft ActiveXDocuments and
ODIF (the interchange format for ODA) are remarkably similar, though lack the
multi-dimension parallel structuring capabilties of the object model of
ODA. Oh
well.

I have thought about patenting some interesting applications of
control theory, for such executable certs. In 17 years time they might be
relevant... just as the patent expires!

----

To work:

There are some relevant consequences of saying no, BTW, to Q2, with
the argument you give. Lets see what others say before analysing
them in detail.

Peter.

At 10:44 AM 3/19/97 -0500, Simon Spero wrote:
>On Tue, 18 Mar 1997, Peter Williams wrote:
>
>> Simple questions, simple answers:
>
>hah!
>> 
>> Can a PKIX (PKIX-1) conformant certificate contain private extensions which
>> are critical?
>
>NO! (I hope). In order for a profile to be valid and interoperable, it must 
>specify the complete minimum set of functionality needed for operations. 
>If it isn't in the PKIX profile, you can't require an extension whilst still
>claiming to be a PKIX-1 certificate
>
>Of course, the whole point of critical extensions is that you can do it 
>anyway, and things will fail safe. 
>
>BTW, talking about private extensions; I just dug out my old java 
>cert parser written for an old code-signing project, and got ready to add 
>V3 support, when I had a stroke of inspiration. Once I've grabbed 
>data out of an extension, it's trival to turn it into executable code. 
>
>Think of how much easier it is for CA's to specify access control when you 
>have Executable certificates that can do the checks themselves. And since 
>the code is embedded in a certificate already, it's as trustable as any 
>other signed code from the same source.
>
>Simon
>
>-----
>Now available - The Freddy Hayek Kayak            | "Pass me another elf
>Paddle Your Own Canoe! Be Rowed To Surfdom!       | Sergeant- this one's
>>From The Taco Institute for Dyslexic Libertarians | split"
>
>
>
>

Date: Wed, 19 Mar 1997 14:18:38 -0500
From: [email-masked] (David P. Kemp)
To: [email-masked]
Subject: Re: Trust in CAs:  Progress?

> From: Carlisle Adams <[email-masked]>
> 
> Denis and I had a long phone conversation yesterday about "Trust in
> CAs".  Of course nothing is definitive yet (comments from the list would
> be helpful) but we need to make some progress on this issue since the
> submission deadline for Memphis is fast approaching...
> 
> Denis proposed the existence of two types of CAs that will be recognized
> in the PKIX-3 profiling section (with possible further discussion in the
> forthcoming part 4):  PKIX-3-compliant Type 1 CAs and PKIX-3-compliant
> Type 2 CAs.
>
>  [...]
> 
> This split gives us PKIX-3 protocols which will work in today's
> environment and also gives us an evolution path to the future scenario
> in which all operational protocols are designed correctly (i.e., with
> considerations for non-repudiation built-in) and POP is totally
> optional.
> 
> Comments?

Bletch.

Although this has been an interesting and enlightening discussion,
I still fail to understand Denis' insistence that POP for the CA or RA
be made optional.  Even if in the future every single application protocol
becomes correct, what *harm* is there in also requiring the CA/RA to do POP?

And as Carlisle said previously, as long as there is a single consumer
of certificates that is not properly designed, a CA which does not do
POP is guilty of malpractice.  We would be designing a very brittle
infrastructure if we profile a "PKIX-3-Type-2" CA.  Assuming that every
application and certificate-using protocol is properly designed is a
far larger leap of faith than assuming that every CA does POP.

As far as I can tell, we have nearly smooth consensus on this issue -
there is one person who objects (perhaps two if you count Peter?), and
every one else thinks requiring CAs to prove possession of private keys
is a good idea.  If we need to demonstrate consensus before Memphis,
take a straw poll on the list.  If it can wait until the meeting, have
Jeff do the poll in person.

I am not persuaded by Denis' arguments that the benefits of making POP
optional outweigh the risks. My straw poll ballot is to allow only one
kind of PKIX-3-compliant CA: the correct kind :-).

From: Carlisle Adams <[email-masked]>
To: "[email-masked]'" <[email-masked]>
Subject: Trust in CAs:  Progress?
Date: Wed, 19 Mar 1997 13:01:16 -0500
Encoding: 94 TEXT

Hi,

Denis and I had a long phone conversation yesterday about "Trust in
CAs".  Of course nothing is definitive yet (comments from the list would
be helpful) but we need to make some progress on this issue since the
submission deadline for Memphis is fast approaching...

Denis proposed the existence of two types of CAs that will be recognized
in the PKIX-3 profiling section (with possible further discussion in the
forthcoming part 4):  PKIX-3-compliant Type 1 CAs and PKIX-3-compliant
Type 2 CAs.

A CA of Type 1 would be trusted by any software to perform  the
following checks.

1) To only issue a certificate after verification of the identity of the
requester.

2) To only issue a certificate after POP (Proof Of Possession of the
private key), whatever means is used to provide that proof.

In addition, it is recommended that Type 1 CAs would also perform the
following check:

3) to verify that the public key that is presented has not already been
issued by that CA for another entity that is not an alias for the same
entity.

A CA of Type 2 would be trusted by any software to perform only the
following check.

1) To only issue a certificate after verification of the identity of the
requester.

Of course, in both cases other minor checks need to be done (such as
verification of the validity date) but we focus here only on the main
items.

A CA may claim to be of Type 1 or Type 2. Whatever the CA is claiming to
be conformant to, the software making use of a certificate may have its
own belief which depends on the claim from the CA, but may also depend
upon some other parameters (such as the country in which the CA
operates, or the government of that country, and so on).  In any case,
it is up to the software to consider if a CA claiming to be a Type 1 CA
can be trusted for that claim, or be considered to be a Type 2 CA (which
involves less trust in the CA).

This means that the support of the POP aspect of the certification
request/response protocol would need to be mandatory if all the
following conditions are met:

1) the CA is claiming conformance to Type 1;
2) the user (i.e., end entity) generates the key pair;
3) an RA is not involved.

For other cases (e.g., the CA is of Type 2, the CA generates the key
pair, an RA is involved, etc.) support of POP is optional for the CA.

Uses of CA Type 1 and CA Type 2
===============================

In many current applications and protocols (popular e-mail protocols are
one example), the signature is only on the message and does not include
the certificate (or a part of it, or a hash of it).  These
applications/protocols can only use CAs of Type 1 (particularly in
support of non-repudiation) and the software must be able to trust that
they can really be considered to be Type 1 CAs.

New applications/protocols using a scheme where the certificate (or a
part of it, or a hash of it) is part of the signed structure may work
with CAs of Type 2.

This split gives us PKIX-3 protocols which will work in today's
environment and also gives us an evolution path to the future scenario
in which all operational protocols are designed correctly (i.e., with
considerations for non-repudiation built-in) and POP is totally
optional.

Comments?

--------------------------------------
Carlisle Adams
Entrust Technologies
[email-masked]
---------------------------------------

Date: Wed, 19 Mar 1997 12:31:20 -0500
From: [email-masked] (David P. Kemp)
To: [email-masked]
Subject: Re: private PKIX-1 extensions

> From: Simon Spero <[email-masked]>
> 
> BTW, talking about private extensions; I just dug out my old java 
> cert parser written for an old code-signing project, and got ready to add 
> V3 support, when I had a stroke of inspiration. Once I've grabbed 
> data out of an extension, it's trival to turn it into executable code. 

Perhaps the stroke of inspiration came subliminally from several of Peter's
prior posts on this list.  I agree with Peter that the concept of
executable certificates is an interesting idea.  But it's not trivial.

Executing the data in an extension is trivial.  Agreeing on the
language for that extension (ksh, perl, java, etc) should be trivial, but
probably wouldn't be because someone would always argue for the use of
a non-portable language (i.e. OLE/DCOM/ActiveX/8086 machine code).

Defining/profiling the inputs and outputs to be processed by the
executable extension is the tough part.  We have a scheme called
Partition Rule Based Access Control (PRBAC) which works on predefined
bitmaps and enumerated constants.  A more general scheme called Local
Rule Based Access Control (LRBAC) which would allow local (private
agreement between CA and verifier) definition of privileges and attributes
has floundered due to lack of customer interest.  If a fairly narrow
community can't agree on the need for defining such data objects, getting
agreement from the wider community of CAs, client/server vendors, and
users seems unlikely.

And without agreement on authorization representation, an executable
language to process authorizations is pretty much useless.

Date: Wed, 19 Mar 1997 10:43:05 -0500
From: Tim Polk <[email-masked]>
To: [email-masked], [email-masked]
Subject: Re: private PKIX-1 extensions
Content-Length: 905

>Simple questions, simple answers:

>Can a PKIX (PKIX-1) conformant certificate contain private extensions

Yes.

>Can a PKIX (PKIX-1) conformant certificate contain private extensions which
>are critical?

Yes, but it is gently discouraged. ("... certificate issuers are cautioned
that marking such extensions as critical may inhibit interoperability.")

>Must a PKIX conformant CA confirm all data, or may it give notice
>that private extensions values {x, y, z} are unverified.

PKIX-1 is silent here. I *believe* that is a policy issue, and could
be addressed with the PKIX-1 policy qualifiers.  Carlisle, does PKIX-3
address this issue?

>Is a UA which enforces a subset of the PKIX-1 profiled extensions
>conformant to PKIX?

A UA must enforce the extensions that are or may be critical to be
PKIX-1 conformant.  It need not enforce any of the non-critical extensions.

Hope this helps.

Tim Polk

Date: Wed, 19 Mar 1997 10:44:30 -0500 (EST)
From: Simon Spero <[email-masked]>
To: Peter Williams <[email-masked]>
cc: [email-masked]
Subject: Re: private PKIX-1 extensions

On Tue, 18 Mar 1997, Peter Williams wrote:

> Simple questions, simple answers:

hah!
> 
> Can a PKIX (PKIX-1) conformant certificate contain private extensions which
> are critical?

NO! (I hope). In order for a profile to be valid and interoperable, it must 
specify the complete minimum set of functionality needed for operations. 
If it isn't in the PKIX profile, you can't require an extension whilst still
claiming to be a PKIX-1 certificate

Of course, the whole point of critical extensions is that you can do it 
anyway, and things will fail safe. 

BTW, talking about private extensions; I just dug out my old java 
cert parser written for an old code-signing project, and got ready to add 
V3 support, when I had a stroke of inspiration. Once I've grabbed 
data out of an extension, it's trival to turn it into executable code. 

Think of how much easier it is for CA's to specify access control when you 
have Executable certificates that can do the checks themselves. And since 
the code is embedded in a certificate already, it's as trustable as any 
other signed code from the same source.

Simon

-----
Now available - The Freddy Hayek Kayak            | "Pass me another elf
Paddle Your Own Canoe! Be Rowed To Surfdom!       | Sergeant- this one's
>From The Taco Institute for Dyslexic Libertarians | split"

Date: Wed, 19 Mar 1997 11:39:46 +0200 (EET)
From: Jyri Kaljundi <[email-masked]>
To: Fred Ou <[email-masked]>
cc: [email-masked], [email-masked], [email-masked]
Subject: Re: Looking for random number testing tools

On Tue, 18 Mar 1997, Fred Ou wrote:

>    I have implemented a random number generator based on mouse movement. I am looking for
> tools that will test randomness of the number generated by my software.

Look at the following page, especially "Source code for testing
randomness" section : 

http://www.cs.berkeley.edu/~daw/netscape-randomness.html

Juri Kaljundi
[email-masked]

From: <[email-masked]>
Date: Wed, 19 Mar 1997 08:26:07 +0100 (MET)
To: [email-masked]
Subject: unsubscribe

unsubscribe

Date: Tue, 18 Mar 1997 13:26:45 -0800
To: [email-masked]
From: Peter Williams <[email-masked]>
Subject: private PKIX-1 extensions

Simple questions, simple answers:

Can a PKIX (PKIX-1) conformant certificate contain private extensions

Can a PKIX (PKIX-1) conformant certificate contain private extensions which
are
critical?

Must a PKIX conformant CA confirm all data, or may it give notice
that private extensions values {x, y, z} are unverified.

Is a UA which enforces a subset of the PKIX-1 profiled extensions
conformant to PKIX?

Date: Tue, 18 Mar 1997 11:41:50 -0800
From: Fred Ou <[email-masked]>
To: [email-masked], [email-masked], [email-masked]
Subject: Looking for random number testing tools

Hi,
   I have implemented a random number generator based on mouse movement. I am looking for
tools that will test randomness of the number generated by my software.

Your help is very much appreciated !

-Fred

From: <[email-masked]>
Date: Tue, 18 Mar 97 09:12:35 +0800
Subject: unsubscribe
To: [email-masked]

Item Subject: cc:Mail Text
     unsubscribe

From: Carlisle Adams <[email-masked]>
To: "[email-masked]'" <[email-masked]>
Cc: "'ietf-pkix%tandem.com'" <[email-masked]>
Subject: RE: Trust in CAs
Date: Mon, 17 Mar 1997 15:18:45 -0500
Encoding: 119 TEXT

Hi,

>----------
>From: 	[email-masked][SMTP:[email-masked]]
>Sent: 	Monday, March 17, 1997 9:48 PM
>To: 	Carlisle Adams
>Cc: 	'ietf-pkix%tandem.com'
>Subject: 	Re: Trust in CAs
>
>Carlisle,
>
>It seems that we are now close to an agreement on one point.
>
>> Some people on this list have requested that the proof of possession be
>> done with the RA instead of with the CA.  This is fine to me (after all,
>> the RA is a trusted entity -- in particular, it can be trusted by the CA
>> to have done POP if it is requesting a certificate on behalf of another
>> entity -- and all I want to ensure is that the verification is done
>> *somewhere* in the certification process).  The PKIX document will be
>> modified to explicitly allow this case.
>
>This is fine with me. Now, if it is done *somewhere* and if it is done
>by the RA, this make the use of the protocol optional. 

No, it doesn't.  POP is mandatory for the end entity (the user).  If the
end entity talks to an RA, it is mandatory for the RA.  If the system is
instead configured such that the end entity talks directly to a CA, then
it is mandatory for the CA.  I don't see the word "optional" anywhere in
the previous three sentences.

>So we are back to
>the question already raised : should we mandate the support of the
>protocol to claim conformance with PKIX - even if it is not used. 

But it *is* used.
>
>I agree that the effort is not big. However at the beginning of the
>discussion people might think that this was the only way to do it. We
>would have to be very clear on that topic.
>
>> Once again, having the CA (or the RA) do proof of possession does not
>> preclude doing other checks in the operational protocols (and you have
>> found an example where such practice may be useful). 
>
>It might be useful to say it in the document.

Fair enough.

>> Note, however,
>> that we cannot *rely* on such checks being done in the operational
>> protocols.  There are many protocols in use already which do not do such
>> checks.  For example, most (all?) of the proposed/popular e-mail
>> protocols (PEM, MOSS, S/MIME, PGP, etc.) sign a message and include the
>> certificate in the header (i.e., the scope of the signature does not
>> include the certificate or its serial number).
>
>Now, this is were we still have different views ...
>
>In the same way, operational protocols cannot rely that proof of 
>possession is done by every CA (over the world). 

We're not necessarily talking about *every* CA over the world; we're
talking about the CAs that claim conformance to PKIX (which might be a
slightly smaller set...).

>This is not a reason 
>to ban these CAs. These proposed/popular protocols exhibit some 
>weaknesses that might be exploited ... until they are modified.
> 
>It is possible to design protocols in such a way that ...  
>protocols do not need to rely that proof of possession is effectively 
>done by every CA.

Once you've modified all existing e-mail protocols which might
conceivably be used over the Internet, let me know  :-) 

>> My point here is that you can't say, "Let's not do this in the CA 
>> because it will be done in the operational protocols"; it might 
>> *not* be done in the operational protocols.
>
>This is not exactly what I said. Instead "We cannot anyway trust all CAs
>over the world to have done that verification, so let us obtain
>assurance of proof of possession from the protocol". 

Again, we're not talking about all CAs over the world; we're talking
about PKIX-compliant CAs.  A CA which *claims* to comply with PKIX is
*trusted* to comply with PKIX (if it does not, then once this is
discovered, the CA will suffer the consequences).  If you can't trust
the CA to have done the verification, why can you trust it to have done
any identity checking?  In fact, why trust it to do anything correctly?
Face it, a "trusted entity" is trusted to do it's job properly; it makes
no sense to call a CA a trusted entity and then assume that it might
only do some portion of its job properly...

>This may always be
>done in the operational protocols. Unfortunately, some existing
>protocols do not do it.

As I said, once you modify all these protocols, let me know.  If even
one operational protocol remains anywhere which does not do the POP,
then we'd better make sure it's done during the certification
procedure...

>Now, for a *small* set of CAs, it is possible to rely on the fact that
>every CA is trusted to perform POP. In such a case, which is a very
>special case, then we can rely on the trust placed in the CA rather than
>the provisions of the protocol.

It's not just an arbitrary "small set of CAs" which form a "very special
case"; it's the set of CAs which claim conformance with PKIX (which,
within the PKIX working group, is probably the only set we care
about...).

--------------------------------------
Carlisle Adams
Entrust Technologies
[email-masked]
---------------------------------------

Date: Mon, 17 Mar 1997 11:56:05 -0500
To: [email-masked]
From: "Kevin L. Hawkins" <[email-masked]>
Subject: unsubscribe

unsubscribe

Kevin L. Hawkins, Manager
FedWorld System Office

Phone: 703.321.0024		
Fax:   703.321.0081
email: [email-masked]

Date: Mon, 17 Mar 1997 18:48:30 -0800
From: Denis Pinkas <[email-masked]>
Reply-To: [email-masked]
Organization: Bull
To: Carlisle Adams <[email-masked]>
Cc: "[email-masked]'" <[email-masked]>
Subject: Re: Trust in CAs

Carlisle,

It seems that we are now close to an agreement on one point.

> Some people on this list have requested that the proof of possession be
> done with the RA instead of with the CA.  This is fine to me (after all,
> the RA is a trusted entity -- in particular, it can be trusted by the CA
> to have done POP if it is requesting a certificate on behalf of another
> entity -- and all I want to ensure is that the verification is done
> *somewhere* in the certification process).  The PKIX document will be
> modified to explicitly allow this case.

This is fine with me. Now, if it is done *somewhere* and if it is done
by the RA, this make the use of the protocol optional. So we are back to
the question already raised : should we mandate the support of the
protocol to claim conformance with PKIX - even if it is not used. I
agree that the effort is not big. However at the beginning of the
discussion people might think that this was the only way to do it. We
would have to be very clear on that topic.

> Once again, having the CA (or the RA) do proof of possession does not
> preclude doing other checks in the operational protocols (and you have
> found an example where such practice may be useful). 

It might be useful to say it in the document.

> Note, however,
> that we cannot *rely* on such checks being done in the operational
> protocols.  There are many protocols in use already which do not do such
> checks.  For example, most (all?) of the proposed/popular e-mail
> protocols (PEM, MOSS, S/MIME, PGP, etc.) sign a message and include the
> certificate in the header (i.e., the scope of the signature does not
> include the certificate or its serial number).

Now, this is were we still have different views ...

In the same way, operational protocols cannot rely that proof of 
possession is done by every CA (over the world). This is not a reason 
to ban these CAs. These proposed/popular protocols exhibit some 
weaknesses that might be exploited ... until they are modified.
 
It is possible to design protocols in such a way that ...  
protocols do not need to rely that proof of possession is effectively 
done by every CA.

> My point here is that you can't say, "Let's not do this in the CA 
> because it will be done in the operational protocols"; it might 
> *not* be done in the operational protocols.

This is not exactly what I said. Instead "We cannot anyway trust all CAs
over the world to have done that verification, so let us obtain
assurance of proof of possession from the protocol". This may always be
done in the operational protocols. Unfortunately, some existing
protocols do not do it.

Now, for a *small* set of CAs, it is possible to rely on the fact that
every CA is trusted to perform POP. In such a case, which is a very
special case, then we can rely on the trust placed in the CA rather than
the provisions of the protocol.

Regards,

Denis

-- 

      Denis Pinkas     Bull S.A.         E-mail : [email-masked]
      Rue Jean Jaures  B.P. 68            Phone : 33 - 1 30 80 34 87
      78340 Les Clayes sous Bois. FRANCE   Fax  : 33 - 1 30 80 33 21

Date: Fri, 14 Mar 1997 15:18:41 -0700
To: Stef Hoeben <[email-masked]>, [email-masked]
From: michael myers <[email-masked]>
Subject: Re: SDSI and SPKI

-----=_=_ 21684121-6741704-12276192 _=_=---
Mime-Version: 1.0
Content-Type: text/plain; charset="us-ascii"

Stef--

The subject of an X.509 certificate need not be a person.  You can identify
anything you wish--IP routers, secure mail gateways, directory servers, web
servers and so on.  X.509 accomodates an ample suite of naming conventions
via its alternative name constructs.  It remains a matter of the practices
of your CA, or your own CA operations, to ensure the identity is
unambiguous within a unique domain of interpretation.

Both access control mechanisms you cite could be used.  It needs to be
noted however that use of critical extensions tends to reduce
interoperability with X.509 compliant applications.  Some environments
desire this effect for either security or proprietary reasons.

I'd be wary of implementing your first example.  Here you have an explicit
list of the authorized principals.  Should it become necessary to revoke
the access rights of one or more of those principals, all certificates
containing that list would have to be reissued in order to enforce your
access control policy.  ACLs are more generally implemented external to the
certification process.

Your second example of rule-based mechanisms is a better approach.  It
scales better for large access control partions where ACLs may grow
excessively large.  A number of communities are implementing this scheme.
One caution I would offer is that while it is relatively easy to include
private extensions into certificates, acquiring applications which enforce
the extensions' semantics is a much more difficult problem.

The tricky details of access control management have not until recently
been addressed in a IETF context. There was some work a few years back on
labels, but it never really took hold.  SPKI begins to do so, and ANSI also
makes some gestures with respect Attribute Certificates, but the concept
requires considerably more public debate than it has until now received.

One last point along these lines:  the current draft of X.509 incorporates
syntax and semantics which enable standards-based use of Attribute
Certificates.  The specification is getting baked this week in Geneva.
Thus, X.509 is as well positioned to deal effectively with access control
issues as any other other proposal.

Michael Myers
Principal Engineer
VeriSign, Inc.
<[email-masked], [email-masked]>

At 03:41 PM 3/14/97 +0100, Stef Hoeben wrote:
>On Tue, 11 Mar 1997, Peter Williams wrote:
> 
>> The models presented in SDSI and SPKI are fine,
>> and very classical. Swapping one syntax format for another
>> adds nothing to models or the right 
>> thing for the internet space. PKIX software is as happy to operate
>> a SDSI-policy as a MISSI-policy, or a SET policy; it is a
>> function of the issuing and management practices of the CA(s) -
>> then banks, the NSIs, or govt agencies, or individuals.
>
>
>Thanks a lot for your answers, but I still wonder:
> 
>If someone wants to use a X.509 certificat to define a group of 
>public keys (whose owners, for example, have acces to a server),
>should he then do the following?
>* create a private extension in the certifcate that gives a list
>  of the public keys (or the ID's, ...)
>* create a critical private extension, saying that the certificate
>  can only be used to give the defined group acces to that server
>
>I'm not sure this is the right place to ask this, but almost everyone
>else says X.509 can only be used to bind a person to a public key.
>
>		Greetings, Stef

-----=_=_ 21684121-6741704-12276192 _=_=---
Content-Type: application/x-pkcs7-signature; name="smime.p7s"
Content-Transfer-Encoding: base64
Content-Disposition: attachment; filename="smime.p7s"

-----=_=_ 21684121-6741704-12276192 _=_=-----

Date: Fri, 14 Mar 1997 13:46:26 -0600 (CST)
From: "Brian M. Thomas" <[email-masked]>
To: [email-masked], [email-masked]
Subject: Re: SDSI and SPKI
Cc: [email-masked]

> 
> For the remote administration case, you could distribute ACLs to
> multiple servers, signed using any secure message/document format (PGP,
> PEM, S/MIME, S-HTTP, etc).  Each server would have to store the
> administrator's public key securely, as above, in order to verify
> ACL messages.

I like this, David.  The point I've been trying to make to our internal
developers is this:  Assume the hardest, most general, case, and when
you assemble a system, simplifying assumptions can make life easier.
If you rely on simplifying assumptions to begin with, life will get
harder.  When we're in a distributed mode such as this Internet thing
is, which is the whole reason the IETF cares about certificates, we
must assume remote administration.  Remote administration disciplines
will work where they are not strictly required; local assumptions will
break when they are extended outside the 'safe' perimeters.

> Or, as you suggest, it would be technically possible to define a
> private X.509 extension just for the purpose of holding an ACL.
> But there doesn't seem to be any reason to go to all that trouble.
> Is there some reason secure email does not address the scenario
> you had in mind?
> 

I have to agree here.  It would be a bad use of a structure designed
for something else.  As Steve said, use the cert to bind the (one) key
to a privilege, as in SPKI, and you've got an atomized ACL entry,
a.k.a.  capability.  As most know, I'm very much in favor of that,
having designed and built a PKI which did that, but didn't use X.509
for them, and didn't call them certificates.  My enthusiasm for SPKI
derives from my pain at not having had a simple and standard means of
dealing with those credentials, not because X.509 is some evil being
forced on us by ITU world-government apparatchiks.  Again, the idea is,
assume nothing, and proceed from the general to the specific, which
means don't start with the assumption that the only attribute to be
bound to a key is a name, even though a name-to-key binding is a
vitally useful thing; recognize that more general mechanisms always
offer more reusability.

I'd also like to apologize for hopping onto a really inappropriate
topic, but I've really been looking for an opportunity to applaud, and
hopefully contribute toward, what I find a very encouraging trend
toward consensus and clarity among the different groups working the PKI
issues.

brian

Brian Thomas, CISSP - Distributed Systems Architect  [email-masked]
Southwestern Bell                                    [email-masked]
One Bell Center,  Room 34G3                          Tel: 314 235 3141
St. Louis, MO 63101                                  Fax: 314 235 0162

Date: Fri, 14 Mar 1997 11:39:54 -0800
To: Stef Hoeben <[email-masked]>, [email-masked]
From: Peter Williams <[email-masked]>
Subject: Re: SDSI and SPKI

Ill probably get shouted at for mentioning active R&D topics
on a maturing standards list, but:

Without violating X.509, or the PKIX-1 profile, one can
indeed use the SDSI scheme to express groups, particularly
useful in IGMP/IPSEC contexts where traditional Orange book
security design rules break down. The statement of the group is neither a
capability, nor an introduction to an acl; the id of the issuer
represents the set of certified entities through introduction; its
a very Japanese authorization and authority model - a cross between
PGP and PEM's delegation of authority/conveynace of assurance level
model

In SDSI the fact that principals are CAs when (re)issuing certs,
with I&A assurances represented by the domain's TLCA, means one has the 
high degree of granularity of group definition one requires, without
getting hungup on name matters, or who is authorized to emit
what reliable statement, or authorization theories. The issuer of
the certs defines the group intrinsically.

I like SDSI; it gets back to basics, and stays away from dogma.

Best treat any other discussion offline, so PKIX-1 stays
on course for IESG ratification and publication.

At 03:41 PM 3/14/97 +0100, Stef Hoeben wrote:
>On Tue, 11 Mar 1997, Peter Williams wrote:
> 
>> The models presented in SDSI and SPKI are fine,
>> and very classical. Swapping one syntax format for another
>> adds nothing to models or the right 
>> thing for the internet space. PKIX software is as happy to operate
>> a SDSI-policy as a MISSI-policy, or a SET policy; it is a
>> function of the issuing and management practices of the CA(s) -
>> then banks, the NSIs, or govt agencies, or individuals.
>
>
>Thanks a lot for your answers, but I still wonder:
> 
>If someone wants to use a X.509 certificat to define a group of 
>public keys (whose owners, for example, have acces to a server),
>should he then do the following?
>* create a private extension in the certifcate that gives a list
>  of the public keys (or the ID's, ...)
>* create a critical private extension, saying that the certificate
>  can only be used to give the defined group acces to that server
>
>I'm not sure this is the right place to ask this, but almost everyone
>else says X.509 can only be used to bind a person to a public key.
>
>		Greetings, Stef
>
>
>
>
>

Date: Fri, 14 Mar 1997 11:47:47 -0500
From: [email-masked] (David P. Kemp)
To: [email-masked]
Subject: Re: SDSI and SPKI
Cc: [email-masked]

> From: Stef Hoeben <[email-masked]>
> 
> Thanks a lot for your answers, but I still wonder:
>  
> If someone wants to use a X.509 certificat to define a group of 
> public keys (whose owners, for example, have acces to a server),
> should he then do the following?
> * create a private extension in the certifcate that gives a list
>   of the public keys (or the ID's, ...)
> * create a critical private extension, saying that the certificate
>   can only be used to give the defined group acces to that server
> 
> I'm not sure this is the right place to ask this, but almost everyone
> else says X.509 can only be used to bind a person to a public key.
> 
> 		Greetings, Stef

Why do you want the server's Access Control List to be in the form
of a certificate (X.509, SPKI, or any other form)?

In the most straightforward case, the ACL (a list of users' public keys
or IDs), is just stored in a file on the server, protected by the same
filesystem mechanisms as the rest of the system's configuration files,
scripts, and executables.   If you're paranoid, you verify that the
system files haven't been modified by using a checksum tool such as
tripwire.

For the remote administration case, you could distribute ACLs to
multiple servers, signed using any secure message/document format (PGP,
PEM, S/MIME, S-HTTP, etc).  Each server would have to store the
administrator's public key securely, as above, in order to verify
ACL messages.

Or, as you suggest, it would be technically possible to define a
private X.509 extension just for the purpose of holding an ACL.
But there doesn't seem to be any reason to go to all that trouble.
Is there some reason secure email does not address the scenario
you had in mind?

Date: Fri, 14 Mar 1997 10:40:18 -0500
To: Stef Hoeben <[email-masked]>
From: Stephen Kent <[email-masked]>
Subject: Re: SDSI and SPKI
Cc: [email-masked]

Stef,

	X.509 (v3) and PKIX Part 1 provide for exactly one key per
certificate, and this is intentional.  Earlier drafts of the standard
included provision for multiple keys and this feature was removed.

	Your question seems to already presume a small set of ways to solve
a problem, but does not state the fundamental problem being solved.  It
might help to step back and restate the problem, and then ask for
suggestions on how to address the problem in the context of X.509
certificate formats.

	For example, one could imagine putting authorization data in a cert
as an extension, and having a server pay atention to that data, based on a
defined set of CAs who are authorized to assert this authorization data.
That transforms the certificates into capabilities, as opposed to using the
ID binding (that is intrinsic to a cert) as an input to an ACL.  In both
cases, the goal is access control and the choices are among the two
traditional approaches: ACLs and capabilities.  However, absent a more
thorough description of the problem being addressed, I cannot tell if this
approach is appropriate.

Steve

Organization: ESAT, K.U.Leuven, Belgium
Date: Fri, 14 Mar 1997 15:41:50 +0100 (MET)
From: Stef Hoeben <[email-masked]>
Reply-To: Stef Hoeben <[email-masked]>
To: [email-masked]
Subject: Re: SDSI and SPKI

On Tue, 11 Mar 1997, Peter Williams wrote:
 
> The models presented in SDSI and SPKI are fine,
> and very classical. Swapping one syntax format for another
> adds nothing to models or the right 
> thing for the internet space. PKIX software is as happy to operate
> a SDSI-policy as a MISSI-policy, or a SET policy; it is a
> function of the issuing and management practices of the CA(s) -
> then banks, the NSIs, or govt agencies, or individuals.

Thanks a lot for your answers, but I still wonder:
 
If someone wants to use a X.509 certificat to define a group of 
public keys (whose owners, for example, have acces to a server),
should he then do the following?
* create a private extension in the certifcate that gives a list
  of the public keys (or the ID's, ...)
* create a critical private extension, saying that the certificate
  can only be used to give the defined group acces to that server

I'm not sure this is the right place to ask this, but almost everyone
else says X.509 can only be used to bind a person to a public key.

		Greetings, Stef

From: Carlisle Adams <[email-masked]>
To: "[email-masked]'" <[email-masked]>
Cc: "[email-masked]'" <[email-masked]>
Subject: RE: Trust in CAs
Date: Wed, 12 Mar 1997 11:29:55 -0500
Encoding: 86 TEXT

Hi Denis,

>----------
>From: 	[email-masked][SMTP:[email-masked]]
>Sent: 	Tuesday, March 11, 1997 7:13 PM
>To: 	[email-masked]
>Subject: 	Trust in CAs
>
>Trust in CAs
>
>The thread about private key possession has illustrated that people 
>have placed different trust assumptions about CAs.
>
>     1) Some people trust CAs to only issue certificates, when they 
>        have verified private key possession and then make the 
>        assumption that a CA can always be trusted to have done that 
>        verification, while ...
>
>     2) Some other people do not make the assumption that a CA can 
>        always be trusted to garantee that the private key 
>        corresponding to the public key value and algorithm placed 
>        in the certificate is really in possession of the entity 
>        nominated in the certificate, and thus rely on appropriate 
>        techniques (i.e. obtain a proof from the user) instead of 
>        making this assumption.
>
>From the above, some people might think that the *single* verification 
>that needs to be made by a CA before issuing a certificate is to verify 
>the private key possession from the requesting entity. The question is 
>whether private key possession verification by the CA is sufficient ?

Actually Denis, as I have repeatedly said to a number of people
(including this list), this is not the question at all.  "Sufficiency"
has nothing whatsoever to do with this argument.  Having a CA verify
private key possession may or may not be sufficient to prevent certain
attacks, but ultimately this makes no difference.  The argument revolves
around what a CA is and what a certificate is.

You have already agreed that a certificate is a binding between an
entity and its private key.  A CA, by creating this certificate, makes
an assertion of this binding.  A CA which publicly (and, in many cases,
legally) makes such an assertion without checking to see that the
binding actually exists is, for all intents and purposes, engaging in
malpractice.  [It is using its authority to state something as true
which it doesn't actually *know* to be true.]

Now, it is possible that there already exist CAs in operation which do
not do this verification (who knows?).  However, if we have the
opportunity to define a standard for the Internet, then why not do
things properly?  Making this verification step optional essentially
makes the statement that for the PKI we're defining/building, such
malpractice is acceptable behaviour.  Is this really what we want?  I
can't see why...  Particularly for the case of signing key pairs, the
verification need involve no extra messages and requires very little
extra computation -- there's simply no good reason *not* to do it.

Some people on this list have requested that the proof of possession be
done with the RA instead of with the CA.  This is fine to me (after all,
the RA is a trusted entity -- in particular, it can be trusted by the CA
to have done POP if it is requesting a certificate on behalf of another
entity -- and all I want to ensure is that the verification is done
*somewhere* in the certification process).  The PKIX document will be
modified to explicitly allow this case.

Once again, having the CA (or the RA) do proof of possession does not
preclude doing other checks in the operational protocols (and you have
found an example where such practice may be useful).  Note, however,
that we cannot *rely* on such checks being done in the operational
protocols.  There are many protocols in use already which do not do such
checks.  For example, most (all?) of the proposed/popular e-mail
protocols (PEM, MOSS, S/MIME, PGP, etc.) sign a message and include the
certificate in the header (i.e., the scope of the signature does not
include the certificate or its serial number).  My point here is that
you can't say, "Let's not do this in the CA because it will be done in
the operational protocols"; it might *not* be done in the operational
protocols.

--------------------------------------
Carlisle Adams
Entrust Technologies
[email-masked]
---------------------------------------

>

To: [email-masked]
cc: [email-masked]
Subject: Trust in CAs
Date: Wed, 12 Mar 1997 10:43:45 -0500
From: "Charles W. Gardiner" <[email-masked]>

    With regard to your scenario of March 10 with Alice and Bob, wasn't it more
than a little stupid of Bob to accept Alice's key pair and to get a certificate
for it, knowing that Alice would then be able to sign things in Bob's name?  If
users are going to do dumb things like this, there is little the CA can do about
it.  I would expect that when non-repudiation time came someone would ask both
Alice and Bob how they happened to have the same key.  Possibly the validity
dates would indicate which one was the original source.

    Of course, there is still the (supposedly) very small probability that two
users will have the same public key and that one of them will find out about it.
Depending on who the other owner is, the first finder might have quite a good
time for a while.

Charlie Gardiner

Date: Wed, 12 Mar 1997 08:01:24 +0100 (MEZ)
From: Ralf Schneider <[email-masked]>
To: [email-masked]
Subject: unsubscribe

unsubscribe

Date: Tue, 11 Mar 1997 15:59:32 -0800
To: Stef Hoeben <[email-masked]>, [email-masked]
From: Peter Williams <[email-masked]>
Subject: Re: SDSI and SPKI

At 10:51 AM 3/11/97 +0100, Stef Hoeben wrote:
>Hello,
>
>Have you all ready heard about SDSI and SPKI?

I suspect so. There is lots to reuse from the SDSI material
in the work of specific PKIX CAs and management domains.

 They are
>both alternatives for the X509 certificate structure, and
>there some very interesting ideas in the papers discribing
>them :

The models presented in SDSI and SPKI are fine,
and very classical. Swapping one syntax format for another
adds nothing to models or the right 
thing for the internet space. PKIX software is as happy to operate
a SDSI-policy as a MISSI-policy, or a SET policy; it is a
function of the issuing and management practices of the CA(s) -
then banks, the NSIs, or govt agencies, or individuals.

Discussion of relevant models for internet usage of certiifcates
is always welcome on this list; to ensure the format profile,
and management protocols are indeed policy and practices
independent.

>
>- SPKI (http://www.clark.net/pub/cme/html/cert.html and
>http://www.clark.net/pub/cme/spki.txt) works with
>`generalised certificates' (not only used to bind a public
>key to a person) and says X.509 has little reason to live
>if the X.500 directory won't make it.

X.509 is being used in practice by at least 10,000 internet sites
who pay money for the related authentication services, and an indeterminate
number of www users, with no use made of X.500
directory whatsoever (other than the generic models)

The SET protocol's source distribution also uses X.509 (see Terisa
Systems/VISA/MAstercard distribution of competing technology deployment
practices to Carl's payment service company) with no use of X.500
directories for naming nor for certificate distribution.

Part of the recent success of X.509 in the internet space, 
given it lay on the internet doldrums for years, was its abandonment
of X.500 as mandatory for theory or practice. One can, always
add X.500 back in whenever one wants, of course; as much
or as little as one wants.

>of the certificate (the policy of the CA) must be in the
>certificate, or there must be a pointer to it.

X.509 v3 std extensions enabled this, to satisfy Carl and others. A
careful  browse around those companies/institutions acting as or
setting standards for trusted-third-party CAs seems to show they
do indeed use the facility, providing the means for subscribers/users to
select on policy(s), as they choose.

>
>- SDSI (http://theory.lcs.mit.edu/~rivest/publications.html)
>is also based on multiple certificate per person, every one
>can be a CA, certificates must be on-line checked (so no need
>for a CRL), uses local instead of global namespaces, and there
>are special group certificates to define groups (very useful for
>Access Condition Lists).

X.509 format and the authentication framework model
has no problem with this scheme. SDSI is simply a degenerate
case of the X.500 name and authority distribution model.

>
>Questions :
>
>- What about these nasty things they say about X.509?

People who say nasty things are usually nasty, especially
when they are an anonymous "they".

>- Can't the `private extensions' defined in the X.509 draft
>  not be used to implement some intersting SDSI and SPKI
>  things in X.509? 

yes. Each CA is free to emulate SPKI mechanisms as they see fit,
and use the SDSI model of authentication and authorization
and name/authority distribution.

As Carl Ellison once put it, VeriSign could easily put
its isusing policy into effect and issue PGP keys. Most
of these models and formats are completely interchangeable,
once the technology is policy independent. it ensures formats
are irrelvant. java vm 1.1 defines a std class interface, so one
doesnt need care, in any case.

>- I think it's possible for these certificate structures to
>  cooperate with each other, that this is only the choice
>  of the CA's. I am wrong.

no. you are right.  I remember when VISA/Microsoft launched the
STT certificate format; none really cared. Once the format
wars were identified as futile, they used X.509 like
the rest of the trusted-third-party software industry, understanding
that one can impose the payment model of key management on X.509 if
one wishes, just as one can use the SDSI model, or
any other.
 
I dont believe Rivest or Lampson are really that hung up
about the format, so long as they can ensure the format
gets used by real software (e.g. java, SET, SSL, internic,
S.MIME) and can convey the information they desire
and be used in the model & culture they designed.

java, SET, SSL, MISSI have all proven for their very different
policies on X.509 usage that there is no one
(hated, wrong, impudent) way for X.509 usage. Each CA
community does whatever its designers decide,
policy-wise. Over time these will settle down
to just a few.

I know for one, I embrace SDSI's models!

 
>
>			Greetings, Stef

To: Stef Hoeben <[email-masked]>
cc: [email-masked]
Subject: Re: SDSI and SPKI 
Reply-To: [email-masked]
Date: Tue, 11 Mar 1997 12:23:25 -0500
From: "Perry E. Metzger" <[email-masked]>

Stef Hoeben writes:
> Have you allready heard about SDSI and SPKI? They are
> both alternatives for the X509 certificate structure, and
> there some very interesting ideas in the papers discribing
> them :

I'm sure many people here have heard of them.

The PKIX folks are standardizing an X.509 profile for the Internet --
that is more or less the reason for their working group's existance,
so the PKIX group isn't really an appropriate forum for the discussion
of alternate technologies.

The SPKI working group, on the other hand, exists specifically to
discuss SPKI/SDSI type things. If you have an interest in exploring
these ideas, that is probably the right place to do it.

Perry

Date: Tue, 11 Mar 1997 16:13:46 -0800
From: Denis Pinkas <[email-masked]>
Reply-To: [email-masked]
Organization: Bull
To: [email-masked]
Subject: Trust in CAs

Trust in CAs

The thread about private key possession has illustrated that people 
have placed different trust assumptions about CAs.

     1) Some people trust CAs to only issue certificates, when they 
        have verified private key possession and then make the 
        assumption that a CA can always be trusted to have done that 
        verification, while ...

     2) Some other people do not make the assumption that a CA can 
        always be trusted to garantee that the private key 
        corresponding to the public key value and algorithm placed 
        in the certificate is really in possession of the entity 
        nominated in the certificate, and thus rely on appropriate 
        techniques (i.e. obtain a proof from the user) instead of 
        making this assumption.

>From the above, some people might think that the *single* verification 
that needs to be made by a CA before issuing a certificate is to verify 
the private key possession from the requesting entity. The question is 
whether private key possession verification by the CA is sufficient ?

Let us look at the following example. Alice generates a key pair 
locally and asks for a certificate. At this time she proves possession 
of the private key to a CA and gets back her certificate. Alice signs a 
messsage without including in it an identifier of her certificate (this 
is not needed for people making the assumption 1) as indicated above). 
A few days later, she would like to repudiate that signed message and 
thus asks a good friend of her, Bob, to ask for a certificate from the 
same CA and provides him with her key pair. At this time the CA does 
its normal check, i.e. verifies that the private key is usable by Bob, 
and issues him a certificate which contains the same public key value 
and algorithm. Now she can pretend that the message was signed by Bob 
showing Bob's certificate.

This scenario would not also happen if:

a) an identifier of her certificate had been included in the signature,
   or

b) the CA had verified that a certificate for that public key value 
   and algorith had already been issued for Alice (where the name Alice
   is obviously not an alias for Bob).

One way to look at this problem is whether we should enforce the 
following:

Statement 1 - "A CA shall guarantee that it never issues two 
certificates that contains the same public key value and algorithm for 
two different entities. PKIX compliant software shall be able to assume 
that this condition is always met by every CA."

The next question is whether what is valid for one CA, should be 
applicable to multiple CAs:

Statement 2 - "A CA shall guarantee that it never issues a certificate 
that contains the same public key value and algorithm contained in a 
certificate from another CA. PKIX compliant software shall be able to 
assume that this condition is always met by every CA."

The statement 1 could be verified by a CA as it is possible to keep 
track of issued certificates (this could take a few seconds but is 
feasible).

The statement 2 could never been verified if Alice and Bob would try to 
perform their trick using two different CAs.

Now, back to the original first question : is private key possession 
verification by the CA sufficient ?

This is *not* sufficient when the certificate identifier is not 
included within the signed data. We would need the statement 2, which 
cannot be assumed.

This is not *needed* when the certificate identifier is included in the 
signed message. Signature verification can be done unambiguously at the 
time of the verification. At the time of signing Bob would indeed be 
able to masquerade as Alice but has to choose between Alice's identity 
or his own identity. He cannot change this later.

As a consequence, the statement 1 is unnecessary in that case.

What conclusions can we draw from this ?
========================================

In the most general case a PKIX compliant software does not need to 
rely on the assumption that a CA is mandated to verify private key 
possession.

On the other end, it is possible to build systems working with a single 
CA where PKIX compliant software will rely on the assumption that a CA 
is mandated to verify private key possession. Such systems would not be 
scalable, but might be sufficient for some cases.

This means that we can consider two types of CAs:

1) CAs not mandated to verify private key possesion (general case), and
2) CAs mandated to verify private key possesion (specific case),

Denis

-- 

      Denis Pinkas     Bull S.A.         E-mail : [email-masked]
      Rue Jean Jaures  B.P. 68            Phone : 33 - 1 30 80 34 87
      78340 Les Clayes sous Bois. FRANCE   Fax  : 33 - 1 30 80 33 21

Date: Tue, 11 Mar 1997 15:24:12 +0100
From: "Adriano Santoni" <[email-masked]>
To: Stef Hoeben <[email-masked]>
Cc: [email-masked]
Subject: Re: SDSI and SPKI

> Hello, 
>  
> Have you allready heard about SDSI and SPKI? They are both 
> alternatives for the X509 certificate structure, and there some 
> very interesting ideas in the papers discribing them : 

Good questions. I would add: have you examined other "strange" certificates 
like that defined in ISO 11660 (seeminlgy used by SWIFT only), or the french 
ETEBAC, or other weird formats? Are those antiques going to survive in your 
opinion?

Bye,
  Adriano

Organization: ESAT, K.U.Leuven, Belgium
Date: Tue, 11 Mar 1997 10:51:29 +0100 (MET)
From: Stef Hoeben <[email-masked]>
To: [email-masked]
Subject: SDSI and SPKI

Hello,

Have you allready heard about SDSI and SPKI? They are
both alternatives for the X509 certificate structure, and
there some very interesting ideas in the papers discribing
them :

- SPKI (http://www.clark.net/pub/cme/html/cert.html and
http://www.clark.net/pub/cme/spki.txt) works with
`generalised certificates' (not only used to bind a public
key to a person) and says X.509 has little reason to live
if the X.500 directory won't make it. Also, the meaning
of the certificate (the policy of the CA) must be in the
certificate, or there must be a pointer to it.

- SDSI (http://theory.lcs.mit.edu/~rivest/publications.html)
is also based on multiple certificate per person, every one
can be a CA, certificates must be on-line checked (so no need
for a CRL), uses local instead of global namespaces, and there
are special group certificates to define groups (very useful for
Access Condition Lists).

Questions :

- What about these nasty things they say about X.509?
- Can't the `private extensions' defined in the X.509 draft
  not be used to implement some intersting SDSI and SPKI
  things in X.509? 
- I think it's possible for these certificate structures to
  cooperate with each other, that this is only the choice
  of the CA's. I am wrong.

			Greetings, Stef

Date: Wed, 05 Mar 1997 07:56:16 -0700
From: Robert Jueneman <[email-masked]>
To: [email-masked]
Cc: [email-masked]
Subject: Missing PKIX mail

I' ve been wondering why the PKIX group was so quiet recently, until I
met Dennis Pinkas and he asked me about a recent thread.

If this message bounces and anyone knows why, please e-mail m at 
[email-masked], or call me at 801/861-7387.

Bob Jueneman

Date: Mon, 3 Mar 1997 10:48:34 -0500
From: [email-masked] (David P. Kemp)
To: [email-masked]
Subject: Re: Unknown string type (28) and content of private enterprise extensions

>  
> This is the SNMP arc (specifically it's 
> iso.org.dod.internet.private.enterprise (1.3.6.1.4.1)).  This seems to be the 
> best way for any smaller organisation to obtain an OID, even though it's not 
> strictly SNMP-related.

Mea culpa - I shouldn't have been so lazy before posting incomplete info.
Details of the above assignments are (of course) in:

  ftp://ftp.isi.edu/in-notes/iana/assignments/smi-numbers
  ftp://ftp.isi.edu/in-notes/iana/assignments/enterprise-numbers

To: [email-masked]
Subject: unsubscribe
Date: Mon, 03 Mar 1997 08:56:05 +0900
From: "Cadowaki,Osamu" <[email-masked]>

#unsubscribe

From: [email-masked] (Peter Gutmann)
To: [email-masked]
Subject: Re: Unknown string type (28) and content of private enterprise extensions
Sender: [email-masked]
Reply-To: [email-masked]
Date: Sun, 2 Mar 1997 16:39:55 (NZDT)

>>More along these lines .... the Verisign certificates have private
>>enterprise extensions ( { 1 3 6 1 4 1 311 2 1 27}  and  { 1 3 6 1 4 1
>>311 2 1 10}  ). Anybody know the content format of these extensions?
>
>So you can see that {1 3 6 ...} is in the ISO dod arc, but I can't help you 
>from there.  
 
This is the SNMP arc (specifically it's 
iso.org.dod.internet.private.enterprise (1.3.6.1.4.1)).  This seems to be the 
best way for any smaller organisation to obtain an OID, even though it's not 
strictly SNMP-related.
 
Peter.